/* This script generates mock data for local development.
   This way you don't have to point to an actual API,
   but you can enjoy realistic, but randomized data,
   and rapid page loads due to local, static data.
 */
const jsf = require('json-schema-faker');
const {
  projectSchema,
  subProjectSchema
} = require('./mockDataSchema');
const fs = require('fs');
const chalk = require('chalk');

const projectjson = jsf(projectSchema);
const subprojectjson = jsf(subProjectSchema);

const data = Object.assign({}, projectjson, subprojectjson);

fs.writeFile("./src/assets/projects/projects.json", JSON.stringify(data), function (err) {
  if (err) {
    return console.log(chalk.red(err));
  } else {
    console.log(chalk.green("Mock data generated for projects and subprojects"));
  }
});
