import { AppStorageService } from './service/common/app-storage.service';
import { WindowRefService } from './service/common/window.ref.service';
import { CommonService } from './service/common/common.service';
import { SharedService } from './service/common/shared.service';
import { OnInit } from '@angular/core';
import { Http } from '@angular/http';
import { Location } from '@angular/common';
import { TranslateService } from '@ngx-translate/core';
import { SessionStorageService } from './service/common/session-storage.service';
import { Router, ActivatedRoute } from '@angular/router';
import { AuthService } from './service/common/auth.service';
import { UserService } from './service/common/user.service';
import { ToasterConfig } from 'angular2-toaster';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import 'rxjs/add/operator/skip';
import { NavService, INavItem } from './service/common/nav.service';
import { CrowdinService } from './service/common/crowdin.service';
export declare class AppComponent implements OnInit {
    translate: TranslateService;
    user: UserService;
    auth: AuthService;
    location: Location;
    router: Router;
    http: Http;
    route: ActivatedRoute;
    sessionStorageService: SessionStorageService;
    appStorageService: AppStorageService;
    sharedService: SharedService;
    commonService: CommonService;
    windowRef: WindowRefService;
    activatedRoute: ActivatedRoute;
    navService: NavService;
    crowdinService: CrowdinService;
    private language;
    private langOptions;
    version: string;
    private envName;
    notifyOptions: any;
    showLoader: boolean;
    toasterConfig: ToasterConfig;
    private navToggle;
    showPrivacyDialog: boolean;
    showLegalNotices: boolean;
    eulaReadOnly: boolean;
    navItems: INavItem[];
    currentDate: Date;
    constructor(translate: TranslateService, user: UserService, auth: AuthService, location: Location, router: Router, http: Http, route: ActivatedRoute, sessionStorageService: SessionStorageService, appStorageService: AppStorageService, sharedService: SharedService, commonService: CommonService, windowRef: WindowRefService, activatedRoute: ActivatedRoute, navService: NavService, crowdinService: CrowdinService);
    isSearchRoute(): boolean;
    goToSettings(): void;
    goToPrivacyPolicy(): void;
    goToEndUserAgreement(): void;
    goToLegalNotices(): void;
    goToRoute(navItem: INavItem): void;
    cancelLegal(): void;
    cancelPrivacy(): void;
    cancelEula(): void;
    logout(): void;
    ngOnInit(): void;
    toggleNav(onlyClose?: boolean): void;
    navClass(): string;
}
