import { Observable } from 'rxjs/Observable';
import { HttpClient } from './../common/HttpClient';
import 'rxjs/Rx';
import { Subject } from 'rxjs/Subject';
export declare class MainPageService {
    private _http;
    deleteUniversalConnectorSubject: Subject<any>;
    deleteChannelSubject: Subject<any>;
    deleteCrossSectionSubject: Subject<any>;
    deleteInteractionEquationSubject: Subject<any>;
    deleteSystemSubject: Subject<any>;
    deletePiperingGroupSubject: Subject<any>;
    deletePiperingSubject: Subject<any>;
    deleteDesignBaseSubject: Subject<any>;
    deleteCorosionProtectionSubject: Subject<any>;
    deleteSubcomponentForVerificationSubject: Subject<any>;
    deleteReleaseSubject: Subject<any>;
    deleteVariantVerificationSubject: Subject<any>;
    deleteMaterialSubject: Subject<any>;
    deletePipeFunctionSubject: Subject<any>;
    deletePipeMaterialTypeSubject: Subject<any>;
    deletePipeGroupSubject: Subject<any>;
    deletePipeFasteningGroupSubject: Subject<any>;
    deletePipeMaterialSubject: Subject<any>;
    deletePipeMaterialConditionSubject: Subject<any>;
    deleteInsulationMaterialSubject: Subject<any>;
    deleteInsulationMaterialSizeSubject: Subject<any>;
    deletePipeSubject: Subject<any>;
    deletePipeSizeSubject: Subject<any>;
    sidemenuSubject: Subject<any>;
    deletePiperingBossSubject: Subject<any>;
    deletePiperingBossThreadedRodSubject: Subject<any>;
    deletePipeToPiperingSubject: Subject<any>;
    deleteWorkingPiperingSubject: Subject<any>;
    deletePiperingFamilySubject: Subject<any>;
    constructor(_http: HttpClient);
    sentSTPFileForConnectors(stpFile: any, id: any): Observable<any>;
    sentSTPFileForCrossSections(stpFile: any, id: any): Observable<any>;
    sentSTPFileForChannels(stpFile: any, id: any): Observable<any>;
    sentSTPFileForPipeRings(stpFile: any, id: any): Observable<any>;
    sendPicture(picture: any, id: any): Observable<any>;
    getPicture(pictureId: any): Observable<any>;
    deleteFile(fileId: any): Observable<any>;
    checkTaskStatus(taskId: any): Observable<any>;
    loadAllConnectors(): Observable<any>;
    loadSpecificConnectors(connectorType: any): Observable<any>;
    updateUniversalConnectorInDb(universalConnector: any): Observable<any>;
    addNewUniversalConnectorIntoDb(universalConnector: any): Observable<any>;
    removeUniversalConnector(id: any): Observable<any>;
    loadAllCrossSections(): Observable<any>;
    loadAllThreadedRods(): Observable<any>;
    updateCrossSectionInDb(crossSection: any): Observable<any>;
    addNewCrossSectionIntoDb(crossSection: any): Observable<any>;
    removeCrossSection(id: any): Observable<any>;
    loadAllChannels(): Observable<any>;
    updateChannelInDb(channel: any): Observable<any>;
    addNewChannelIntoDb(channel: any): Observable<any>;
    removeChannel(id: any): Observable<any>;
    loadAllSystems(): Observable<any>;
    updateSystemInDb(system: any): Observable<any>;
    addNewSystemIntoDb(system: any): Observable<any>;
    removeSystem(id: any): Observable<any>;
    loadAllCorosionProtections(): Observable<any>;
    updateCorosionProtectionInDb(corosionProtection: any): Observable<any>;
    addNewCorosionProtectionIntoDb(corosionProtection: any): Observable<any>;
    removeCorosionProtection(id: any): Observable<any>;
    loadAllDesignBases(): Observable<any>;
    updateDesignBaseInDb(designBase: any): Observable<any>;
    addNewDesignBaseIntoDb(designBase: any): Observable<any>;
    removeDesignBase(id: any): Observable<any>;
    loadAllSubcomponentsForVerification(): Observable<any>;
    updateSubcomponentForVerificationInDb(subcomponentForVerification: any): Observable<any>;
    addNewSubcomponentForVerificationIntoDb(subcomponentForVerification: any): Observable<any>;
    removeSubcomponentForVerification(id: any): Observable<any>;
    loadAllInteracionEquations(): Observable<any>;
    updateInteractionEquationInDb(interactionEquation: any): Observable<any>;
    addNewInteracionEquationIntoDb(interactionEquation: any): Observable<any>;
    removeInteracionEquation(id: any): Observable<any>;
    loadAllReleases(): Observable<any>;
    updateReleaseInDb(release: any): Observable<any>;
    addNewReleaseIntoDb(release: any): Observable<any>;
    removeRelease(id: any): Observable<any>;
    addNewConnectorVariantIntoDb(variant: any): Observable<any>;
    loadAllConnectorVariants(id: any): Observable<any>;
    removeVariant(id: any): Observable<any>;
    updateVariantInDb(variant: any): Observable<any>;
    addNewVariantVerificationIntoDb(variantVerification: any): Observable<any>;
    loadVariantVerifications(variantId: any, designBaseId: any): Observable<any>;
    removeVariantVerification(id: any): Observable<any>;
    updateVariantVerificationInDb(variantVerification: any): Observable<any>;
    duplicateVariantData(oldVariantId: any, newVariantId: any): Observable<any>;
    addNewMaterialIntoDb(material: any): Observable<any>;
    loadAllMaterials(): Observable<any>;
    removeMaterial(id: any): Observable<any>;
    updateMaterialInDb(material: any): Observable<any>;
    addNewPiperingGroupIntoDb(piperingGroup: any): Observable<any>;
    loadAllPiperingGroups(): Observable<any>;
    removePiperingGroup(id: any): Observable<any>;
    updatePiperingGroupInDb(piperingGroup: any): Observable<any>;
    addNewPiperingIntoDb(pipering: any): Observable<any>;
    loadAllPiperings(): Observable<any>;
    getSpecificPipering(id: any): Observable<any>;
    removePipering(id: any): Observable<any>;
    updatePiperingInDb(pipering: any): Observable<any>;
    addNewPiperingVariantIntoDb(piperingVariant: any): Observable<any>;
    loadAllPiperingVariants(id: any): Observable<any>;
    removePiperingVariant(id: any): Observable<any>;
    updatePiperingVariantInDb(piperingVariant: any): Observable<any>;
    postPiperingVariantConfiguration(variantConfig: any): Observable<any>;
    getPiperingVariantConfigurationData(id: any): Observable<any>;
    addNewPipeFunctionIntoDb(pipeFunction: any): Observable<any>;
    loadAllPipeFunctions(): Observable<any>;
    removePipeFunction(id: any): Observable<any>;
    updatePipeFunctionInDb(pipeFunction: any): Observable<any>;
    addNewPipeMaterialTypeIntoDb(pipeMaterialType: any): Observable<any>;
    loadAllPipeMaterialTypes(): Observable<any>;
    removePipeMaterialType(id: any): Observable<any>;
    updatePipeMaterialTypeInDb(pipeMaterialType: any): Observable<any>;
    addNewPipeGroupIntoDb(pipeGroup: any): Observable<any>;
    loadAllPipeGroups(): Observable<any>;
    removePipeGroup(id: any): Observable<any>;
    updatePipeGroupInDb(pipeGroup: any): Observable<any>;
    addNewPipeFasteningGroupIntoDb(pipeFasteningGroup: any): Observable<any>;
    loadAllPipeFasteningGroups(): Observable<any>;
    removePipeFasteningGroup(id: any): Observable<any>;
    updatePipeFasteningGroupInDb(pipeFasteningGroup: any): Observable<any>;
    addNewPipeMaterialIntoDb(pipeMaterial: any): Observable<any>;
    loadAllPipeMaterials(): Observable<any>;
    removePipeMaterial(id: any): Observable<any>;
    updatePipeMaterialInDb(pipeMaterial: any): Observable<any>;
    addNewPipeMaterialConditionIntoDb(pipeMaterialCondition: any): Observable<any>;
    loadPipeMaterialConditions(pipeMaterialId: any): Observable<any>;
    removePipeMaterialCondition(id: any): Observable<any>;
    updatePipeMaterialConditionInDb(pipeMaterialCondition: any): Observable<any>;
    addNewInsulationMaterialIntoDb(insulationMaterial: any): Observable<any>;
    loadAllInsulationMaterials(): Observable<any>;
    removeInsulationMaterial(id: any): Observable<any>;
    updateInsulationMaterialInDb(insulationMaterial: any): Observable<any>;
    addNewInsulationMaterialSizeIntoDb(insulationMaterialSize: any): Observable<any>;
    loadInsulationMaterialSizes(insulationMaterialId: any): Observable<any>;
    removeInsulationMaterialSize(id: any): Observable<any>;
    updateInsulationMaterialSizeInDb(insulationMaterialSize: any): Observable<any>;
    addNewPipeIntoDb(pipe: any): Observable<any>;
    loadAllPipes(): Observable<any>;
    removePipe(id: any): Observable<any>;
    updatePipeInDb(pipe: any): Observable<any>;
    addNewPipeSizeIntoDb(pipeSize: any): Observable<any>;
    loadPipeSizes(pipeId: any): Observable<any>;
    removePipeSize(id: any): Observable<any>;
    updatePipeSizeInDb(pipeSize: any): Observable<any>;
    addNewPiperingBossIntoDb(piperingBoss: any): Observable<any>;
    loadAllPiperingBosses(): Observable<any>;
    removePiperingBoss(id: any): Observable<any>;
    updatePiperingBossInDb(piperingBoss: any): Observable<any>;
    addNewPiperingBossThreadedRodIntoDb(piperingBossThreadedRod: any): Observable<any>;
    loadPiperingBossThreadedRods(id: any): Observable<any>;
    removePiperingBossThreadedRod(id: any): Observable<any>;
    updatePiperingBossThreadedRodInDb(piperingBossThreadedRod: any): Observable<any>;
    addNewPipeToPiperingIntoDb(pipeToPipering: any): Observable<any>;
    loadAllPipeToPiperings(): Observable<any>;
    removePipeToPipering(id: any): Observable<any>;
    updatePipeToPiperingInDb(pipeToPipering: any): Observable<any>;
    addNewWorkingPiperingIntoDb(workingPipering: any): Observable<any>;
    loadWorkingPiperings(id: any): Observable<any>;
    removeWorkingPipering(id: any): Observable<any>;
    updateWorkingPiperingInDb(workingPipering: any): Observable<any>;
    addNewPiperingFamilyIntoDb(piperingFamily: any): Observable<any>;
    loadAllPiperingFamilies(): Observable<any>;
    removePiperingFamily(id: any): Observable<any>;
    updatePiperingFamilyInDb(piperingFamily: any): Observable<any>;
    getConnectorTypeArray(): any[];
    getPipeRingGraphicalRepresentationsArray(): any[];
}
