import { OnInit, EventEmitter, NgZone } from '@angular/core';
import { MainPageService } from './../../../main-page.service';
import { ConnectorVariantModel } from '../../../../models/parts/connectorVariant.model';
import { FormGroup } from '@angular/forms';
import { SystemModel } from '../../../../models/dictionaries/system.model';
import { ShowViewerArgs } from '../../../../models/viewer/ShowViewerArgs.model';
import { CorosiveProtectionModel } from '../../../../models/dictionaries/corosive-protection.model';
import { UniversalConnectorModel } from '../../../../models/parts/universal-connector.model';
import { DesignBaseModel } from '../../../../models/dictionaries/design-base.model';
export declare class BasesManagmentComponent implements OnInit {
    private mainPageService;
    private zone;
    fileInput: any;
    onShowViewer: EventEmitter<ShowViewerArgs>;
    baseData: any;
    editedBase: UniversalConnectorModel;
    editedVariant: ConnectorVariantModel;
    variantTemplateModel: ConnectorVariantModel;
    showPicture: boolean;
    canOpenGraphicalTool: boolean;
    private stpConvertTaskId;
    currentVariantTabId: string;
    currentVariantTab: number;
    isStpVisible: boolean;
    isPngVisible: boolean;
    pictureData: string;
    systemsArray: SystemModel[];
    corrosionProtectionsArray: CorosiveProtectionModel[];
    designBasesArray: DesignBaseModel[];
    choosenDesignBase: string;
    private duplicateMode;
    formGroup: FormGroup;
    variantFormGroup: FormGroup;
    mockList: any[];
    mockedPictureBase64: string;
    mockedStepFileBase64: string;
    variantGridData: any[];
    headersVariantGrid: string[];
    displayedColumns: string[];
    variantsList: ConnectorVariantModel[];
    constructor(mainPageService: MainPageService, zone: NgZone);
    ngOnInit(): void;
    loadData(): void;
    loadBaseVariants(): void;
    showBase(sender: any): void;
    upload(): void;
    readThis(inputFile: any): void;
    checkIfStpIsConverted(): void;
    sendSTPFile(file: any, id: any): void;
    sendPictureFile(picture: any, id: any): void;
    openGraphicalTool(): void;
    openVariantGraphicalTool(variantId: any): void;
    save(): void;
    changeVariantTab(id: any): void;
    deletePicture(): void;
    deleteStepFile(): void;
    setFilesData(connector: any): void;
    deleteBase(): void;
    saveNewVariant(): void;
    sendVariantToDb(variant: any): void;
    duplicateVariant(): void;
    deleteVariant(): void;
    updateVariant(): void;
    private createForm();
    prepareVariantCreate(): void;
    private createVariantForm();
}
