import { OnInit, EventEmitter, NgZone } from '@angular/core';
import { MainPageService } from './../../../main-page.service';
import { ChannelModel } from '../../../../models/parts/channel.model';
import { CrossSectionModel } from '../../../../models/parts/cross-section.model';
import { SystemModel } from '../../../../models/dictionaries/system.model';
import { CorosiveProtectionModel } from '../../../../models/dictionaries/corosive-protection.model';
import { MaterialModel } from '../../../../models/dictionaries/material.model';
import { FormGroup } from '@angular/forms';
export declare class ChannelsManagmentComponent implements OnInit {
    private mainPageService;
    private zone;
    fileInput: any;
    onShowViewer: EventEmitter<boolean>;
    selectedConnectorId: EventEmitter<number>;
    channelData: any;
    editedChannel: ChannelModel;
    showPicture: boolean;
    canOpenGraphicalTool: boolean;
    private stpConvertTaskId;
    mockedStepFileBase64: string;
    isStpVisible: boolean;
    isPngVisible: boolean;
    pictureData: string;
    allCrossSectionsArray: CrossSectionModel[];
    availableCrossSectionsArray: CrossSectionModel[];
    systemsArray: SystemModel[];
    corrosionProtectionsArray: CorosiveProtectionModel[];
    materialsArray: MaterialModel[];
    formGroup: FormGroup;
    constructor(mainPageService: MainPageService, zone: NgZone);
    ngOnInit(): void;
    loadData(): void;
    showChannel(sender: any): void;
    upload(): void;
    readThis(inputFile: any): void;
    checkIfStpIsConverted(): void;
    sendSTPFile(file: any, id: any): void;
    openGraphicalTool(): void;
    save(): void;
    deleteStepFile(): void;
    setFilesData(channel: any): void;
    deleteChannel(): void;
    private createForm();
    filterCrossSections(): void;
}
