import { OnInit, EventEmitter, NgZone } from '@angular/core';
import { MainPageService } from './../../../main-page.service';
import { CrossSectionModel } from '../../../../models/parts/cross-section.model';
import { SystemModel } from '../../../../models/dictionaries/system.model';
import { ShowViewerArgs } from '../../../../models/viewer/ShowViewerArgs.model';
import { FormGroup } from '@angular/forms';
export declare class CrossSectionManagmentComponent implements OnInit {
    private mainPageService;
    private zone;
    fileInput: any;
    onShowViewer: EventEmitter<ShowViewerArgs>;
    crossSectionData: any;
    editedCrossSection: CrossSectionModel;
    showPicture: boolean;
    canOpenGraphicalTool: boolean;
    private stpConvertTaskId;
    mockedPictureBase64: string;
    mockedStepFileBase64: string;
    isStpVisible: boolean;
    isPngVisible: boolean;
    pictureData: string;
    systemsArray: SystemModel[];
    formGroup: FormGroup;
    constructor(mainPageService: MainPageService, zone: NgZone);
    ngOnInit(): void;
    loadData(): void;
    showCrossSection(sender: any): void;
    upload(): void;
    readThis(inputFile: any): void;
    checkIfStpIsConverted(): void;
    sendSTPFile(file: any, id: any): void;
    sendPictureFile(picture: any, id: any): void;
    openGraphicalTool(): void;
    save(): void;
    deletePicture(): void;
    deleteStepFile(): void;
    setFilesData(crossSection: any): void;
    deleteCrossSection(): void;
    private createForm();
}
