import { OnInit, EventEmitter, NgZone } from '@angular/core';
import { MainPageService } from './../../../main-page.service';
import { ShowViewerArgs } from '../../../../models/viewer/ShowViewerArgs.model';
import { FormGroup } from '@angular/forms';
import { PipeRingModel } from '../../../../models/parts/pipering.model.';
import { PiperingGroupModel } from '../../../../models/dictionaries/pipering-group.model';
import { CorosiveProtectionModel } from '../../../../models/dictionaries/corosive-protection.model';
import { PipeRingVariantModel } from '../../../../models/parts/pipering-variant.model';
import { DesignBaseModel } from '../../../../models/dictionaries/design-base.model';
export declare class PipeRingsManagmentComponent implements OnInit {
    private mainPageService;
    private zone;
    fileInput: any;
    onShowViewer: EventEmitter<ShowViewerArgs>;
    pipeRingData: any;
    editedPipeRing: PipeRingModel;
    editedPipeRingVariant: PipeRingVariantModel;
    showPicture: boolean;
    canOpenGraphicalTool: boolean;
    private stpConvertTaskId;
    isStpVisible: boolean;
    isPngVisible: boolean;
    currentVariantTabId: string;
    currentVariantTab: number;
    pictureData: string;
    formGroup: FormGroup;
    variantFormGroup: FormGroup;
    private duplicateMode;
    choosenDesignBase: string;
    piperingGroupsData: PiperingGroupModel[];
    corrosionProtectionData: CorosiveProtectionModel[];
    variantsList: PipeRingVariantModel[];
    designBasesArray: DesignBaseModel[];
    piperingFamiliesArray: any[];
    constructor(mainPageService: MainPageService, zone: NgZone);
    ngOnInit(): void;
    loadData(): void;
    loadPiperingVariants(): void;
    showPipeRing(sender: any): void;
    upload(): void;
    readThis(inputFile: any): void;
    checkIfStpIsConverted(): void;
    sendSTPFile(file: any, id: any): void;
    sendPictureFile(picture: any, id: any): void;
    openGraphicalTool(): void;
    openVariantGraphicalTool(variantId: any): void;
    changeVariantTab(id: any): void;
    save(): void;
    deletePicture(): void;
    deleteStepFile(): void;
    setFilesData(pipering: any): void;
    deletePipeRing(): void;
    prepareVariantCreate(): void;
    private createVariantForm();
    private createForm();
    saveNewVariant(): void;
    sendVariantToDb(variant: any): void;
    duplicateVariant(): void;
    deleteVariant(): void;
    updateVariant(): void;
    prepareVariantEdit(): void;
}
