import { OnInit } from '@angular/core';
import { MainPageService } from './../../../main-page.service';
import { Subject } from 'rxjs';
import { FormBuilder, FormGroup } from '@angular/forms';
import { PipeGroupModel } from '../../../../models/dictionaries/pipe-group.model';
import { PipeSizeModel } from '../../../../models/parts/pipe-size.model';
import { PipeMaterialGroupModel } from '../../../../models/dictionaries/pipe-material-group.model';
export declare class PipesManagmentComponent implements OnInit {
    private mainPageService;
    private formBuilder;
    pipeData: any;
    isPipeNew: boolean;
    stateSubject: Subject<any>;
    pipeSizesGridData: PipeSizeModel[];
    pipeSizesGridDisplayData: PipeSizeModel[];
    editedSizeData: PipeSizeModel;
    canAddRowToSizeGrid: boolean;
    private sizesOpenedGridRows;
    isSizesGridInChangeMode: boolean;
    currentOpenRow: number;
    formGroup: FormGroup;
    rowNumber: number;
    private removeData;
    pipeGroupsData: PipeGroupModel[];
    pipeMaterialGroupsData: PipeMaterialGroupModel[];
    private unitsConverter;
    constructor(mainPageService: MainPageService, formBuilder: FormBuilder);
    ngOnInit(): void;
    loadData(): void;
    showManagmentPage(sender: any, isNew: any): void;
    save(): void;
    returnHandler(): void;
    editHandlerForSizeData({sender, rowIndex}: {
        sender: any;
        rowIndex: any;
    }): void;
    cancelHandlerForSizeData({sender, rowIndex}: {
        sender: any;
        rowIndex: any;
    }): void;
    saveHandlerForSizeData({sender, formGroup, rowIndex}: {
        sender: any;
        formGroup: any;
        rowIndex: any;
    }): void;
    addHandlerForSizeData({sender}: {
        sender: any;
    }): void;
    removeHandler({dataItem}: {
        dataItem: any;
    }): void;
    createFormGroupForSizeData(dataItem: any): FormGroup;
    private changeDisplayedUnits();
    overwriteDataInGrid(rowIndex: any, formGroup: any): void;
    saveNewSize(): void;
    saveEditedSizes(): void;
    removeSize(): void;
    deletePipeSize(size: any): void;
}
