import { InjectionToken } from '@angular/core';
import { RequestOptionsArgs, Response } from '@angular/http';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/observable/of';
import 'rxjs/add/observable/throw';
import { ErrorObservable } from 'rxjs/Observable/ErrorObservable.js';
import { CacheService } from 'ng2-cache';
import { HttpClient } from '../../common/HttpClient';
export declare let API_URL: InjectionToken<string>;
export declare let IMAGE_URL: InjectionToken<string>;
export declare class HelpersService {
    private api_url;
    private imageUrl;
    private http;
    private cacheService;
    constructor(api_url: string, imageUrl: string, http: HttpClient, cacheService: CacheService);
    createRequestOptionsArgs(params?: any): RequestOptionsArgs;
    getApiPath(endpoint: any, segment?: string): Observable<string>;
    getApiPathForTypicals(endpoint: any): string;
    getImageUrl(): string;
    handleHttpError(error: Response | any): ErrorObservable;
    composeCacheKey(url: any, method: any, options: any): string;
    cachingGet(url: string, options?: RequestOptionsArgs): Observable<Response>;
}
