import { OnInit, NgZone } from '@angular/core';
import { SubcomponentVerificationModel } from '../../models/dictionaries/subcomponents-verification.model';
import { InteractionEquationModel } from '../../models/dictionaries/interaction-equation.model';
import { MainPageService } from '../../main-page/main-page.service';
import { Router } from '@angular/router';
import { VariantVerificationModel } from '../../models/parts/variant-verification.model';
import { GridDataResult } from '@progress/kendo-angular-grid';
import { FormGroup, FormBuilder } from '@angular/forms';
export declare class VariantVerificationGridComponent implements OnInit {
    private mainPageService;
    private router;
    private zone;
    private formBuilder;
    private variantId;
    private designBaseId;
    variantsVerificationRawData: VariantVerificationModel[];
    variantsVerificationDisplayData: VariantVerificationModel[];
    verificationData: SubcomponentVerificationModel[];
    methodsData: InteractionEquationModel[];
    formGroup: FormGroup;
    private unitsConverter;
    variantVerificationPageSize: number;
    skipForvariantsVerificationData: number;
    editedVariantVerification: VariantVerificationModel;
    rowNumber: number;
    variantVerificationGridView: GridDataResult;
    private variantVerificationOpenedRows;
    currentOpenRow: number;
    isVariantVerificationGridInChangeMode: boolean;
    canAddRowToVariantVerificationGrid: boolean;
    isVariantVerificationArrayEmpty: any;
    showRemoveDialog: boolean;
    private dataCopy;
    private removeData;
    displayUnitF: string;
    displayUnitM: string;
    VariantId: string;
    DesignBaseId: string;
    constructor(mainPageService: MainPageService, router: Router, zone: NgZone, formBuilder: FormBuilder);
    ngOnInit(): void;
    loadVerificationData(): void;
    loadData(): void;
    saveNewVariantVerification(): void;
    saveEditedVariantVerification(): void;
    deleteVariantVerification(variantVerification: any): void;
    editHandlerForVariantVerificationData({sender, rowIndex, dataItem}: {
        sender: any;
        rowIndex: any;
        dataItem: any;
    }): void;
    cancelHandlerForVariantVerificationData({sender, rowIndex}: {
        sender: any;
        rowIndex: any;
    }): void;
    saveHandlerForVariantVerificationData({sender, formGroup, rowIndex}: {
        sender: any;
        formGroup: any;
        rowIndex: any;
    }): void;
    addHandlerForVariantVerificationData({sender}: {
        sender: any;
    }): void;
    removeHandler({sender, dataItem}: {
        sender: any;
        dataItem: any;
    }): void;
    removeFromVariantVerificationData(): void;
    onUnitChange(unit: any): void;
    private changeDisplayedUnits();
    private changeElementUnitsToSI(index);
    overwriteDataInGrid(rowIndex: any, formGroup: any): void;
    createFormGroupForVariantVerificationData(dataItem: any): FormGroup;
}
