import { AuthService } from './../service/common/auth.service';
import { TranslateService } from '@ngx-translate/core';
import { MainPageService } from './main-page.service';
import { Router } from '@angular/router';
import { Component, OnInit, Input} from '@angular/core';
import { environment } from '../environments/environment';
import { SideMenuComponent } from './side-menu/side-menu.component';
import { ShowViewerArgs } from '../models/viewer/ShowViewerArgs.model';

@Component({
  templateUrl: './main-page.component.html',
  styleUrls: ['./main-page.component.scss']
})
export class MainPageComponent implements OnInit {
  @Input() sideBar: SideMenuComponent;
  public envName: string;
  public isStpViewerVisible = false;
  // public masterDataStateArray = [false, false, false, false, false, false];
  // public dictionariesStateArray = [false, false, false, false, false, false];
  public chooseItem:string;
  public menuTitle:string;
  public showViewerArgs: ShowViewerArgs;
  public hide: boolean;

  constructor(
    private router: Router,
    private auth: AuthService,
    private mainPageService: MainPageService
  ) { }

  public ngOnInit(): void {
    this.envName = environment.envName;
    this.mainPageService.sidemenuSubject.subscribe((value => {
      this.sidemenuChoice(value);
    }))
  };

  public logout(): void {
    this.auth.logout();
    if (this.envName === 'test') {
      this.router.navigate(['/logout']);
    }
  }

  public showViewer(event: ShowViewerArgs) {
    this.showViewerArgs = event;
    this.isStpViewerVisible = event.show;
  }

  sidemenuChoice(value: any) {
    this.chooseItem = value.choiceName;
    this.menuTitle = value.menuTitle;
    }
  }
