import { OnInit, Input, Component, NgZone } from '@angular/core';
import { StpConfigureService } from '../stp-configure.service';
import {ExtensionInterface} from '../../../models/viewer/ExtensionInterface.model'

@Component({
    selector: 'orientation-positioning',
    templateUrl: './orientation-positioning.component.html',
    styleUrls: ['./orientation-positioning.component.scss']
})
export class OrientationPositioningComponent implements OnInit {
    public extensionInterface: ExtensionInterface;
    public position;
    @Input() set ExtensionInterface (value: ExtensionInterface){
        this.extensionInterface = value;
        if (this.extensionInterface !== null) {
                this.extensionInterface.armsTranslationVector.subscribe((vector) => {
                    this.zone.run(() => {
                        this.position = vector;
                    });
                });
        }
    }

    constructor(private stpConfigureService: StpConfigureService, private zone: NgZone) { }

    ngOnInit(): void {
    }

    public changePosition() {
            this.extensionInterface.setOrientationAndPositionOfModel(this.position);
            this.extensionInterface.rewriteArms();
            const data = this.extensionInterface.prepareFullConnectorConfiguration();
            this.stpConfigureService.saveConnectorConfiguration(data).subscribe( () => {
            });
    }


}
