import { NgModule } from '@angular/core';


import { DBMDataStoreModule } from './dbm-data-store/dbm.data.store.module';
import { TranslateModule, TranslateLoader } from '@ngx-translate/core';
import { Http } from '@angular/http';
import { TranslateHttpLoader } from '@ngx-translate/http-loader';
import {HttpClientModule, HttpClient} from '@angular/common/http';

export function createTranslateLoader(http: HttpClient) {
  return new TranslateHttpLoader(http, 'assets/i18n/', '.json');
}

@NgModule({
  imports: [
    TranslateModule.forChild({
      loader: {
      provide: TranslateLoader,
      useFactory: (createTranslateLoader),
      deps: [HttpClient]
      }
    }),
    DBMDataStoreModule
  ],
  exports : [
    TranslateModule
  ]
})
export class DBMDataStoreModuleWrapper { }
