﻿CORE.storageManager = {

    ignoreDeleteAll: ["workplanes"],
    ignoredProperties: ["selectedObjects"/*, "selected"*/, "modelArrays", "loads", "supports", "workplanes"],
    doNotObserve: ["type", "id"],

	removeAll: function() {

	    var model = CORE.model;
	    var arrayNames = ["bars", "nodes", "loads", "supports"];     // order is important

	    for (var i = 0, ii = arrayNames.length; i < ii; i++)
	    {
	        var arrayName = arrayNames[i];
	        var unwrappedArray = ko.unwrap(model[arrayName]);

	        //model[arrayName].removeAll();

	        while (unwrappedArray.length > 0) {
	            var object = unwrappedArray[0];
	            var array = model[arrayName];
	            array.remove(object);
	        }
	    }
	},

	saveAndLoad: function(){    // test method
	    var json = this.getJsonFromModel();
	    this.loadModelFromJson(json);
	},

    getJsonFromModel: function() {
        return CORE.modelConverter.convertModelToJson(CORE.model);
    },

    loadModelFromJson: function (json) {

        //var newModel = this.convertJsonToModel(json);

        //ko.mapping.fromJS(newModel, {}, CORE.model);

        this.removeAll();

        model = CORE.model;
        var newModel = CORE.modelConverter.convertJsonToModel(json);

        for (arrayName in newModel) {                           // for each array

            var newArray = ko.unwrap(newModel[arrayName]);
            var ignoreThis = this.ignoredProperties.indexOf(arrayName) !== -1;

            if (!newArray || newArray.constructor !== Array || ignoreThis || typeof model[arrayName].removeAll !== 'function') { continue; } // ignore

            if (typeof model[arrayName].removeAll !== 'function')
                debugger;

            //model[arrayName].removeAll();
           

            for (var i = 0, ii = newArray.length; i < ii; i++)     // for each objects in array
            {

                for (var propName in newArray[i])    // iterate over object's properties
                {
                    if (!newArray[i].hasOwnProperty(propName)) { continue; }
                    if (newArray[i][propName] === null) { newArray[i][propName] = ko.observable(newArray[i][propName]); continue; }

                    var newProp = newArray[i][propName];
                    //var descriptor = object.getownpropertydescriptor(model[arrayname][i], propname);
                    //if(!descriptor.writable)
                    //{

                    //}

                    /*if(typeof newArray[i][propName] !== 'undefined')
                    {
                        model[arrayName][i](newArray[i][propName]);
                    }*/
                    //if (propName === 'node1') debugger;

                    if(newProp.constructor === Array)
                    {
                        
                        if (newProp.length > 0 && typeof newProp[0].id !== 'undefined' && typeof newProp[0].name === 'undefined') //if has SimpleRelatedObjects (has id, but not name)
                        {
                            for(var j=0, jj=newProp.length; j<jj; j++)
                            {
                                newArray[i][propName][j] = this.getRelatedObjectBySimpleObject(newProp[j]);
                            }
                        }

                        if (!isElementInSet(this.doNotObserve, propName))
                            newArray[i][propName] = ko.observableArray(newArray[i][propName]);
                        else
                            newArray[i][propName] = newArray[i][propName];
                    }
                    else
                    {
                        if (typeof newProp.id !== 'undefined')
                        {
                            newArray[i][propName] = this.getRelatedObjectBySimpleObject(newProp);
                        }

                        if (!isElementInSet(this.doNotObserve, propName))
                            newArray[i][propName] = ko.observable(newArray[i][propName]);
                        else
                            newArray[i][propName] = newArray[i][propName];
                    }

                } // /for each prop of object

                if (newArray[i].type === 'Node') newArray[i].createsBars = function () { return CORE.model.getBarsCreatedByNode(newArray[i]); } //refactor
                if (typeof newArray[i].node1 === 'function') {
                    //var node1 = newArray[i].node1();
                   
                    newArray[i].node1().createsBars = function () {
                        return CORE.model.getBarsCreatedByNode(this);
                    } //refactor


                    newArray[i].node1().remove = function () {
                        CORE.model.removeNode(this);
                    }
                }
                if (typeof newArray[i].node2 === 'function') {
                    //var node2 = newArray[i].node2();

                    newArray[i].node2().createsBars = function () {
                        return CORE.model.getBarsCreatedByNode(this);
                    } //refactor

                    newArray[i].node2().remove = function () {
                        CORE.model.removeNode(this);
                    }
                }

                if (newArray[i].type === 'Bar') newArray[i].remove = function () { CORE.model.removeBar(this); } //refactor

                model[arrayName].push(newArray[i]); // add new object to model array
                HELPERS.subscribePropertyChange(this, newArray[i].selected, "Imported object", CORE.model.onObjectSelectedChanged, newArray[i], CORE.model);

            }   // /for each objects in array
        }   // /for each newModel array


        
    },


    saveUsingProtoBuf: function () {

        ProtoBuf.loadProtoFile(CORE.rootPath + "js/core/ConstructionModel.proto", function (err, builder) {
            if (!isEmpty(err))
            {
                console.error("CORE.storageManager.saveUsingProtoBuf:"); console.error(err);
                return;
            }
            console.log("proto file loaded successfully");
            var ConstructionModel = builder.build("ConstructionModel"); // ConstructionModel this is a constructor
            //CORE.storageManager.overrideProtoBufJsFunctions(ConstructionModel.prototype);

            var model = ko.toJS(CORE.model); // strip observables
            if (!isEmpty(model.bars[0]) && !isEmpty(model.bars[0].material) && !isEmpty(model.bars[0].material.$add)) debugger;
            var constructionModel = CORE.storageManager.convertModelToProtoBuf(ConstructionModel, model);  // constructionModel this is an instance
            

            //var buffer = constructionModel.toArrayBuffer(); //for binary encoding
            var b64string = constructionModel.toBase64(); //for base64 encoding

            //var myMessage = ConstructionModel.decode64(b64string);

            CORE.webApiManager.saveToDbUsingProtoBuf(b64string);
        });
    },

    protoBufIgnoreProperties: ["test"],

    convertModelToProtoBuf: function (protoBufModel, model) {  // protoBufModel is a constructor

        var protoBufModel = new protoBufModel();
        
        protoBufModel.appId = CORE.options.appId;
        protoBufModel.projId = CORE.options.projId;
        protoBufModel.jobId = CORE.options.jobId;

        var arraysToConvert = ["loads", "supports", "nodes", "bars"/*, "supports", "workplanes"*/];    //hardcoded array order
        var ignoreProperties = ["selected", /*"type"*/, "assignedTo"];
        var convertToSimpleProperties = ["connector"];

        for (var arrayIndex in arraysToConvert) {            // for each array (hardcoded)

            var arrayName = arraysToConvert[arrayIndex];
            var modelArray = model[arrayName];

            for(var i=0,ii=modelArray.length; i<ii;i++) // for each object in array
            {
                var object = modelArray[i];
                var protoObject = {};
                var ignore;

                for (var propertyName in object)            // for each property in object
                {
                    var property = object[propertyName];
                    ignore = false;

                    for (var propertyToIgnoreIndex in ignoreProperties)
                    {
                        if (ignoreProperties[propertyToIgnoreIndex] === propertyName)  // exclude hardcoded properties
                        { ignore = true; break; }
                    }

                    if (ignore || typeof property === 'function') continue;            // exclude functions

                    if (!isEmpty(property)) {

                        if (property.constructor === Array) {
                            property = CORE.storageManager.convertSpecialArrayProperty(property, propertyName, protoBufModel, protoObject);
                        }
                        else {
                            property = CORE.storageManager.convertSpecialProperty(property, propertyName, protoBufModel);
                        }

                        protoObject[propertyName] = property;
                    }
                }

                /*if (object.parentType === MODEL.OBJECT_TYPE.Load || object.parentType === MODEL.OBJECT_TYPE.Support)
                {
                    arrayName = object.type.charAt(0).toLowerCase() + object.type.slice(1) + "s"; //BarTrapezoidal -> barTrapezoidals
                    protoBufModel[arrayName] = protoBufModel[arrayName] || [];
                }*/

                protoBufModel[arrayName].push(protoObject);
            }

        }


        return protoBufModel;
    },

    convertSpecialProperty: function (property, propertyName, protoModel) {     // for every property except arrays

        if (isEmpty(property)) return property;

        if (typeof property === 'object') {                                     // if e.g. node, load...

            //if (property.constructor instanceof MODEL.types.Vector)   // not possible, no longer preserved
            delete property["toViewModel"];                             // delete toViewModel from Vectors

            for (var innerPropertyName in property) {
                if (typeof property[innerPropertyName] === 'object')
                delete property[innerPropertyName]["toViewModel"];
            }


            if (!isEmpty(property.id) & !isEmpty(property.name))
            {
                return CORE.modelConverter.getSimpleRelatedObject(property);

            }

            /*if (property.type === "Node") {   //reassignRelatedObjects (protobuf requires reference)
            
                var modelArray = protoModel["nodes"];//model.modelArrays[property.type];

                for(var existingObjectIndex in modelArray)
                {
                    if (modelArray[existingObjectIndex].id === property.id)
                        return modelArray[existingObjectIndex];
                }
                throw "No matching existingObject found in " + property.type + " array";
            }

            if (property.type === "Bar") {   //reassignRelatedObjects (protobuf requires reference)

                var modelArray = protoModel["bars"];//model.modelArrays[property.type];

                for (var existingObjectIndex in modelArray) {
                    if (modelArray[existingObjectIndex].id === property.id)
                        return modelArray[existingObjectIndex];
                }
                throw "No matching existingObject found in " + property.type + " array";
            }*/

        }
        return property;                                                // if e.g. position, rotation...

    },

    convertSpecialArrayProperty: function (property, propertyName, protoModel, protoObject) {     // only for array properties

        var arrayProperty = [];

        propertyLoop:
            for (var i = 0, ii = property.length; i < ii; i++) {        // property is an array, e.g. Node.Load

                var propertyItem = property[i];

                if (isEmpty(propertyItem)) throw "PropertyItem is null in an array " + propertyName + " of a " + protoObject.type + " with id: " + protoObject.id;

                arrayProperty.push(this.convertSpecialProperty(propertyItem));

                //if (property.parentType === "Load" || property.parentType === "Supports") {
                /*
                var loadsArrayName = propertyItem.type.charAt(0).toLowerCase();
                loadsArrayName = loadsArrayName + propertyItem.type.slice(1) + "s";


                    var modelArray = protoModel[loadsArrayName];    //already converted objects

                    for (var existingObjectIndex in modelArray) {
                        if (modelArray[existingObjectIndex].id === propertyItem.id) {

                            protoObject[loadsArrayName] = protoObject[loadsArrayName] || [];
                            protoObject[loadsArrayName].push(modelArray[existingObjectIndex]);
                            continue propertyLoop;
                        }
                    }
                    throw "No matching existingObject found in " + loadsArrayName + " array";
                    */
                //}

            }

        return arrayProperty;

    },

    loadFromProtoFile: function () {
        ProtoBuf.loadProtoFile(CORE.rootPath + "js/core/file.proto", function (err, builder) {
            console.log(isEmpty(err) ? "proto file loaded successfully" : err);
            var ConstructionModel = builder.build("ConstructionModel"); // this is a constructor
            var model = new ConstructionModel()
            //debugger;
        });
    },

    //overrideProtoBufJsFunctions: function (MessagePrototype) {
    //    MessagePrototype.set = function (keyOrObj, value, noAssert) {
    //        if (keyOrObj && typeof keyOrObj === 'function') return this;

    //        for (var i = 0, ii = 0; i < ii; i++) {
    //            CORE.storageManager.protoBufIgnoreProperties[i] = null;

    //        }

    //        if (keyOrObj && typeof keyOrObj === 'object') {
    //            noAssert = value;
    //            for (var ikey in keyOrObj)
    //                if (keyOrObj.hasOwnProperty(ikey) && typeof (value = keyOrObj[ikey]) !== 'undefined')
    //                    this.$set(ikey, value, noAssert);
    //            return this;
    //        }
    //        var field = T._fieldsByName[keyOrObj];
    //        if (!noAssert) {
    //            if (!field)
    //                throw Error(this + "#" + keyOrObj + " is not a field: undefined");
    //            if (!(field instanceof ProtoBuf.Reflect.Message.Field))
    //                throw Error(this + "#" + keyOrObj + " is not a field: " + field.toString(true));
    //            this[field.name] = (value = field.verifyValue(value)); // May throw
    //        } else
    //            this[keyOrObj] = value;
    //        if (field && field.oneof) { // Field is part of an OneOf (not a virtual OneOf field)
    //            var currentField = this[field.oneof.name]; // Virtual field references currently set field
    //            if (value !== null) {
    //                if (currentField !== null && currentField !== field.name)
    //                    this[currentField] = null; // Clear currently set field
    //                this[field.oneof.name] = field.name; // Point virtual field at this field
    //            } else if (/* value === null && */currentField === keyOrObj)
    //                this[field.oneof.name] = null; // Clear virtual field (current field explicitly cleared)
    //        }
    //        return this;
    //    };
    //    MessagePrototype.$set = MessagePrototype.set;
    //}

}