﻿CORE.storageManager.load.currentObjectType = "";
CORE.storageManager.load.currentObjectIndex = "";


CORE.storageManager.load.protoToModel = (function () {

    var protoToModel = {};
    /*var getRepositoryItem = CORE.storageManager.load.getRepositoryItem;     // shortcuts
    var matchCollection = CORE.storageManager.load.matchCollection;
    var matchItem = CORE.storageManager.load.matchItem;
    var getProperty = CORE.storageManager.load.getProperty;
    var getVector = CORE.storageManager.load.getVector;
    var getExtendedVector = CORE.storageManager.load.getExtendedVector;
    var getExtendedVectorArray = CORE.storageManager.load.getExtendedVectorArray;*/

    protoToModel[MODEL.OBJECT_TYPE.Node] = function (protoObject, loads, supports) { // loads and supports have to be converted first and passed to this constructor

        var node = new MODEL.Node(null);

        node.id = getProperty(protoObject.id, "id");
        node.name(getProperty(protoObject.name, "name"));
        node.position(getVector(protoObject.position, "position"));

        node.connector(getRepositoryItem(protoObject.connector, "connector"));
        node.connectorType(getProperty(protoObject.connectorType, "connectorType"));

        //node.loads = ko.observableArray(matchCollection(protoObject.loads, loads, "loads", node));
        matchAndAssignCollection(protoObject.loads, loads, "loads", node);

        node.support = matchItem(protoObject.loads, supports, "supports", node);

        return node;
    };

    protoToModel[MODEL.OBJECT_TYPE.Bar] = function (protoObject, loads, supports, nodes) { // nodes, loads and supports have to be converted first and passed to this constructor

        var bar = new MODEL.Bar(null, null, null, null);

        bar.id = getProperty(protoObject.id, "id");
        bar.name(getProperty(protoObject.name, "name"));

        bar.node1(matchItem(protoObject.node1, nodes, "node1"));
        bar.node2(matchItem(protoObject.node2, nodes, "node2"));
        bar.profile(getRepositoryItem(protoObject.profile, "profile"));
        bar.material(getRepositoryItem(protoObject.material, "connector"));
        bar.rotation(getVector(protoObject.rotation, "rotation"));

        //bar.loads = ko.observableArray(matchCollection(protoObject.loads, loads, "loads", bar));
        matchAndAssignCollection(protoObject.loads, loads, "loads", bar);

        return bar;
    };

    protoToModel[MODEL.OBJECT_TYPE.NodeForce] = function (protoObject) {

        var load = new MODEL.load.node.NodeForce(null, null, null);

        load.id = getProperty(protoObject.id, "id");
        load.name(getProperty(protoObject.name, "name"));

        load.loadCaseId(getProperty(protoObject.loadCaseId, "loadCaseId"));

        load.forces(getVector(protoObject.forces, "forces"));
        //load.moments(getVector(protoObject.moments, "moments"));
        load.rotation(getVector(protoObject.rotation, "rotation"));

        return load;
    };

    protoToModel[MODEL.OBJECT_TYPE.NodeMoment] = function (protoObject) {

        var load = new MODEL.load.node.NodeMoment(null, null, null);

        load.id = getProperty(protoObject.id, "id");
        load.name(getProperty(protoObject.name, "name"));

        load.loadCaseId(getProperty(protoObject.loadCaseId, "loadCaseId"));

        //load.forces(getVector(protoObject.forces, "forces"));
        load.moments(getVector(protoObject.moments, "moments"));
        //load.rotation(getVector(protoObject.rotation, "rotation"));

        return load;
    };

    protoToModel[MODEL.OBJECT_TYPE.BarUniform] = function (protoObject) {

        var load = new MODEL.load.bar.BarUniform(null, null);

        load.id = getProperty(protoObject.id, "id");
        load.name(getProperty(protoObject.name, "name"));

        load.loadCaseId(getProperty(protoObject.loadCaseId, "loadCaseId"));
        load.isGlobal(getProperty(protoObject.isGlobal, "isGlobal"));
        load.isProjected(getProperty(protoObject.isProjected, "isProjected"));

        load.forces(getVector(protoObject.forces, "forces"));
        //load.moments(getVector(protoObject.moments, "moments"));
        load.rotation(getVector(protoObject.rotation, "rotation"));

        return load;
    };

    protoToModel[MODEL.OBJECT_TYPE.BarTrapezoidal] = function (protoObject) {

        var load = new MODEL.load.bar.BarTrapezoidal(null, null);

        load.id = getProperty(protoObject.id, "id");
        load.name(getProperty(protoObject.name, "name"));

        load.loadCaseId(getProperty(protoObject.loadCaseId, "loadCaseId"));
        load.isGlobal(getProperty(protoObject.isGlobal, "isGlobal"));
        load.isProjected(getProperty(protoObject.isProjected, "isProjected"));

        load.points(getExtendedVectorArray(protoObject.points, "points"));
        //load.moments(getVector(protoObject.moments, "moments"));
        load.rotation(getVector(protoObject.rotation, "rotation"));

        return load;
    };

    protoToModel[MODEL.OBJECT_TYPE.NodeSupport] = function (protoObject) {

        var load = new MODEL.NodeSupport(null, null, null, null);

        load.id = getProperty(protoObject.id, "id");
        load.name(getProperty(protoObject.name, "name"));
        load.supportType = getProperty(protoObject.supportType, "supportType");

        load.kVector(getToggleableVector(protoObject.kVector, "kVector"));
        load.hVector(getToggleableVector(protoObject.hVector, "hVector"));
        load.rotation(getVector(protoObject.rotation, "rotation"));

        return load;
    };


    
    return protoToModel;

})();

warn = function (message, propertyName) {
    console.warn(message + " (property: " + CORE.storageManager.load.currentArrayName + "[" + CORE.storageManager.load.currentObjectIndex + "]." + propertyName + ")");
    //console.warn()
}

getRepositoryItem = function (protoRelatedObject, propertyName) {

    if (!isEmpty(protoRelatedObject)) {
        if (isEmpty(protoRelatedObject.id)) warn("CORE.storageManager.load.getRepositoryItem: protoRelatedObject.id is empty", propertyName);
        if (isEmpty(protoRelatedObject.relatedType)) warn("CORE.storageManager.load.getRepositoryItem: protoRelatedObject.relatedType is empty", propertyName);
    }

    if (isEmpty(protoRelatedObject) || isEmpty(protoRelatedObject.id)) {
        return;                                                             // return undefined if protoRelatedObject is invalid
    }

    var repository = MODEL.repository.repositories[protoRelatedObject.relatedType];

    if (!isEmpty(repository)) {

        //try to match by id
        for(var i = 0, ii = repository.length; i < ii; i++)
        {
            if(repository[i].id === protoRelatedObject.id)
                return repository[i];
        }

        warn("CORE.storageManager.load.getRepositoryItem: Cannot match item with id: " + protoRelatedObject.id + " in the repository of type: " + protoRelatedObject.relatedType, propertyName); debugger;

    }
    else {
        warn("CORE.storageManager.load.getRepositoryItem: Cannot find repository of type: " + protoRelatedObject.relatedType, propertyName); debugger;
    }

    return; // return undefined if not found
};

matchAndAssignCollection = function (protoRelatedObjectsArr, collection, propertyName, parentObject) {  // match every object in protoRelatedObjectsArr using id (look in the collection of existing items)

    if (isEmpty(protoRelatedObjectsArr)) {
        return;                                                             // return undefined if protoRelatedObjectsArr is null of undefined
    }

    var matchedItemsArray = [];

    if (!isEmpty(collection)) {

        //try to match every item by id and type
        foreachRelatedObjects:
        for (var i = 0, ii = protoRelatedObjectsArr.length; i < ii; i++) {
            for (var j = 0, jj = collection.length; j < jj; j++) {
                if (collection[j].id === protoRelatedObjectsArr[i].id && collection[j].type === protoRelatedObjectsArr[i].relatedType)
                {
                    collection[j].assignTo(parentObject);   // assignTo must exist
                    //matchedItemsArray.push(collection[j]);
                    continue foreachRelatedObjects;
                }
            }

            warn("CORE.storageManager.load.matchCollection: Cannot match item with id: " + protoRelatedObjectsArr[i].id
                + ", type: " + protoRelatedObjectsArr[i].relatedType + " in the passed collection", propertyName); debugger;
        }

    }
    else {
        warn("CORE.storageManager.load.matchCollection: Passed collection is empty", propertyName); debugger;
    }

    //return matchedItemsArray;
};

matchItem = function (protoRelatedObject, collection, propertyName) {  // match protoRelatedObject using id (look in the collection of existing items)

    if (isEmpty(protoRelatedObject) || isEmpty(protoRelatedObject.id)) {
        return;                                                             // return undefined if protoRelatedObject is invalid
    }

    if (isEmpty(protoRelatedObject.id)) warn("CORE.storageManager.load.matchItem: protoRelatedObject.id is empty", propertyName);
    if (isEmpty(protoRelatedObject.relatedType)) warn("CORE.storageManager.load.matchItem: protoRelatedObject.relatedType is empty", propertyName);
    

    if (!isEmpty(collection)) {

        //try to match item by id and type
            for (var i = 0, ii = collection.length; i < ii; i++) {
                if (collection[i].id === protoRelatedObject.id && collection[i].type === protoRelatedObject.relatedType)
                {
                    return collection[i];
                }
            }

            warn("CORE.storageManager.load.matchItem: Cannot match item with id: " + protoRelatedObject.id
                + ", type: " + protoRelatedObject.relatedType + " in the passed collection", propertyName);
       
    }
    else {
        warn("CORE.storageManager.load.matchItem: Passed collection is empty", propertyName);
    }

    return;
};

getVector = function (protoVector, propertyName) {
    if (isEmpty(protoVector)) warn("CORE.storageManager.load.getVector: proto vector message is empty", propertyName);
    
    if (isEmpty(protoVector.x) || isEmpty(protoVector.y) || isEmpty(protoVector.z))
        warn("CORE.storageManager.load.getVector: one of the coordinates in proto vector message is empty", propertyName);

    return new MODEL.types.Vector(protoVector.x || 0, protoVector.y || 0, protoVector.z || 0);
}

getExtendedVectorArray = function (protoVectorArr, propertyName) {
    if (isEmpty(protoVectorArr)) warn("CORE.storageManager.load.getExtendedVectorArray: proto vector array message is empty", propertyName);
    
    var modelArray = [];

    for (var i = 0, ii = protoVectorArr.length; i < ii ; i++)
    {
        var modelVector = getExtendedVector(protoVectorArr[i], propertyName + "["+i+"]");
        modelArray.push(ko.observable(modelVector));
    }

    return modelArray;
}

getExtendedVector = function (protoVector, propertyName) {
    if (isEmpty(protoVector)) warn("CORE.storageManager.load.getExtendedVector: proto vector message is empty", propertyName);
    if (isEmpty(protoVector.distance) || isEmpty(protoVector.vector.x) || isEmpty(protoVector.vector.y) || isEmpty(protoVector.vector.z))
        warn("CORE.storageManager.load.getExtendedVector: one of the coordinates in proto vector message is empty", propertyName);

    return new MODEL.types.ExtendedVector(protoVector.vector.x || 0, protoVector.vector.y || 0, protoVector.vector.z || 0, protoVector.distance || 0);
}

getToggleableVector = function (protoVector, propertyName) {
    if (isEmpty(protoVector)) { warn("CORE.storageManager.load.getToggleableVector: proto vector message is empty", propertyName); debugger; }
    if (isEmpty(protoVector.value) || isEmpty(protoVector.value.x) || isEmpty(protoVector.value.y) || isEmpty(protoVector.value.z)
     || isEmpty(protoVector.enabled) || isEmpty(protoVector.enabled.x) || isEmpty(protoVector.enabled.y) || isEmpty(protoVector.enabled.z)) {
        warn("CORE.storageManager.load.getToggleableVector: one of the coordinates in proto vector message is empty", propertyName); debugger;
    }

    return new MODEL.types.ToggleableVector(
        protoVector.value.x || 0, protoVector.value.y || 0, protoVector.value.z || 0,
        protoVector.enabled.x || 0, protoVector.enabled.y || 0, protoVector.enabled.z || 0
        );
}

getProperty = function (protoProperty, propertyName) {
    if (isEmpty(protoProperty)) warn("CORE.storageManager.load.getProperty: proto property is empty", propertyName);

    return protoProperty;
}

