﻿convertUnits = function (model, type, min, max, element) { // barLength - optional
    var multi = 1;
    var multi2 = 1;
    if (!isEmpty(max) && model() > max) {
        model(max);
    }
    if (!isEmpty(min) && model() < min) {
        model(min);
    }
    var _model = model;
    var val = 0;
    var view;
    var updaateMultipliers = function (customType) {
        type = customType || type;
        multi = 1;
        multi2 = 1;
        if (!isEmpty(CORE.units)) {
            switch (type) {
                case "Distance": // Default: "m" (metre)
                    switch (VIEWUI.viewOptions.unitDistance()) {
                        case "mm":
                            multi = CORE.units.getMulti("mm");
                            break;
                        case "cm":
                            multi = CORE.units.getMulti("cm");
                            break;
                        case "ft":
                            multi = CORE.units.getMulti("ft");
                            break;
                        case "inch":
                            multi = CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Displacement": // Default: "mm" (millimetre)
                    switch (VIEWUI.viewOptions.unitDisplacement()) {
                        case "mm":
                            multi = CORE.units.getMulti("mm");
                            break;
                        case "cm":
                            multi = CORE.units.getMulti("cm");
                            break;
                        case "ft":
                            multi = CORE.units.getMulti("ft");
                            break;
                        case "inch":
                            multi = CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Area": // Default: "m2" (square metre)
                    switch (units.area) {
                        case "mm2":
                            multi = CORE.units.getMulti("mm") * CORE.units.getMulti("mm");
                            break;
                        case "cm2":
                            multi = CORE.units.getMulti("cm") * CORE.units.getMulti("cm");
                            break;
                        case "ft2":
                            multi = CORE.units.getMulti("ft") * CORE.units.getMulti("ft");
                            break;
                        case "inch2":
                            multi = CORE.units.getMulti("inch") * CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Volume": // Default: "m3" (cubic metre)
                    switch (units.volume) {
                        case "mm3":
                            multi = CORE.units.getMulti("mm") * CORE.units.getMulti("mm") * CORE.units.getMulti("mm");
                            break;
                        case "cm3":
                            multi = CORE.units.getMulti("cm") * CORE.units.getMulti("cm") * CORE.units.getMulti("cm");
                            break;
                        case "ft3":
                            multi = CORE.units.getMulti("ft") * CORE.units.getMulti("ft") * CORE.units.getMulti("ft");
                            break;
                        case "inch3":
                            multi = CORE.units.getMulti("inch") * CORE.units.getMulti("inch") * CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Force": // Default: "N" (Newton)
                    switch (VIEWUI.viewOptions.unitForce()) {
                        case "daN":
                            multi = CORE.units.getMulti("daN");
                            break;
                        case "kG":
                            multi = CORE.units.getMulti("kG");
                            break;
                        case "kgf":
                            multi = CORE.units.getMulti("kgf");
                            break;
                        case "kip":
                            multi = CORE.units.getMulti("kip");
                            break;
                        case "kN":
                            multi = CORE.units.getMulti("kN");
                            break;
                        case "lbf":
                            multi = CORE.units.getMulti("lbf");
                            break;
                        case "MN":
                            multi = CORE.units.getMulti("MN");
                            break;
                        case "tonfUS":
                            multi = CORE.units.getMulti("tonfUS");
                            break;
                        case "tf":
                            multi = CORE.units.getMulti("tf");
                            break;
                        case "T":
                            multi = CORE.units.getMulti("T");
                            break;
                    }
                    break;
                case "Angle": // Default: "deg" (degree)
                    switch (VIEWUI.viewOptions.unitAngle()) {
                        case "Rad":
                            multi = CORE.units.getMulti("Rad");
                            break;
                        case "Percent":
                            multi = CORE.units.getMulti("Percent");
                            break;
                        case "Grad":
                            multi = CORE.units.getMulti("Grad");
                            break;
                        case "°":
                            multi = CORE.units.getMulti("°");
                            break;

                    }
                    break;
                case "Mass": // Default: "kg" (kilogram)
                    switch (units.mass) {
                        case "mg":
                            multi = CORE.units.getMulti("mg");
                            break;
                        case "g":
                            multi = CORE.units.getMulti("g");
                            break;
                        case "dkg":
                            multi = CORE.units.getMulti("dkg");
                            break;
                        case "t":
                            multi = CORE.units.getMulti("t");
                            break;
                        case "oz":
                            multi = CORE.units.getMulti("oz");
                            break;
                        case "lb":
                            multi = CORE.units.getMulti("lb");
                            break;
                        case "tonUS":
                            multi = CORE.units.getMulti("tonUS");
                            break;
                    }
                    break;
                case "Stress": // Default "Pa" (Pascal)
                    switch (units.stress) {
                        case "kPa":
                            multi = CORE.units.getMulti("kPa");
                            break;
                        case "MPa":
                            multi = CORE.units.getMulti("MPa");
                            break;
                        case "psi":
                            multi = CORE.units.getMulti("psi");
                            break;
                        case "psf":
                            multi = CORE.units.getMulti("psf");
                            break;
                    }
                    break;

                case "Moment": // Default "N*m"
                    switch (VIEWUI.viewOptions.unitMomentForce()) {
                        case "daN":
                            multi = CORE.units.getMulti("daN");
                            break;
                        case "kG":
                            multi = CORE.units.getMulti("kG");
                            break;
                        case "kgf":
                            multi = CORE.units.getMulti("kgf");
                            break;
                        case "kip":
                            multi = CORE.units.getMulti("kip");
                            break;
                        case "kN":
                            multi = CORE.units.getMulti("kN");
                            break;
                        case "lbf":
                            multi = CORE.units.getMulti("lbf");
                            break;
                        case "MN":
                            multi = CORE.units.getMulti("MN");
                            break;
                        case "tonfUS":
                            multi = CORE.units.getMulti("tonfUS");
                            break;
                        case "tf":
                            multi = CORE.units.getMulti("tf");
                            break;
                        case "T":
                            multi = CORE.units.getMulti("T");
                            break;
                    }
                    switch (VIEWUI.viewOptions.unitMomentDistance()) {
                        case "mm":
                            multi2 = CORE.units.getMulti("mm");
                            break;
                        case "cm":
                            multi2 = CORE.units.getMulti("cm");
                            break;
                        case "ft":
                            multi2 = CORE.units.getMulti("ft");
                            break;
                        case "inch":
                            multi2 = CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "DistLoad": // Default "N/m"
                    switch (VIEWUI.viewOptions.unitForce()) {
                        case "daN":
                            multi = CORE.units.getMulti("daN");
                            break;
                        case "kG":
                            multi = CORE.units.getMulti("kG");
                            break;
                        case "kgf":
                            multi = CORE.units.getMulti("kgf");
                            break;
                        case "kip":
                            multi = CORE.units.getMulti("kip");
                            break;
                        case "kN":
                            multi = CORE.units.getMulti("kN");
                            break;
                        case "lbf":
                            multi = CORE.units.getMulti("lbf");
                            break;
                        case "MN":
                            multi = CORE.units.getMulti("MN");
                            break;
                        case "tonfUS":
                            multi = CORE.units.getMulti("tonfUS");
                            break;
                        case "tf":
                            multi = CORE.units.getMulti("tf");
                            break;
                        case "T":
                            multi = CORE.units.getMulti("T");
                            break;
                    }
                    switch (VIEWUI.viewOptions.unitMomentDistance()) {
                        case "mm":
                            multi2 = 1 / CORE.units.getMulti("mm");
                            break;
                        case "cm":
                            multi2 = 1 / CORE.units.getMulti("cm");
                            break;
                        case "ft":
                            multi2 = 1 / CORE.units.getMulti("ft");
                            break;
                        case "inch":
                            multi2 = 1 / CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Pressure": // Default "N*m"
                    switch (VIEWUI.viewOptions.unitPressureForce()) {
                        case "daN":
                            multi = CORE.units.getMulti("daN");
                            break;
                        case "kG":
                            multi = CORE.units.getMulti("kG");
                            break;
                        case "kgf":
                            multi = CORE.units.getMulti("kgf");
                            break;
                        case "kip":
                            multi = CORE.units.getMulti("kip");
                            break;
                        case "kN":
                            multi = CORE.units.getMulti("kN");
                            break;
                        case "lbf":
                            multi = CORE.units.getMulti("lbf");
                            break;
                        case "MN":
                            multi = CORE.units.getMulti("MN");
                            break;
                        case "tonfUS":
                            multi = CORE.units.getMulti("tonfUS");
                            break;
                        case "tf":
                            multi = CORE.units.getMulti("tf");
                            break;
                        case "T":
                            multi = CORE.units.getMulti("T");
                            break;
                    }
                    switch (VIEWUI.viewOptions.unitPressureSurface()) {
                        case "mm2":
                            multi2 = 1 / (CORE.units.getMulti("mm") * CORE.units.getMulti("mm"));
                            break;
                        case "cm2":
                            multi2 = 1 / (CORE.units.getMulti("cm") * CORE.units.getMulti("cm"));
                            break;
                        case "ft2":
                            multi2 = 1 / (CORE.units.getMulti("ft") * CORE.units.getMulti("ft"));
                            break;
                        case "inch2":
                            multi2 = 1 / (CORE.units.getMulti("inch") * CORE.units.getMulti("inch"));
                            break;
                    }
                    break;
                case "mm": // always mm
                    multi = CORE.units.getMulti("mm");
                    break;
            }
        }
    };

    updaateMultipliers();

    convertUnitsVector = function (vec_, unitType) {
        var vec = ko.unwrap(vec_);
        var convertedVec = new MODEL.types.Vector();
        
        convertedVec.x = convertUnits(ko.unwrap(vec.x), unitType);
        convertedVec.y = convertUnits(ko.unwrap(vec.y), unitType);
        convertedVec.z = convertUnits(ko.unwrap(vec.z), unitType);

        return convertedVec;
    }

    //    if ((!isEmpty(min) || !isEmpty(max)) && !element) { console.error("You must pass '$element' as a 5th element of the convertUnits function for min/max to work"); }

    if (!isEmpty(min))
        $(element).attr('min', min / multi);

    if (!isEmpty(max))
        $(element).attr('max', max / multi);

    if (typeof model === "function") {
        view = ko.observable(Number(model()) / multi / multi2);
        view.subscribe(function () {
            updaateMultipliers();
            if (view() !== FormatPrecision(Number(_model()) / multi / multi2, type)) {
                _model(view() * multi * multi2);
            }
        });
        view(FormatPrecision(Number(_model()) / multi / multi2, type));
    } else {
        view = FormatPrecision(model / multi / multi2, type);
    }
    return view;
};

FormatPrecision = function (value, type) {
    var num = 0;
    switch (type) {
        case "Distance":
            num = value.toFixed(VIEWUI.viewOptions.unitDistancePrecision());
            break;
        case "Force":
            num = value.toFixed(VIEWUI.viewOptions.unitForcePrecision());
            break;
        case "Moment":
            num = value.toFixed(VIEWUI.viewOptions.unitMomentPrecision());
            break;
        case "Pressure":
            num = value.toFixed(VIEWUI.viewOptions.unitPressurePrecision());
            break;
        case "Angle":
            num = value.toFixed(VIEWUI.viewOptions.unitAnglePrecision());
            break;
        case "Utilization":
            num = value.toFixed(VIEWUI.viewOptions.unitUtilizationPrecision());
            break;
        case "Displacement":
            num = value.toFixed(VIEWUI.viewOptions.unitDisplacementPrecision());
            break;
        case "Stress":
            num = value.toFixed(VIEWUI.viewOptions.unitStressPrecision());
            break;
        case "DistLoad":
            num = value.toFixed(2);
            break;
        case "mm":
            num = value.toFixed(1);
    }
    return num;
};

MeasurementLabel = function (vec1, vec2, color, text, textSize, texture, offset, ratio) {
    var mockAspectRatio = ko.observable(1);
    THREE.Mesh.call(this, this.geometry, this.material);

    var bitmapFont = CORE.bitmapFont;
    var p1 = vec1;
    var p2 = vec2;
    this.geometry = new THREE.BufferGeometry();
    this.material = new VIEW3D.materials.LineLabel(mockAspectRatio, texture, color, offset);
    this.geometry = bitmapFont.createText(text);
    this.geometry.addAttribute('begin', new THREE.BufferAttribute(undefined, 3));
    this.geometry.addAttribute('end', new THREE.BufferAttribute(undefined, 3));
    this.geometry.update({
        text: text.toString(),
        align: 'center',
        font: bitmapFont.font
    });
    var positions = this.geometry.attributes.position.array;
    var vertices = positions.length / 2;
    var halfW = this.geometry.layout._width / 2;
    var halfH = this.geometry.layout._height / 2;
    var begins = new Float32Array(vertices * 3);
    var ends = new Float32Array(vertices * 3);
    for (var i = 0; i < vertices; i++) {
        begins[i * 3] = p1.x;
        begins[i * 3 + 1] = p1.y;
        begins[i * 3 + 2] = p1.z;
        ends[i * 3] = p2.x;
        ends[i * 3 + 1] = p2.y;
        ends[i * 3 + 2] = p2.z;
        positions[i * 2] = (positions[i * 2] - halfW) * textSize / halfH;
        positions[i * 2 + 1] = -(positions[i * 2 + 1] + halfH) * textSize / halfH;
    }
    this.geometry.attributes.begin.array = begins;
    this.geometry.attributes.begin.needsUpdate = true;
    this.geometry.attributes.end.array = ends;
    this.geometry.attributes.end.needsUpdate = true;
    this.geometry.attributes.begin.count = vertices;
    this.geometry.attributes.end.count = vertices;
    this.geometry.attributes.position.count = vertices;
    this.geometry.attributes.uv.count = vertices;
    this.frustumCulled = false;
};
MeasurementLabel.prototype = Object.create(THREE.Mesh.prototype);
var resultLabels = [];
recalibrateViewport = function (screenSize, imgWidth, imgHeight, oldCam) {
    var height = screenSize.height;
    var width = (imgWidth / imgHeight) * height;

    if ((imgWidth / imgHeight) > (screenSize.width / screenSize.height)) {//if ratio of an image is somehow bigger then scene then swap:
        width = screenSize.width;
        height = (imgHeight / imgWidth) * width;
    }

    var camWidth = (imgWidth / imgHeight) * (oldCam.top - oldCam.bottom);
    camera.right = camWidth / 2;
    camera.left = -1 * camWidth / 2;

    //var frameHieght = screenSize.height;
    //var frameWidth  = (imgWidth/imgHeight)*screenSize.height;
    //var newHieght = frameWidth * screenSize.height/screenSize.width
    camera.updateMatrixWorld();
    camera.updateProjectionMatrix();
    CORE.aspectRatio(width / height);
    CORE.screenSize({ width: width, height: height });
    renderer.setViewport(screenSize.width / 2 - width / 2, screenSize.height / 2 - height / 2, width, height);
}

copyCanvas = function (screenSize, imgWidth, imgHeight) {
    var height = screenSize.height;
    var width = Math.floor((imgWidth / imgHeight) * height);

    if ((imgWidth / imgHeight) > (screenSize.width / screenSize.height)) {//if ratio of an image is somehow bigger then scene then swap:
        width = screenSize.width;
        height = Math.floor((imgHeight / imgWidth) * width);
    }
    // var renderCtx = renderer.domElement.getContext("webgl");
    // var pixels = new Uint8Array(width * height * 4);
    // renderCtx.readPixels((screenSize.width - width)/2, (screenSize.height - height)/2, width, height, renderCtx.RGBA, renderCtx.UNSIGNED_BYTE, pixels);
    // var clampedPixels = Uint8ClampedArray.from(pixels);
    // var imageData = new ImageData(clampedPixels, width, height);

    var tmpCanvas = document.createElement("canvas");
    tmpCanvas.width = width;
    tmpCanvas.height = height;
    var context = tmpCanvas.getContext("2d");

    context.rect(0, 0, width, height);
    context.fillStyle = 'white';
    context.fill();
    //context.putImageData(imageData, 0, 0);
    //context.scale(-1, 1);

    context.drawImage(renderer.domElement, (screenSize.width - width) / 2, (screenSize.height - height) / 2, width, height, 0, 0, width, height);

    return tmpCanvas.toDataURL("image/png");
}
createLabelsObject = function(labels, color, screenSize, mirror) {
    var texture = undefined;
    if(mirror == true) {
        texture = "itemLabel";
    }
    var structures =  VIEW3D.utils.Labeling.createStructures(color, texture);
    for (var i = 0; i < labels.length; i++) {
        var label = labels[i];
        VIEW3D.utils.Labeling.createLabel(structures, label, 1, mirror);
    }
    structures.labelsObject.material.depthTest = false;
    //var zoomValue = Math.sqrt(screenSize.width/1700) * 1.5;//for viewer size = 1700 (so full-hd screen) zoom is 1.5, for smaller screens it is smaller
    structures.labelsObject.material.uniforms.scale.value = 1.5;
    return structures.labelsObject;
}
addLabelsObject = function(labels, color, labelObjects, screenSize, mirror) {
    if(labels.length > 0) {
        var lblObj = createLabelsObject(labels, color, screenSize, mirror);
        scene.add(lblObj);
        labelObjects.push(lblObj);
    }
}
addNodeLabels = function(screenSize) {
    
    var positives = [];
    var negatives = [];
    var labelObjects = [];
    for (var i = 0; i < CORE.model.nodesResults().length; i++) {
        var labels = [];
        var nodeResult = CORE.model.nodesResults()[i];
        var node = nodeResult.node;
        var nodePos = node.position();
        var label = {
            pos: new THREE.Vector3(nodePos.x, nodePos.y,nodePos.z),
            dir: new THREE.Vector3(0, 0, 0),
            text: " " + String(node.id) //No. is not displayed (not such chars in used charset) but makes formatting very nice somehow
        };
        labels.push(label);
        addLabelsObject(labels, new THREE.Vector4(0.9, 0.9, 0.9, 0.8), labelObjects, screenSize, true);

        var resultLabel = {
            pos: new THREE.Vector3(nodePos.x, nodePos.y,nodePos.z),
            dir: new THREE.Vector3(0, 0, 0),
            text: String(FormatPrecisionResults(nodeResult.data.utilization.global, "Utilization")) + "%"
        };
        if(nodeResult.data.utilization.global > 100) {
            negatives.push(resultLabel);
        }
        else {
            positives.push(resultLabel);
        }
    }

    addLabelsObject(positives, new THREE.Vector4(0, 1, 0, 0.8), labelObjects, screenSize);
    addLabelsObject(negatives, new THREE.Vector4(1, 0, 0, 0.8), labelObjects, screenSize);
    
    return labelObjects;
}

addBarLabels = function(screenSize, withResults) {
    var positives = [];
    var negatives = [];
    var labelObjects = [];
    for (var i = 0; i < CORE.model.barsResults().length; i++) {
        var labels = [];
        var barResult = CORE.model.barsResults()[i];
        var bar = barResult.bar;
        var node1 = HELPERS.toVector3(bar.node1().position());
        var node2 = HELPERS.toVector3(bar.node2().position());
        var center = new THREE.Vector3().addVectors(node1, node2).multiplyScalar(0.5);
        if(Math.abs(node1.z - node2.z)> 0.00001) {
            if(node2.z > node1.z) center = node2;
            else center = node1;
        }
        var label = {
            pos: center,
            dir: new THREE.Vector3(0, 0, 0),
            text: " " + String(bar.id) //No. is not displayed (not such chars in used charset) but makes formatting very nice somehow
        };
        labels.push(label);
        addLabelsObject(labels, new THREE.Vector4(0.9, 0.9, 0.9, 0.8), labelObjects, screenSize, withResults);
        if(withResults === false) {
            continue;
        }
        var resultLabel = {
            pos: center,
            dir: new THREE.Vector3(0, 0, 0),
            text: String(FormatPrecisionResults(barResult.data.values.utilization, "Utilization")) + "%"
        };
        if(barResult.data.values.utilization > 100) {
            negatives.push(resultLabel);
        }
        else {
            positives.push(resultLabel);
        }
    }

    
    addLabelsObject(positives, new THREE.Vector4(0, 1, 0, 0.8), labelObjects, screenSize);
    addLabelsObject(negatives, new THREE.Vector4(1, 0, 0, 0.8), labelObjects, screenSize);
    
    return labelObjects;
}

removeLabels = function(labelsObjects) {
    for (var i = 0; i < labelsObjects.length; i++) {
        scene.remove(labelsObjects[i]);
    }
}

generateReport = function () {
    var oldFontsSize = CORE.getFontSize();
    var oldAspectRatio = CORE.aspectRatio();
    var screenSize = CORE.screenSize();
    var oldCam = camera;
    camera = new THREE.OrthographicCamera(oldCam.left, oldCam.right, oldCam.top, oldCam.bottom, -1000, 1000);
    recalibrateViewport(screenSize, 539, 313, oldCam);
    var oldView = VIEWUI.viewOptions.showRealElements();
    var oldViewLoad = VIEWUI.viewOptions.loadsVisible();
    var oldViewForce = VIEWUI.viewOptions.visibleCalcForce();
    var oldViewDisp = VIEWUI.viewOptions.showCalcDisplacement();
    var oldViewMeasurement = VIEWUI.viewOptions.measurementsVisible();
    VIEWUI.viewOptions.showRealElements(true);
    VIEWUI.viewOptions.measurementsVisible(false);
    var dataUrl, pos;
    var image = [];
    var control = new VIEW3D.controls.Trackball(camera, CORE.axisHelperNamespace, null, CORE.model);
    CORE.model.deselectAll();
    CORE.changeFontSize(1.5);
    
    // Page 1 SS
    control.resetView(-1, 1, -1);
    control.zoomAll();
    VIEWUI.viewOptions.showRealElements(true);
    VIEWUI.viewOptions.showCalcDisplacement(false);
    VIEWUI.viewOptions.loadsVisible(false);
    CORE.constructionView3D.activeWorkplane.skyboxScene.visible = false;
    VIEWUI.viewOptions.showCalcForceFx(false);
    VIEWUI.viewOptions.showCalcForceFy(false);
    VIEWUI.viewOptions.showCalcForceFz(false);
    VIEWUI.viewOptions.showCalcForceMx(false);
    VIEWUI.viewOptions.showCalcForceMy(false);
    VIEWUI.viewOptions.showCalcForceMz(false);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 539, 313);//renderer.domElement.toDataURL("image/png");
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    // Page 3 SS 1
    // Rewrite html inputs for screenshots
    recalibrateViewport(screenSize, 380, 377, oldCam);
    control.zoomAll();
    var start, end, obj, i, value;
    var labels = [];
    var texture = VIEW3D.AxisHelper.fontTexture;
    var measurements = CORE.measurements.getAllMeasurements();
    var totals = CORE.totalMeasurements.getAllMeasurements();
    var offset;
    for (i = 0; i < measurements.length; i++) {
        start = measurements[i].start();
        end = measurements[i].getEnd();

        if (window.innerWidth > 1050) {
            if (Math.abs(start.z - end.z) < 0.1) {
                offset = 0.009 * camera.zoom;
            } else {
                offset = 0.019 * camera.zoom;
            }
        }
        else {
            if (Math.abs(start.z - end.z) < 0.1) {
                offset = 0.010 * camera.zoom;
            } else {
                offset = 0.028 * camera.zoom;
            }
        }

        value = convertUnits(measurements[i].length(), 'Distance');
        obj = new MeasurementLabel(start, end, VIEW3D.measurementColor, value, 0.020, texture, offset);
        scene.add(obj);
        labels.push(obj);
    }
    for (i = 0; i < totals.length; i++) {
        start = totals[i].start();
        end = totals[i].getEnd();
        if (window.innerWidth > 1050) {
            if (Math.abs(start.z - end.z) < 0.1) {
                offset = 0.017 * camera.zoom
            } else {
                offset = 0.029 * camera.zoom;
            }
        }
        else {
            if (Math.abs(start.z - end.z) < 0.1) {
                offset = 0.017 * camera.zoom
            } else {
                offset = 0.041 * camera.zoom;
            }
        }

        value = convertUnits(totals[i].length(), 'Distance');
        obj = new MeasurementLabel(start, end, VIEW3D.measurementColor, value, 0.020, texture, offset);
        scene.add(obj);
        labels.push(obj);
    }
    control.resetView(-1, 0, 0);
    control.zoomAll();
    //camera.zoom *= 0.6;
    VIEWUI.viewOptions.measurementsVisible(true);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 380, 377);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    // Page 3 SS 2
    recalibrateViewport(screenSize, 335, 377, oldCam);
    control.resetView(0, 1, 0);
    control.zoomAll();
    //camera.zoom *= 0.6;
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 335, 377);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    for (var k = 0; k < labels.length; k++) {
        scene.remove(labels[k]);
    }
    // Page 4 SS
    recalibrateViewport(screenSize, 724, 472, oldCam);
    var labelsObjects = addBarLabels(screenSize, false);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 1.1;
    VIEWUI.viewOptions.measurementsVisible(false);
    VIEWUI.viewOptions.showRealElements(false);
    VIEWUI.viewOptions.loadsVisible(true);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 724, 472);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    removeLabels(labelsObjects);
    // Page 5 SS 1
    recalibrateViewport(screenSize, 506, 472, oldCam);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 1.1;
    VIEWUI.viewOptions.showCalcDisplacement(true);
    VIEWUI.viewOptions.loadsVisible(false);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 506, 472);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    // Page 5 SS 2
    recalibrateViewport(screenSize, 506, 518, oldCam);
    var labelsObjects = addNodeLabels(screenSize);
    var scale = 1;
    //var barLabels = createBarLabel(scale);
    //scene.add(barLabels[0]);
    //scene.add(barLabels[1]);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 1.1;
    VIEWUI.viewOptions.showRealElements(true);
    VIEWUI.viewOptions.showCalcDisplacement(false);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 506, 518);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    removeLabels(labelsObjects);
    // Page last SS 1
    recalibrateViewport(screenSize, 520, 256, oldCam);
    //scene.remove(barLabels[0]);
    //scene.remove(barLabels[1]);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 0.6;
    VIEWUI.viewOptions.showRealElements(false);
    VIEWUI.viewOptions.showCalcForceFx(true);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 520, 256);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    // Page last SS 2
    recalibrateViewport(screenSize, 520, 256, oldCam);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 0.6;
    VIEWUI.viewOptions.showCalcForceFx(false);
    VIEWUI.viewOptions.showCalcForceFy(true);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 520, 256);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    // Page last SS 3
    recalibrateViewport(screenSize, 520, 256, oldCam);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 0.6;
    VIEWUI.viewOptions.showCalcForceFy(false);
    VIEWUI.viewOptions.showCalcForceFz(true);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 520, 256);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    // Page last SS 4
    recalibrateViewport(screenSize, 520, 256, oldCam);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 0.6;
    VIEWUI.viewOptions.showCalcForceFz(false);
    VIEWUI.viewOptions.showCalcForceMx(true);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 520, 256);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    // Page last SS 5
    recalibrateViewport(screenSize, 520, 256, oldCam);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 0.6;
    VIEWUI.viewOptions.showCalcForceMx(false);
    VIEWUI.viewOptions.showCalcForceMy(true);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 520, 256);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    // Page last SS 6
    recalibrateViewport(screenSize, 520, 256, oldCam);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 0.6;
    VIEWUI.viewOptions.showCalcForceMy(false);
    VIEWUI.viewOptions.showCalcForceMz(true);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 520, 256);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));

    // Page bars utilization
    recalibrateViewport(screenSize, 506, 518, oldCam);
    var scale = 1;
    var labelsObjects = addBarLabels(screenSize, true);
    control.resetView(-1, 1, -1);
    control.zoomAll();
    //camera.zoom *= 1.1;
    VIEWUI.viewOptions.showRealElements(true);
    VIEWUI.viewOptions.showCalcDisplacement(false);
    camera.updateProjectionMatrix();
    renderNow();
    dataUrl = copyCanvas(screenSize, 506, 518);
    pos = dataUrl.indexOf(",");
    image.push(dataUrl.slice(pos + 1));
    removeLabels(labelsObjects);

    // Return to user view
    camera = oldCam;
    CORE.changeFontSize(oldFontsSize);
    CORE.aspectRatio(oldAspectRatio);
    CORE.screenSize(screenSize);
    renderer.setViewport(0, 0, screenSize.width, screenSize.height);
    
    VIEWUI.viewOptions.showCalcForceMz(false);
    CORE.constructionView3D.activeWorkplane.skyboxScene.visible = true;
    VIEWUI.viewOptions.visibleCalcForce(oldViewForce);
    VIEWUI.viewOptions.showCalcDisplacement(oldViewDisp);
    VIEWUI.viewOptions.showRealElements(oldView);
    VIEWUI.viewOptions.loadsVisible(oldViewLoad);
    VIEWUI.viewOptions.measurementsVisible(oldViewMeasurement);
    
    return image;
};

getDownloadReportUrl = function () { // CRM does not allow /lang/Controller/Method requests, using /Controller/Method instead if run in CRM
    if (!CORE.options.isCrm)
        return '/' + CORE.options.language.toLowerCase() + '/Report/DownloadReportPost';
    else
        return '/Report/DownloadReportPost';
};

generateXls = function (mod) {
    var info = {
        appId: CORE.options.appId,
        projId: CORE.options.projId,
        jobId: CORE.options.jobId,
        systemId: CORE.options.systemId,
        versionId: CORE.options.language,
        mod: mod,
        reportName: CORE.options.jobName
    };
    var url = "/api/ConstructionViewerStorage/GetXlsReport?info=" + btoa(JSON.stringify(info));

    window.open(url, '_blank', '');
};

convertUnitsResults = function (model, type, min, max, element) { // barLength - optional
    var multi = 1;
    var multi2 = 1;
    if (!isEmpty(max) && model() > max) {
        model(max);
    }
    if (!isEmpty(min) && model() < min) {
        model(min);
    }
    var _model = model;
    var val = 0;
    var view;
    var updaateMultipliers = function (customType) {
        type = customType || type;
        multi = 1;
        multi2 = 1;
        if (!isEmpty(CORE.units)) {
            switch (type) {
                case "Distance": // Default: "m" (metre)
                    switch (VIEWUI.viewOptions.unitDistanceResults()) {
                        case "mm":
                            multi = CORE.units.getMulti("mm");
                            break;
                        case "cm":
                            multi = CORE.units.getMulti("cm");
                            break;
                        case "ft":
                            multi = CORE.units.getMulti("ft");
                            break;
                        case "inch":
                            multi = CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Displacement": // Default: "mm" (millimetre)
                    switch (VIEWUI.viewOptions.unitDisplacement()) {
                        case "mm":
                            multi = CORE.units.getMulti("mm");
                            break;
                        case "cm":
                            multi = CORE.units.getMulti("cm");
                            break;
                        case "ft":
                            multi = CORE.units.getMulti("ft");
                            break;
                        case "inch":
                            multi = CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Area": // Default: "m2" (square metre)
                    switch (units.area) {
                        case "mm2":
                            multi = CORE.units.getMulti("mm") * CORE.units.getMulti("mm");
                            break;
                        case "cm2":
                            multi = CORE.units.getMulti("cm") * CORE.units.getMulti("cm");
                            break;
                        case "ft2":
                            multi = CORE.units.getMulti("ft") * CORE.units.getMulti("ft");
                            break;
                        case "inch2":
                            multi = CORE.units.getMulti("inch") * CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Volume": // Default: "m3" (cubic metre)
                    switch (units.volume) {
                        case "mm3":
                            multi = CORE.units.getMulti("mm") * CORE.units.getMulti("mm") * CORE.units.getMulti("mm");
                            break;
                        case "cm3":
                            multi = CORE.units.getMulti("cm") * CORE.units.getMulti("cm") * CORE.units.getMulti("cm");
                            break;
                        case "ft3":
                            multi = CORE.units.getMulti("ft") * CORE.units.getMulti("ft") * CORE.units.getMulti("ft");
                            break;
                        case "inch3":
                            multi = CORE.units.getMulti("inch") * CORE.units.getMulti("inch") * CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Force": // Default: "N" (Newton)
                    switch (VIEWUI.viewOptions.unitForceResults()) {
                        case "daN":
                            multi = CORE.units.getMulti("daN");
                            break;
                        case "kG":
                            multi = CORE.units.getMulti("kG");
                            break;
                        case "kgf":
                            multi = CORE.units.getMulti("kgf");
                            break;
                        case "kip":
                            multi = CORE.units.getMulti("kip");
                            break;
                        case "kN":
                            multi = CORE.units.getMulti("kN");
                            break;
                        case "lbf":
                            multi = CORE.units.getMulti("lbf");
                            break;
                        case "MN":
                            multi = CORE.units.getMulti("MN");
                            break;
                        case "tonfUS":
                            multi = CORE.units.getMulti("tonfUS");
                            break;
                        case "tf":
                            multi = CORE.units.getMulti("tf");
                            break;
                        case "T":
                            multi = CORE.units.getMulti("T");
                            break;
                    }
                    break;
                case "Angle": // Default: "deg" (degree)
                    switch (VIEWUI.viewOptions.unitAngle()) {
                        case "Rad":
                            multi = CORE.units.getMulti("Rad");
                            break;
                        case "Percent":
                            multi = CORE.units.getMulti("Percent");
                            break;
                        case "Grad":
                            multi = CORE.units.getMulti("Grad");
                            break;
                        case "°":
                            multi = CORE.units.getMulti("°");
                            break;

                    }
                    break;
                case "Mass": // Default: "kg" (kilogram)
                    switch (units.mass) {
                        case "mg":
                            multi = CORE.units.getMulti("mg");
                            break;
                        case "g":
                            multi = CORE.units.getMulti("g");
                            break;
                        case "dkg":
                            multi = CORE.units.getMulti("dkg");
                            break;
                        case "t":
                            multi = CORE.units.getMulti("t");
                            break;
                        case "oz":
                            multi = CORE.units.getMulti("oz");
                            break;
                        case "lb":
                            multi = CORE.units.getMulti("lb");
                            break;
                        case "tonUS":
                            multi = CORE.units.getMulti("tonUS");
                            break;
                    }
                    break;
                case "Stress": // Default "Pa" (Pascal)
                    switch (units.stress) {
                        case "kPa":
                            multi = CORE.units.getMulti("kPa");
                            break;
                        case "MPa":
                            multi = CORE.units.getMulti("MPa");
                            break;
                        case "psi":
                            multi = CORE.units.getMulti("psi");
                            break;
                        case "psf":
                            multi = CORE.units.getMulti("psf");
                            break;
                    }
                    break;

                case "Moment": // Default "N*m"
                    switch (VIEWUI.viewOptions.unitMomentForceResults()) {
                        case "daN":
                            multi = CORE.units.getMulti("daN");
                            break;
                        case "kG":
                            multi = CORE.units.getMulti("kG");
                            break;
                        case "kgf":
                            multi = CORE.units.getMulti("kgf");
                            break;
                        case "kip":
                            multi = CORE.units.getMulti("kip");
                            break;
                        case "kN":
                            multi = CORE.units.getMulti("kN");
                            break;
                        case "lbf":
                            multi = CORE.units.getMulti("lbf");
                            break;
                        case "MN":
                            multi = CORE.units.getMulti("MN");
                            break;
                        case "tonfUS":
                            multi = CORE.units.getMulti("tonfUS");
                            break;
                        case "tf":
                            multi = CORE.units.getMulti("tf");
                            break;
                        case "T":
                            multi = CORE.units.getMulti("T");
                            break;
                    }
                    switch (VIEWUI.viewOptions.unitMomentDistanceResults()) {
                        case "mm":
                            multi2 = CORE.units.getMulti("mm");
                            break;
                        case "cm":
                            multi2 = CORE.units.getMulti("cm");
                            break;
                        case "ft":
                            multi2 = CORE.units.getMulti("ft");
                            break;
                        case "inch":
                            multi2 = CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "DistLoad": // Default "N/m"
                    switch (VIEWUI.viewOptions.unitForce()) {
                        case "daN":
                            multi = CORE.units.getMulti("daN");
                            break;
                        case "kG":
                            multi = CORE.units.getMulti("kG");
                            break;
                        case "kgf":
                            multi = CORE.units.getMulti("kgf");
                            break;
                        case "kip":
                            multi = CORE.units.getMulti("kip");
                            break;
                        case "kN":
                            multi = CORE.units.getMulti("kN");
                            break;
                        case "lbf":
                            multi = CORE.units.getMulti("lbf");
                            break;
                        case "MN":
                            multi = CORE.units.getMulti("MN");
                            break;
                        case "tonfUS":
                            multi = CORE.units.getMulti("tonfUS");
                            break;
                        case "tf":
                            multi = CORE.units.getMulti("tf");
                            break;
                        case "T":
                            multi = CORE.units.getMulti("T");
                            break;
                    }
                    switch (VIEWUI.viewOptions.unitMomentDistance()) {
                        case "mm":
                            multi2 = 1 / CORE.units.getMulti("mm");
                            break;
                        case "cm":
                            multi2 = 1 / CORE.units.getMulti("cm");
                            break;
                        case "ft":
                            multi2 = 1 / CORE.units.getMulti("ft");
                            break;
                        case "inch":
                            multi2 = 1 / CORE.units.getMulti("inch");
                            break;
                    }
                    break;
                case "Pressure": // Default "N*m"
                    switch (VIEWUI.viewOptions.unitPressureForce()) {
                        case "daN":
                            multi = CORE.units.getMulti("daN");
                            break;
                        case "kG":
                            multi = CORE.units.getMulti("kG");
                            break;
                        case "kgf":
                            multi = CORE.units.getMulti("kgf");
                            break;
                        case "kip":
                            multi = CORE.units.getMulti("kip");
                            break;
                        case "kN":
                            multi = CORE.units.getMulti("kN");
                            break;
                        case "lbf":
                            multi = CORE.units.getMulti("lbf");
                            break;
                        case "MN":
                            multi = CORE.units.getMulti("MN");
                            break;
                        case "tonfUS":
                            multi = CORE.units.getMulti("tonfUS");
                            break;
                        case "tf":
                            multi = CORE.units.getMulti("tf");
                            break;
                        case "T":
                            multi = CORE.units.getMulti("T");
                            break;
                    }
                    switch (VIEWUI.viewOptions.unitPressureSurface()) {
                        case "mm2":
                            multi2 = 1 / (CORE.units.getMulti("mm") * CORE.units.getMulti("mm"));
                            break;
                        case "cm2":
                            multi2 = 1 / (CORE.units.getMulti("cm") * CORE.units.getMulti("cm"));
                            break;
                        case "ft2":
                            multi2 = 1 / (CORE.units.getMulti("ft") * CORE.units.getMulti("ft"));
                            break;
                        case "inch2":
                            multi2 = 1 / (CORE.units.getMulti("inch") * CORE.units.getMulti("inch"));
                            break;
                    }
                    break;
                case "mm": // always mm
                    multi = CORE.units.getMulti("mm");
                    break;
            }
        }
    };

    updaateMultipliers();

    //    if ((!isEmpty(min) || !isEmpty(max)) && !element) { console.error("You must pass '$element' as a 5th element of the convertUnits function for min/max to work"); }

    if (!isEmpty(min))
        $(element).attr('min', min / multi);

    if (!isEmpty(max))
        $(element).attr('max', max / multi);

    if (typeof model === "function") {
        view = ko.observable(Number(model()) / multi / multi2);
        view.subscribe(function () {
            updaateMultipliers();
            if (view() !== FormatPrecisionResults(Number(_model()) / multi / multi2, type)) {
                _model(view() * multi * multi2);
            }
        });
        view(FormatPrecisionResults(Number(_model()) / multi / multi2, type));
    } else {
        view = FormatPrecisionResults(model / multi / multi2, type);
    }
    return view;
};

FormatPrecisionResults = function (value, type) {
    var num = 0;
    switch (type) {
        case "Distance":
            num = value.toFixed(VIEWUI.viewOptions.unitDistancePrecisionResults());
            break;
        case "Force":
            num = value.toFixed(VIEWUI.viewOptions.unitForcePrecisionResults());
            break;
        case "Moment":
            num = value.toFixed(VIEWUI.viewOptions.unitMomentPrecisionResults());
            break;
        case "Pressure":
            num = value.toFixed(VIEWUI.viewOptions.unitPressurePrecision());
            break;
        case "Angle":
            num = value.toFixed(VIEWUI.viewOptions.unitAnglePrecision());
            break;
        case "Utilization":
            num = value.toFixed(VIEWUI.viewOptions.unitUtilizationPrecision());
            break;
        case "Displacement":
            num = value.toFixed(VIEWUI.viewOptions.unitDisplacementPrecision());
            break;
        case "Stress":
            num = value.toFixed(VIEWUI.viewOptions.unitStressPrecision());
            break;
        case "DistLoad":
            num = value.toFixed(2);
            break;
        case "mm":
            num = value.toFixed(1);
    }
    return num;
};