﻿var CORE = CORE || {};
CORE.webApiManager = {
    saveToDbUsingProtoBuf: function (systemId, constructionModel, preferencesJson, versionName, mode, callback, errorCallback) {
        CORE.model.pendingSave = {
            systemId: systemId,
            userId: CORE.options.userId,
            userName: CORE.options.userName,
            versionName: versionName,
            model: constructionModel,
            subProjectId: window.subProjectId,
            preferences: preferencesJson,
            constraintsMode: !isEmpty(mode) && !isEmpty(mode.mode) ? mode.mode : 0,
            language: CORE.options.language,
            isDemoMode: CORE.options.demoMode
        };
        CORE.model.pendingSave.model.typicalId = window.constructionData.typicalId;
        CORE.model.pendingSave.model.system = window.constructionData.system;
        CORE.model.pendingSave.model.corrosion = window.constructionData.corrosion;
        CORE.model.pendingSave.model.seismic = window.constructionData.seismic;
        CORE.model.pendingSave.model.id = window.constructionData.id;
        CORE.model.pendingSave.model.jobId = window.constructionData.jobId;
        if (!CORE.model.waitingForResponse()) {
            var url = apiUri + "ConstructionViewerStorage/Save";


            console.log("Before request");
            VIEWUI.statusBar.startLoading(LOADING_MODE.SAVE);
            CORE.model.waitingForResponse(true);
            $.ajax({
                    url: HandleRequestUrl(url, ''),
                    method: "POST",
                    beforeSend: AddHeadersToRequest,
                    data: JSON.stringify(CORE.model.pendingSave), // order is the same as of parameters in the method
                    contentType: "application/json",
                    dataType: "json",
                    subProjectId: window.subProjectId
                })
                .done(function (data) {
                    console.info("request succeeded");
                    if (!isEmpty(callback)) {
                        callback(data);
                    }
                })
                .always(function (data, textStatus, jqXhr) {
                    // remove loading image maybe
                    console.log(data);
                    if (!isEmpty(data.SavedModel)) {
                        console.log(data.SavedModel);
                    }
                    if (typeof data.responseText !== 'undefined') {
                        console.log(data.responseText);
                    }
                    if (textStatus !== 'success') {
                        console.log(textStatus);
                        console.log(jqXhr);
                    }
                    VIEWUI.statusBar.stopLoading();
                    CORE.model.waitingForResponse(false);
                })
                .fail(function () {
                    console.warn("request failed");
                    if (!isEmpty(errorCallback)) {
                        errorCallback();
                    }
                });
        }
    },
    loadFromDb: function (appId, projId, jobId, sysId, versionId, callback, errorCallback) {
        var url = apiUri + "ConstructionViewerStorage/Load";
        console.log("Before request");
        VIEWUI.statusBar.startLoading();
        $.ajax({
            url: HandleRequestUrl(url, ''),
            beforeSend: AddHeadersToRequest,
            method: "POST",
            data: JSON.stringify({
                b64string: "",
                jobId: 0,
                systemId: 0,
                versionId: 0,
                subProjectId: window.subProjectId
            }),
            dataType: "json",
            contentType: "application/json"
        }).done(function (data) {
            console.info("request succeeded");
            window.constructionData = data.constructionData;
            callback(data);
        }).always(function (data, textStatus, jqXhr) {
            // remove loading image maybe
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            }
            VIEWUI.statusBar.stopLoading();
        }).fail(function () {
            console.warn("request failed");
            if (!isEmpty(errorCallback)) {
                errorCallback();
            }
        });
    },
    getLayersFromDxf: function (dxf, callback) {
        var model = {
            dxf: dxf
        };
        var json = JSON.stringify(model);
        var url = "/api/ConstructionViewerStorage/GetLayersFromDxf";

        console.log("CORE.webApiManager.getLayersFromDxf: Before request");
        $.ajax({
            url: url,
            method: "POST",
            data: json,
            dataType: "json",
            contentType: "application/json"
        }).done(function (data) {
            console.info("CORE.webApiManager.getLayersFromDxf: request succeeded");
            //execute callback
            callback(data);
        }).always(function (data, textStatus, jqXhr) {
            // remove loading image maybe
            console.log(data);
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            }
        }).fail(function () {
            console.warn("CORE.webApiManager.getLayersFromDxf: request failed");
        });
    },
    importDxfToDb: function (dxf, appId, projId, jobId, selectedLayers) {
        var model = {
            dxf: dxf,
            appId: appId,
            projId: projId,
            jobId: jobId,
            selectedLayers: selectedLayers
        };
        var json = JSON.stringify(model);
        var url = "/api/ConstructionViewerStorage/Import";

        console.log("Before request");
        $.ajax({
            url: url,
            method: "POST",
            data: json,
            dataType: "json",
            contentType: "application/json"
        }).done(function () {
            console.info("request succeeded");
            //lets load it!
            CORE.webApiManager.loadFromDb(CORE.options.appId, CORE.options.projId, CORE.options.jobId, CORE.options.systemId);
        }).always(function (data, textStatus, jqXhr) {
            // remove loading image maybe
            console.log(data);
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            }
        }).fail(function () {
            console.warn("request failed");
        });
    },
    downloadZipFiles: function (model) {
        var div = document.getElementById('dxfLoader');
        div.style.display = 'block';
        VIEWUI.toolbar.generateAnalysisInProgress = true;
        var info = {
            model: model,
            subProjectId: window.subProjectId
        };
        var url = apiUri + "ConstructionViewerStorage/GenerateZipFiles";
        info.model.typicalId = window.constructionData.typicalId;
        info.model.system = window.constructionData.system;
        info.model.corrosion = window.constructionData.corrosion;
        info.model.seismic = window.constructionData.seismic;
        info.model.id = window.constructionData.id;
        info.model.jobId = window.constructionData.jobId;
        var windowUrl = window.URL || window.webkitURL;
        $.ajax({
            url: HandleRequestUrl(url, ''),
            beforeSend: AddHeadersToRequest,
            method: "POST",
            data: JSON.stringify(info),
            // accepts: {
            //     zip: 'application/octet-stream'
            // },
            // dataType: "zip",
            contentType: "application/json",
        }).done(function (taskInfo) {
            CORE.webApiManager.waitForTaskEnd(taskInfo.taskKey, () => {
                var div = document.getElementById('dxfLoader');
                div.style.display = 'none';
                VIEWUI.toolbar.generateAnalysisInProgress = false;
                CORE.parentWindowOpen(HandleRequestUrl(apiUri + "ConstructionViewerStorage/DownloadZipFiles") + "?taskKey=" + taskInfo.taskKey);
            });
        }).fail(function (xhr) {
            alert("Can not download calculation files");
        });
    },
    waitForTaskEnd: function (taskKey, onDone, onError, checkCancelToken) {
        var url = apiUri + "ConstructionViewerStorage/AsyncTaskStatus";
        var taskEnded = false;
        const startViewerTask = setInterval(() => {
            if (!taskEnded) {
                $.ajax({
                    url: HandleRequestUrl(url, "?taskKey=" + taskKey),
                    beforeSend: AddHeadersToRequest,
                    method: "GET",
                    dataType: "json",
                    contentType: "application/json"
                }).done(function () {}).always(function (taskInfo, textStatus, jqXhr) {
                    if (!isEmpty(checkCancelToken) && checkCancelToken()) {
                        clearInterval(startViewerTask);
                        taskEnded = true;
                        console.log(taskKey + " - task canceled");
                        if (!isEmpty(onError)) {
                            onError();
                        }
                    }

                    if (!taskEnded) {
                        if (taskInfo.status == "Done") {
                            clearInterval(startViewerTask);
                            taskEnded = true;
                            console.log(taskKey + " - task done");
                            if (!isEmpty(onDone)) {
                                onDone();
                            }
                        } else if (taskInfo.status == "Error" || taskInfo.status == "NotFound") {
                            clearInterval(startViewerTask);
                            taskEnded = true;
                            console.log(taskKey + " - task error");
                            if (!isEmpty(onError)) {
                                onError();
                            }
                        } else {
                            console.log(taskKey + " - task in progress");
                        }
                    }

                }).fail(function () {
                    clearInterval(startViewerTask);
                    taskEnded = true;
                    if (!isEmpty(onError)) {
                        onError();
                    }
                })
            }
        }, 1000);
    },
    getCalculationResult: function (taskKey, onDone, onError) {
        var url = apiUri + "ConstructionViewerStorage/GetCalculation";
        $.ajax({
            url: HandleRequestUrl(url, "?taskKey=" + taskKey),
            beforeSend: AddHeadersToRequest,
            method: "GET",
            dataType: "json",
            contentType: "application/json"
        }).done(function () {}).always(function (data, textStatus, jqXhr) {
            if (!isEmpty(onDone)) {
                onDone(JSON.parse(data));
            }
        }).fail(function () {
            if (!isEmpty(onError)) {
                onError();
            }
        });
    },
    cancelCalculationToken: false,
    startCalculation: function (model, callback, errorCallback) {
        CORE.webApiManager.cancelCalculationToken = false;
        var info = {
            model: model,
            subProjectId: window.subProjectId
        };
        var url = apiUri + "ConstructionViewerStorage/StartCalculation";
        info.model.typicalId = window.constructionData.typicalId;
        info.model.system = window.constructionData.system;
        info.model.corrosion = window.constructionData.corrosion;
        info.model.seismic = window.constructionData.seismic;
        info.model.id = window.constructionData.id;
        info.model.jobId = window.constructionData.jobId;
        console.log("Before request");
        $.ajax({
            url: HandleRequestUrl(url, ''),
            beforeSend: AddHeadersToRequest,
            method: "POST",
            data: JSON.stringify(info),
            dataType: "json",
            contentType: "application/json"
        }).done(function (taskInfo) {
            CORE.webApiManager.waitForTaskEnd(taskInfo.taskKey, () => CORE.webApiManager.getCalculationResult(taskInfo.taskKey, callback, errorCallback), errorCallback, () => CORE.webApiManager.cancelCalculationToken)
        }).fail(function (data) {
            if (!isEmpty(errorCallback)) {
                errorCallback(data);
            }
        });
    },
    checkProgress: function (appId, projId, jobId, callback, errorCallback) {
        var info = {
            appId: appId,
            jobId: jobId,
            projId: projId
        };
        var url = "/api/ConstructionViewerStorage/CheckProgress";

        console.log("Before request");
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify(info),
            dataType: "json",
            contentType: "application/json"
        }).done(function (data) {
            console.info("request succeeded");
            callback(data.percentage, data.status, data.exceptions);
        }).always(function (data, textStatus, jqXhr) {
            console.log(data);
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            }
        }).fail(function (data) {
            console.warn("request failed");
            if (!isEmpty(errorCallback)) {
                errorCallback(data);
            }
        });
    },
    stopCalculation: function (appId, projId, jobId) {
        var info = {
            appId: appId,
            jobId: jobId,
            projId: projId
        };
        var url = "/api/ConstructionViewerStorage/StopCalculation";

        console.log("Before request");
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify(info),
            dataType: "json",
            contentType: "application/json"
        }).done(function () {
            console.info("request succeeded");
        }).always(function (data, textStatus, jqXhr) {
            console.log(data);
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            }
        }).fail(function () {
            console.warn("request failed");
        });
    },
    showAnalysisDocumentation: function () {
        let subId = window.constructionData.jobId;
        var url = apiUri + "ConstructionViewerStorage/GetAnalysisDocumentation";
        $.ajax({
            url: HandleRequestUrl(url, "?subId=" + subId),
            beforeSend: AddHeadersToRequest,
            method: "GET",
            dataType: "json",
            contentType: "application/json"
        }).done(function () {
            console.info("request succeeded");
        }).always(function (data, textStatus, jqXhr) {
            let content = data.responseText.replace(/\n/g, "<br />");
            var wnd = window.open("about:blank", "", "_blank");
            wnd.document.write(content);
        }).fail(function () {
            console.warn("request failed");
        });
    },
    importResults: function (appId, projId, jobId, callback, errorCallback) {
        var info = {
            appId: appId,
            jobId: jobId,
            projId: projId
        };
        var url = "/api/ConstructionViewerStorage/ImportResults";

        console.log("Before request");
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify(info),
            dataType: "text",
            contentType: "application/json"
        }).done(function (data) {
            console.info("request succeeded");
            if (data !== null && typeof data !== 'undefined') {
                callback(data.substring(1, data.length - 1));
            } else {
                console.error("ImportResults method returned no data");
                VIEWUI.statusBar.setError("Calculation succeeded, but no results data returned");
                return;
            }
        }).always(function (data, textStatus, jqXhr) {
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            };
        }).fail(function () {
            console.warn("request failed");
            if (!isEmpty(errorCallback)) {
                errorCallback();
            }
        });
    },
    importUnitsData: function (callback, errorCallback) {

        if (CORE.options.disableLoadAndSave) {
            callback('{"m":1.0,"N":1.0,"Rad":1.0,"kg":1.0,"MPa":1000000.0,"psi":0.000139999999999999,"psf":0.02088,"%":0.01,"-":1.0,"mm":0.001,"cm":0.01,"ft":0.3048,"inch":0.0254,"daN":10.0,"kG":9.80665,"kgf":9.80665,"kip":4448.2216152605,"kN":1000.0,"lbf":4.4482216152605,"MN":1000000.0,"tonfUS":8896.443230521,"tf":9806.65,"T":9806.65,"°":0.017453292,"Grad":0.01570796326795,"mg":9.99999999999E-07,"g":0.001,"dkg":0.01,"t":1000.0,"oz":0.028349523,"lb":0.45359237,"tonUS":907.18474,"kPa":1000.0}');
            return;
        }
        var url = apiUri + "units/get";

        console.log("Before request");
        $.ajax({
            url: HandleRequestUrl(url, ''),
            beforeSend: AddHeadersToRequest,
            method: "GET",
            dataType: "json",
            contentType: "application/json"
        }).done(function (data) {
            console.info("request succeeded");
            if (data === null) {
                console.error("ImportUnitsData method returned no data");
            }
            callback(data);
        }).always(function (data, textStatus, jqXhr) {
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            };
        }).fail(function () {
            console.warn("request failed");
            if (!isEmpty(errorCallback)) {
                errorCallback();
            }
        });
    },
    /*exportPreferences: function(preferences, appId, projId, jobId, callback, errorCallback) {
        var info = {
            appId: appId,
            jobId: jobId,
            projId: projId,
            preferences: preferences
        };
        var url = "/api/ConstructionViewerStorage/SetSystemPreferences";

        console.log("Before request ExportPreferences");
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify(info),
            dataType: "text",
            contentType: "application/json"
        }).done(function(data) {
            console.info("request succeeded");
            if (data === null) {
                console.error("ExportPreferences method returned no data");
            }
            callback(data);
        }).always(function(data, textStatus, jqXhr) {
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            };
        }).fail(function() {
            console.warn("request failed ExportPreferences");
            if (!isEmpty(errorCallback)) {
                errorCallback();
            }
        });
    },*/
    /*importPreferences: function(appId, jobId, projId, callback, errorCallback) {
        var info = {
            appId: appId,
            jobId: jobId,
            projId: projId
        };
        var url = "/api/ConstructionViewerStorage/GetSystemPreferences";

        console.log("Before request");
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify(info),
            dataType: "json",
            contentType: "application/json"
        }).done(function(data) {
            console.info("request succeeded");
            if (data === null) {
                console.error("ImportPreferences method returned no data");
            }
            callback(data);
        }).always(function(data, textStatus, jqXhr) {
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined') {
                console.log(data.responseText);
            }
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            };
        }).fail(function() {
            console.warn("request failed");
            if (!isEmpty(errorCallback)) {
                errorCallback();
            }
        });
    },*/
    importVersionList: function (appId, projId, jobId, callback, errorCallback) {
        var info = {
            appId: appId,
            projId: projId,
            jobId: jobId
        };
        var url = "/api/ConstructionViewerStorage/ImportVersionList";

        console.log("Before request");
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify(info),
            dataType: "json",
            contentType: "application/json"
        }).done(function (data) {
            console.info("request succeeded");
            if (data === null) {
                console.error("ImportVersionList method returned no data");
            }
            callback(data);
        }).always(function (data, textStatus, jqXhr) {
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined')
                console.log(data.responseText);
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            };
        }).fail(function () {
            console.warn("request failed");
            if (!isEmpty(errorCallback)) {
                errorCallback();
            }
        });
    },
    deleteVersion: function (appId, projId, jobId, versionId, callback, errorCallback) {
        var info = {
            appId: appId,
            projId: projId,
            jobId: jobId,
            versionId: versionId
        };
        var url = "/api/ConstructionViewerStorage/DeleteVersion";

        console.log("Before request");
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify(info),
            dataType: "json",
            contentType: "application/json"
        }).done(function (data) {
            console.info("request succeeded");
            if (data === null) {
                console.error("DeleteVersion method returned no data");
            }
            callback(data);
        }).always(function (data, textStatus, jqXhr) {
            if (data !== null && typeof data !== 'undefined' && typeof data.responseText !== 'undefined')
                console.log(data.responseText);
            if (textStatus !== 'success') {
                console.log(textStatus);
                console.log(jqXhr);
            };
        }).fail(function () {
            console.warn("request failed");
            if (!isEmpty(errorCallback)) {
                errorCallback();
            }
        });
    },
    uploadDataToServer: function (data, onComplete) {
        CORE.webApiManager.uploadDataPartToServerHelper(data, 0, null, onComplete);
    },
    uploadDataPartToServerHelper(data, part, fileKey, onComplete) {
        var partSize = 2 * 1000 * 1000;
        if (data.length > part * partSize) {
            partData = data.substr(part * partSize, partSize);
            CORE.webApiManager.uploadDataPartToServer(partData, part, fileKey, (fileKey) => {
                CORE.webApiManager.uploadDataPartToServerHelper(data, part + 1, fileKey, onComplete);
            });
        } else {
            onComplete(fileKey);
        }
    },
    uploadDataPartToServer: function (data, part, fileKey, onComplete) {
        var filePart = {
            fileKey: fileKey,
            part: part,
            data: data
        };
        var url = apiUri + "ConstructionViewerStorage/UploadFilePart";

        console.log("Uploading file, part: " + part);
        $.ajax({
            url: HandleRequestUrl(url, ''),
            method: "POST",
            beforeSend: AddHeadersToRequest,
            data: JSON.stringify(filePart),
            dataType: "json",
            contentType: "application/json"
        }).done(function (fileKey) {
            console.log("Uploaded file, part: " + part);
            onComplete(fileKey);
        });
    },
    getStpFile: function (stpId, callback) {
        var url = apiUri + "ProtoStpFile";
        $.ajax({
            url: HandleRequestUrl(url, '?id=' + stpId),
            method: "GET",
            beforeSend: AddHeadersToRequest
        }).done(function (stp) {
            console.log("Stp file loaded");
            callback(stp);
        });
    },
    getDoubleStpFile: function (stpId, callback) {
        var url = apiUri + "ProtoDoubleStpFile";
        $.ajax({
            url: HandleRequestUrl(url, '?id=' + stpId),
            method: "GET",
            beforeSend: AddHeadersToRequest
        }).done(function (stp) {
            console.log("Double Stp file loaded");
            callback(stp);
        });
    },
    getConfig: function (stpId, type, callback) {
        if (type === "PIPE_RING") {
            conf = null;
            callback(conf);
        } else {
            var url = apiUri + "getConfigurationData";
            $.ajax({
                url: HandleRequestUrl(url, '?id=' + stpId + '&type=' + type),
                method: "GET",
                beforeSend: AddHeadersToRequest
            }).done(function (conf) {
                console.log("Configuration loaded for " + type);
                callback(conf);
            });
        }

    },
    getVariantConfig: function (variantId, type, callback) {
        var url = apiUri + "getVariantConfigurationData";
        $.ajax({
            url: HandleRequestUrl(url, '?id=' + variantId + '&type=' + type),
            method: "GET",
            beforeSend: AddHeadersToRequest
        }).done(function (conf) {
            console.log("Configuration loaded for variant of " + type);
            callback(conf);
        });
    },
    postCrossSectionConfig: function (data, callback) {
        var url = apiUri + "postCrossSectionConfigurationData";
        $.ajax({
            url: HandleRequestUrl(url, ''),
            method: "POST",
            beforeSend: AddHeadersToRequest,
            data: JSON.stringify({
                id: data._id,
                data: data
            }),
            dataType: "json",
            contentType: "application/json"
        }).done(function () {
            console.log("Configuration saved for cross section");
            callback();
        });
    },
    postConnectorConfig: function (data, callback) {
        var url = apiUri + "postConnectorConfigurationData";
        $.ajax({
            url: HandleRequestUrl(url, ''),
            method: "POST",
            beforeSend: AddHeadersToRequest,
            data: JSON.stringify({
                id: data._id,
                data: data
            }),
            dataType: "json",
            contentType: "application/json"
        }).done(function () {
            console.log("Configuration saved for connector");
            callback();
        });
    },
    updateViewerModel: function (id, itemType, base64Obj, base64ObjDouble, callback) {
        var url = apiUri + "updateViewerModel";
        $.ajax({
            url: HandleRequestUrl(url, ''),
            method: "POST",
            beforeSend: AddHeadersToRequest,
            data: JSON.stringify({
                id: id,
                base64Obj: base64Obj,
                itemType: itemType,
                base64ObjDouble : base64ObjDouble
            }),
            dataType: "json",
            contentType: "application/json"
        }).done(function () {
            console.log("Viewer model updated");
            callback();
        });
    },
    getAllCrossSectionConfigs: function (callback) {
        var url = apiUri + "GetAllCrossSectionConfigs";
        $.ajax({
            url: HandleRequestUrl(url, ''),
            method: "GET",
            beforeSend: AddHeadersToRequest
        }).done(function (confs) {
            console.log("CrossSection configurations were loaded");
            callback(confs);
        });
    },
    executeLightConstraints: function (data, callback) {
        var url = constraintsUri + "Light";
        $.ajax({
                url: HandleRequestUrl(url, ''),
                method: "POST",
                beforeSend: AddHeadersToRequest,
                data: JSON.stringify(data),
                contentType: "application/json",
                dataType: "json",
                subProjectId: window.subProjectId
            })
            .done(function (d) {
                console.info("request succeeded");
                callback(d);
            });
    }
};