﻿// valueObservable =  value to convert (observable)
// valueRelative = viewModel observable (relative)
// mode = true - to absolute, false - to relative
convertX = function(valueObservable, valueRelative, mode, barLength) {
    var x;
    var value = ko.unwrap(valueObservable);
    switch (ko.unwrap(mode)) {
    case true:
    { // relative -> absolute
        var needValidationUpdate = false;
        if (value < 0) {
            value = 0;
            needValidationUpdate = true;
        } // validate relative value
        if (value > 100) {
            value = 100;
            needValidationUpdate = true;
        }
        x = barLength * (value / 100); // only return absolute value
        if (needValidationUpdate && ko.isObservable(valueObservable)) {
            valueObservable(value); // set relative value after validation (only needed when relative value from input was incorrect)
        }
        break;
    }
    case false:
    { // absolute -> relative
        x = (value / barLength) * 100;
        x = +x.toFixed(2); // round to 2 decimal places
        if (!isEmpty(valueRelative) && ko.isObservable(valueRelative)) {
            valueRelative(x); // set relative observable
        }
        break;
    }
    default:
        break;
    }
    if (isEmpty(x)) {
        throw new Error("calculated x is empty");
    }
    return x;
}