var Extension = Extension || {};
Extension.LightConstraintsExecutorCache = null;
Extension.LightConstraintsExecutor = function() {

    //Extension.prepareFullConnectorConfiguration();
    //Extension.currentConnectorCrossSectionsConfig
    this.execute = function(connectorConfig, variantConfig, callback) {
        var self = this;
        if(Extension.LightConstraintsExecutorCache === null) {
            CORE.webApiManager.getAllCrossSectionConfigs(d => {
                Extension.LightConstraintsExecutorCache = d;
                self.actualExecute(connectorConfig, variantConfig, callback);
            });
        } else {
            self.actualExecute(connectorConfig, variantConfig, callback);
        }
    };

    this.actualExecute = function(connectorConfig, variantConfig, callback) {
        connectorConfig.isBase = Extension.stpItemType === "BASE";
        connectorConfig.armList = connectorConfig.arms;
        for (var j = 0; j < connectorConfig.armList.length; j++) {
            var arm = connectorConfig.armList[j];
            arm.id = j + 1;
        }
        connectorConfig.profileList = [];
        for (var j = 0; j < variantConfig.arms.length; j++) {
            var arm = variantConfig.arms[j];
            var wasFound = false;
            for (var k = 0; k < arm.crossSections.length; k++) {
                var cs = arm.crossSections[k];
                if(cs.isShown) {
                    cs.config = this.findCrossSectionConfig(cs.crossSectionId);
                    connectorConfig.profileList.push(cs);
                    wasFound = true;
                    break;
                }
            }
            if(!wasFound) connectorConfig.profileList.push(null);
        }

        CORE.webApiManager.executeLightConstraints(connectorConfig, callback);
    };

    this.findCrossSectionConfig = function(crossSectionId) {
        for (var j = 0; j < Extension.LightConstraintsExecutorCache.length; j++) {
            var element = Extension.LightConstraintsExecutorCache[j];
            if(element._id === crossSectionId) return element.config;
        }
        return null;
    }
}