var ExtensionInterface = ExtensionInterface || {};

ExtensionInterface.getArms = function() {
    return Extension.arms;
}

ExtensionInterface.getPossibleArmDirections = function() {
    return Extension.possibleArmDirections;
}

ExtensionInterface.getPossibleReleaseCodes = function() {
    return Extension.possibleReleaseCodes;
}

ExtensionInterface.changeArmDirection = function(armDefinition, dirId) {
    Extension.changeArmDirection(armDefinition, dirId);
    ExtensionInterface.setDistances(armDefinition, Extension.calculateArmSize(armDefinition, Extension.connectorMeshes));
    render();
}

ExtensionInterface.setDistances = function(armDef, calculations) {
    armDef.config.distances = calculations.distances;
    armDef.baseX = calculations.versors.baseX;
    armDef.baseY = calculations.versors.baseY;
    armDef.baseZ = calculations.versors.baseZ;
}

ExtensionInterface.removeArmDefintion = function(armDefinition) {
    Extension.removeArmDefintion(armDefinition);
    Extension.removeArmData(armDefinition.id);
    render();
}

ExtensionInterface.createEmptyArm = function() {
    var id = Extension.createEmptyArm();
    Extension.createEmptyArmData(id);
}

ExtensionInterface.prepareFullConnectorConfiguration = function() {
    return Extension.prepareFullConnectorConfiguration();
}

ExtensionInterface.setOrientationAndPositionOfModel = function(armsTranslationVector){
     Extension.armsTranslationVector = armsTranslationVector;
}

ExtensionInterface.rewriteArms = function(){
    Extension.rewriteArms();
}

ExtensionInterface.getConnectorCrossSectionsConfig = function() {
    if(Extension.currentConnectorCrossSectionsConfig === null) {
        Extension.currentConnectorCrossSectionsConfig = Extension.getConnectorCrossSectionsConfig();
    }
    return Extension.currentConnectorCrossSectionsConfig;
}

ExtensionInterface.createEmptyConnectorCrossSection = function(arm, groupId) {
    Extension.createEmptyConnectorCrossSection(arm, groupId);
}

ExtensionInterface.changeShownCrossSection = function(arm, crossSection, groupId) {
    if(crossSection.crossSectionId === null) return;
    Extension.changeCrossSectionIsShown(crossSection, arm);
    //Extension.showCrossSectionForArm(crossSection, arm);
    Extension.executeLightConstraints(groupId);
}

ExtensionInterface.removeCrossSectionForArm = function(arm, crossSection) {
    if(crossSection.isShown === true) {
        Extension.removeCrossSectionForArm(arm, crossSection);
    }
}

ExtensionInterface.verifyArmDefinitionForProfileConfiguration = function(groupId) {
    var id = groupId - 1;
    if(Extension.currentConnectorCrossSectionsConfig === null) return true;
    if(Extension.currentConnectorCrossSectionsConfig.armGroups[id] === undefined) {
        console.log("verifyArmDefinitionForProfileConfiguration ERROR : groupId - 1 " + id);
    }
    return Extension.currentConnectorCrossSectionsConfig.armGroups[id].arms.length === Extension.arms.length;
}

ExtensionInterface.resetConnectorCrossSectionsConfig = function() {
    Extension.currentConnectorCrossSectionsConfig = Extension.getConnectorCrossSectionsConfig();
    Extension.clearConnectorCrossSectionVisualisation();
}

ExtensionInterface.showConnectorCrossSections = function(groupId) {
    if(Extension.currentConnectorCrossSectionsConfig !== null) {
        Extension.clearConnectorCrossSectionVisualisation();
        Extension.showConnectorCrossSectionVisualisation(groupId);
        render();
    }
}

ExtensionInterface.hideConnectorCrossSections = function() {
    if(Extension.currentConnectorCrossSectionsConfig !== null) {
        Extension.clearConnectorCrossSectionVisualisation();
        render();
    }
}

ExtensionInterface.createEmptyArmGroup = function(groupId) {
    Extension.createEmptyArmGroup(groupId);
}

ExtensionInterface.removeArmGroup = function(armGroup) {
    Extension.removeArmGroup(armGroup);
}

ExtensionInterface.armsTranslationVector = ko.observable();
ExtensionInterface.loadingCompleated = ko.observable().extend({ rateLimit: 10 });