﻿KEYCODES = {
    ENTER: 13,
    CTRL: 17,
    DELETE: 46,
    ESC: 27,
    A: 65,
    Z: 90,
    Y: 89
}

HELPERS.inputState = (function () {
    return {
        selectMultiple: false,
        isRightClicked: false,
        onKeyDownListenerEnabled: false,
        onKeyDown: function (event) {
            console.log("HELPERS.inputState.onKeyDown");
            if (event.keyCode === KEYCODES.CTRL) {
                HELPERS.inputState.selectMultiple = true;
            }
            if (event.keyCode === KEYCODES.DELETE) {
                if(CORE.whichViewerTab === "geometry" || CORE.whichViewerTab === "loads")
                    CORE.model.removeObjects(CORE.model.selectedObjects);
            }
            if (event.keyCode === KEYCODES.A && event.ctrlKey) {
                event.preventDefault();
                CORE.model.selectAll();
            }
            if (event.keyCode === KEYCODES.Z && event.ctrlKey) {
                event.preventDefault();
                CORE.constructionUndoRedo.undo();
            }
            if (event.keyCode === KEYCODES.Y && event.ctrlKey) {
                event.preventDefault();
                CORE.constructionUndoRedo.redo();
            }
            render();
        },
        onKeyUp: function (event) {
            if (event.keyCode === KEYCODES.CTRL) {
                HELPERS.inputState.selectMultiple = false;
            }
            if (event.keyCode === KEYCODES.ESC && CORE.mode() !== MODE.EDIT &&  CORE.mode() !== MODE.MOVE_CONSTRUCTION) {


                VIEWUI.toolbar.switchMode(MODE.SELECT);
                if (CORE.options.mode === "HILTI") {
                    VIEWUI.viewModel.propertiesVisible(false);
                    VIEWUI.viewModel.definitionVisible(false);
                    CORE.view3D.drawRecOpening.hideHelper();
                    CORE.view3D.drawCircleOpening.hideHelper();
                    CORE.view2DLeft.drawRecOpening.hideHelper();
                    CORE.view2DLeft.drawCircleOpening.hideHelper();
                } else {
                    VIEWUI.viewModel.popupMode(null);
                }
                CORE.model.deselectAll();
            }
        },
        onInputFocus: function (event) {
            console.log("HELPERS.inputState.onInputFocus");
            if(HELPERS.inputState.onKeyDownListenerEnabled) {
                document.removeEventListener('keydown', HELPERS.inputState.onKeyDown);
                HELPERS.inputState.onKeyDownListenerEnabled = false;
            }
        },
        onInputBlur: function () {
            console.log("HELPERS.inputState.onInputBlur");
            if (!HELPERS.inputState.onKeyDownListenerEnabled) {
                document.addEventListener('keydown', HELPERS.inputState.onKeyDown);
                HELPERS.inputState.onKeyDownListenerEnabled = true;
            }
        },
        onViewerMouseOver: function (event) {
            event.preventDefault();
        },
        //onViewerScroll: function (event) {
        //}
    }
})();
//init
document.addEventListener('keydown', HELPERS.inputState.onKeyDown);
//document.addEventListener('keyup', HELPERS.inputState.onKeyUp);
$(document).on('focus', 'input', {}, HELPERS.inputState.onInputFocus);
$(document).on('blur', 'input', {}, HELPERS.inputState.onInputBlur);
//$(document).on('wheel', HELPERS.inputState.onViewerScroll);