﻿jQuery.fn.extend({
    constructionViewer: function(options) {
        VIEWER_OPTIONS = options;

        subProjectId = options.subProjectId;
        apiUri = options.apiUri;
        constraintsUri = options.constraintsUri;
        authData = options.authData;
        viewerLoadingStart = options.viewerLoadingStart;
        angularEnvName = options.angularEnvName;

        console.log("CONSTRUCTION VIEWER loader: Begin");
        if (!this.length) {
            console.error("CONSTRUCTION VIEWER loader: Target element provided in jquery extend function does not exist!");
        } else {
            console.log("CONSTRUCTION VIEWER loader: preparing container");
            if (typeof options.width === 'undefined') {
                options.width = '100%';
            }
            if (typeof options.height === 'undefined') {
                options.height = '100%';
            }
            var viewerContainerOuter = this;
            viewerContainerOuter.empty();
            viewerContainerOuter.width(options.width);
            //viewerContainerOuter.height(options.height);
            //viewerContainerOuter.css('position', 'relative');
            viewerContainerOuter.append(
                "<div id='loadingLabel' class='loadingLabel' style='height: " + options.height + "; width: " + options.width + "'>" +
                "<div class='loading-container'>" +
                    "<div class='loading-title'><img height=\"40\" src=\"../../assets/images/hilti-logo.svg\"></div>" +
                    "<span class='loader darkLoader mainViewerLoader'>" +
                        "<span class='bounce1'></span>" +
                        "<span class='bounce2'></span>" +
                        "<span class='bounce3'></span>" +
                    "</span>" +
                "</div>"+
                "</div>");
            try {
                var viewerContainer = viewerContainerOuter.append('<div id="VIEWUI_viewerContainer"></div>').find('#VIEWUI_viewerContainer');
                viewerContainer.addClass("VIEWUI_viewerContainer");
                viewerContainer.width(options.width);
                viewerContainer.height(options.height);
                console.log("CONSTRUCTION VIEWER loader: container prepared");
                if (options.loadResources) {
                    console.log("CONSTRUCTION VIEWER loader: Begin resources loading (getting load_resources.js)");
                    VIEWERLOADER = {};
                    VIEWERLOADER.setError = function(message, ex) {
                        clearTimeout(resourcesLoadingTimeout);
                        $('.loading-container').html('<h2 style="color:red">Error!</h2>');
                        console.error("CONSTRUCTION VIEWER loader: error", message);
                        if(ex) console.error(ex);
                    };
                    VIEWERLOADER.setLoadingFinished = function() {
                        console.log("CONSTRUCTION VIEWER loader: Finished loading");
                    };
                    var checkIfResourcesLoaded;
                    var resourcesLoadingTimeout = setTimeout(function() {
                        if (typeof checkIfResourcesLoaded !== 'undefined') {
                            clearInterval(checkIfResourcesLoaded);
                        }
                        VIEWERLOADER.setError("Resources loading timeout");
                        throw new Error("Resources loading timeout");
                    }, 60000); //timeout for viewer's resources loading - 60 seconds
                    rootPath = options.rootPath;

                    var loadResourcesPath = "js/load_resources.js";
                    if(VIEWER_OPTIONS.useProd === true) {
                        loadResourcesPath = "js/loader-prod/loader-prod.js"
                    }

                    $.getScript(rootPath + "js/lib/require.js").done(function() {

                        $.getScript(rootPath + loadResourcesPath).done(function () {
                            console.log("CONSTRUCTION VIEWER loader: Checking resources loading completion status");
                            checkIfResourcesLoaded = setInterval(function() {
                                try { // need another try catch block because of async request
                                    if (constructionViewerInitSuccess) {
                                        console.log("CONSTRUCTION VIEWER loader: Resources loading complete, initializing construction viewer...");
                                        clearInterval(checkIfResourcesLoaded);
                                        clearTimeout(resourcesLoadingTimeout);
                                        var coreModules = ['js/core/CORE', 'js/model/MODEL.ConstructionViewModel'];

                                        if (options.customCoreModules) {
                                            if (!Array.isArray(options.customCoreModules))
                                                throw new Error("options.customCoreModules must be an array");
                                            coreModules = options.customCoreModules; // overwrite default core modules for specific solutions
                                        }

                                        require(coreModules, function () {
                                            CORE.init(viewerContainer, options);
                                            VIEWERLOADER.setLoadingFinished(); // when no exception thrown
                                        }, function (err) { VIEWERLOADER.setError(err); });
                                    }
                                } catch (error) {
                                    VIEWERLOADER.setError("Error during loading: " + error);
                                    console.error(error.stack); // bug in chrome - sometimes does not throw exception to the console
                                    throw error; // to output stack trace to the console
                                    //$('#loadingLabel').html('<span style="color:red">Error!</span>');
                                    //console.error("CONSTRUCTION VIEWER loader: Error during loading: " + error);
                                }
                            }, 300); // interval between each completion check
                        }).fail(function(jqxhr, settings, exception) {
                            //console.error("CONSTRUCTION VIEWER loader: load_resources.js file failed to load! Reason: " + exception);
                            VIEWERLOADER.setError("Error");
                            throw new Error("load_resources.js file failed to load! Reason: " + exception);
                        });

                    })
                    .fail(function(jqxhr, settings, exception) { //failed to get require.js
                        console.error("Failed to get require.js, exception: " + exception);
                        if (typeof VIEWERLOADER !== 'undefined' && typeof VIEWERLOADER.setError === 'function')
                            VIEWERLOADER.setError("Require.js loading failed");
                    });

                } else {
                    console.log("CONSTRUCTION VIEWER loader: initializing construction viewer...");
                    if (typeof CORE === 'undefined') {
                        VIEWERLOADER.setError("Error");
                        throw 'Attempted to initialize viewer, but resources are not loaded (CORE is undefined)!';
                    }
                    CORE.init(this, options);
                }
            } catch (error) {
                VIEWERLOADER.setError("Resources loading failed");
                throw error;
                //$('#loadingLabel').html('<span style="color:red">Error!</span>');
                //console.error("CONSTRUCTION VIEWER loader: Error during loading: " + error);
                //throw error;
            }
        }
    }
});
//# sourceURL=loader.js
function AddHeadersToRequest(request){
    return;
    if(typeof(CORE.isAuthenticatedFunc) !== 'undefined') {
        CORE.isAuthenticatedFunc();
    }

    if(angularEnvName === "test") {
        request.setRequestHeader("HC-UID", authData.userId);
        request.setRequestHeader("HC-User", authData.userName);
        request.setRequestHeader("HC-CustomerID", authData.company);
    }
    request.setRequestHeader("Authorization", "Bearer " + authData.accessToken);
}

function HandleRequestUrl(baseUrl, parameters) {

    var actualUrl = baseUrl;
    if (actualUrl.slice(-1) === "/") {
        actualUrl = actualUrl.slice(0, actualUrl.length - 1);
      }
    if(angularEnvName !== "test") {
        actualUrl = baseUrl + '/v1';
    }

    if (parameters) {
        actualUrl = actualUrl + parameters;
    }
    return actualUrl;
}