﻿var MODEL = MODEL || {};
var boxesCount = 0;

//this model is used during definition
MODEL.BoxDefinition = function() {
    this.type = MODEL.OBJECT_TYPE.BoxDefinition;
    this.name = ko.observable(translation.BOX + ' ' + (boxesCount + 1));
    this.p1 = ko.observable(new MODEL.types.Vector(0,0,0));
    this.p2 = ko.observable(new MODEL.types.Vector(0, 0, 0));
    this.watchModel = function (callback, unwatch) {
        // Just for onDefiningObjectChanged event
    }
}

MODEL.Box = function() {
    this.type = MODEL.OBJECT_TYPE.Box;
    this.id = 0;
    this.name = ko.observable(translation.BOX + ' ' + (boxesCount + 1));
    this.origin = ko.observable(new MODEL.types.Vector(0,0,0));
    this.size  = ko.observable(new MODEL.types.Vector(0,0,0));
    this.selected = ko.observable(false);
    this.watchModel = function (callback, unwatch) {
        ko.watch(this.origin, false, callback, unwatch, 2);
        ko.watch(this.size, false, callback, unwatch, 2);
    }
    this.save = function() {
            return {
                id: this.id,
                name: this.name(),
                size: this.size().save(),
                origin: this.origin().save(),
            }
    }
    this.load = function(object) {
        this.id = object.id;
        this.name(object.name);
        this.size( object.size === null ? new MODEL.types.Vector(0,0,0) : new MODEL.types.Vector(object.size.x, object.size.y, object.size.z));
        this.origin( object.origin === null ? new MODEL.types.Vector(0,0,0) : new MODEL.types.Vector(object.origin.x, object.origin.y, object.origin.z));
    }

}