﻿var MODEL = MODEL || {};
var fillCount = 0;

MODEL.Fill = function() {
    this.type = MODEL.OBJECT_TYPE.Fill;
    this.id = 0;
    this.name = ko.observable("Fill " + (fillCount + 1));
    this.positions = ko.observableArray();
    this.material = ko.observable("");
    this.selected = ko.observable(false);
    this.pointCount = ko.observable(0);
    this.watchModel = function(callback, unwatch) {
        ko.watch(this.positions, false, callback, unwatch);
        ko.watch(this.material, false, callback, unwatch);
    }
    this.save = function() {
        var pointsArray = [];
        for (var i = 0; i < this.positions().length; i++) {
            pointsArray[i] = this.positions()[i].save();
        }
        return {
            id: this.id,
            name: this.name(),
            positions: pointsArray,
            material: this.material()
        }
    }
    this.load = function(object) {
        this.id = object.id;
        this.name(object.name);
        for (var i = 0; i < object.positions.length; i++) {
            var newPoint = new MODEL.Point(object.positions[i].id, object.positions[i].position.x, object.positions[i].position.y, object.positions[i].position.z);
            newPoint.name(object.positions[i].name);
            this.positions.push(newPoint);
        }
        this.material(object.material);
        this.pointCount(object.positions.length);
    }
    this.removePoint = function(fill, pointObject) {
        if (isEmpty(pointObject) || pointObject.type !== "Point") {
            console.error("MODEL.Fill.removePoint: passed pointObject is not a Point");
            return;
        }
        var id = pointObject.id();
        fill.positions().pop(pointObject);
        this.pointCount(fill.pointCount() - 1);
        for (var i = id - 1; i < fill.pointCount(); i++) {
            fill.positions()[i].name("Point " + fill.positions()[i].id());
            fill.positions()[i].id(fill.positions()[i].id() - 1);
        }
        alert("sds");
    }
}
MODEL.Point = function(pointCount, posX, posY, posZ) {
    this.id = ko.observable(pointCount);
    this.name = ko.observable("Point " + this.id());
    this.type = "Point";
    this.position = new MODEL.types.Vector(posX, posY, posZ);
    this.watchModel = function(callback, unwatch) {
        ko.watch(this.id, false, callback, unwatch);
        ko.watch(this.name, false, callback, unwatch);
    }
    this.save = function() {
        return {
            id: this.id(),
            name: this.name(),
            position: this.position.save()
        }
    }
}