﻿var MODEL = MODEL || {};
var epsilon = 0.001;

MODEL.NodeMerger = function(model) {
    this.observers = [];
    this.model = model;
    this.nodes = model.nodes();
    this.onNodeAdded = function(newNode) {
        var object = HELPERS.subscribePropertyChange(this, newNode.position, 'position', this.merge, newNode);
        var observer = {
            id: newNode.id,
            observer: object
        }
        this.observers.push(observer);
    }
    this.onNodeRemoved = function(nodeToRemove) {
        for (var i = 0; i < this.observers.length; i++) {
            if (this.observers[i].id === nodeToRemove.id) {
                this.observers[i].observer.dispose();
                this.observers.splice(i, 1);
            }
        }
    }
    this.merge = function(node) {
        for (var i = 0; i < this.nodes.length; i++) {
            var nodeToMarge = this.nodes[i];
            if (this.nodes[i].id !== node.id &&
                Math.abs(nodeToMarge.position().x - node.position().x) < epsilon &&
                Math.abs(nodeToMarge.position().y - node.position().y) < epsilon &&
                Math.abs(nodeToMarge.position().z - node.position().z) < epsilon) {
                model.mergeNodes(nodeToMarge, node);
                return nodeToMarge;
            }
        }
        return null;
    }
    // Init
    HELPERS.subscribeArrayChange(this, model.nodes, 'nodes', this.onNodeAdded, this.onNodeRemoved);
}