﻿var MODEL = MODEL || {};
MODEL.enums = MODEL.enums || {};

MODEL.SystemPreferences = function() {
    this.ecGammaM0= ko.observable(1.0);
    this.ecGammaM1= ko.observable(1.0);
    this.deadLoadFactorULS = ko.observable(1.35);
    this.deadLoadInfFactorULS = ko.observable(1.0);
    this.liveLoadFactorULS = ko.observable(1.5);
    this.seismicLoadFactorULS = ko.observable(1.0);
    this.deadLoadFactorSLS = ko.observable(1.0);
    this.deadLoadInfFactorSLS = ko.observable(1.0);
    this.liveLoadFactorSLS = ko.observable(1.0);
    this.seismicLoadFactorSLS = ko.observable(1.0);

    this.windLoadFactorPsi0 = ko.observable(1.0);
    this.windLoadFactorPsi1 = ko.observable(1.0);
    this.windLoadFactorPsi2 = ko.observable(1.0);

    this.liveLoadFactorPsi0 = ko.observable(1.0);
    this.liveLoadFactorPsi1 = ko.observable(1.0);
    this.liveLoadFactorPsi2 = ko.observable(1.0);
    
    this.maxDefChannelABS = ko.observable(200);
    this.maxDefCantileverABS = ko.observable(150);   

    this.maxDefChannelREL = ko.observable(200);
    this.maxDefCantileverREL = ko.observable(150);
    // properties window changes value to a string, have to change it back to a number
    var onValuechanged = function(newValue, oldValue, propertyName) {
        if (typeof newValue === "string") {
            this[propertyName](Number(newValue));
        }
    };
    HELPERS.subscribePropertyChange(this, this.deadLoadFactorULS, "SystemPreferences.deadLoadFactorULS", onValuechanged, null, "deadLoadFactorULS");
    HELPERS.subscribePropertyChange(this, this.deadLoadInfFactorULS, "SystemPreferences.deadLoadInfFactorULS", onValuechanged, null, "deadLoadInfFactorULS");
    HELPERS.subscribePropertyChange(this, this.liveLoadFactorULS, "SystemPreferences.liveLoadFactorULS", onValuechanged, null, "liveLoadFactorULS");
    HELPERS.subscribePropertyChange(this, this.seismicLoadFactorULS, "SystemPreferences.seismicLoadFactorULS", onValuechanged, null, "seismicLoadFactorULS");
    HELPERS.subscribePropertyChange(this, this.deadLoadFactorSLS, "SystemPreferences.deadLoadFactorSLS", onValuechanged, null, "deadLoadFactorSLS");
    HELPERS.subscribePropertyChange(this, this.deadLoadInfFactorSLS, "SystemPreferences.deadLoadInfFactorSLS", onValuechanged, null, "deadLoadInfFactorSLS");
    HELPERS.subscribePropertyChange(this, this.liveLoadFactorSLS, "SystemPreferences.liveLoadFactorSLS", onValuechanged, null, "liveLoadFactorSLS");
    HELPERS.subscribePropertyChange(this, this.seismicLoadFactorSLS, "SystemPreferences.seismicLoadFactorSLS", onValuechanged, null, "seismicLoadFactorSLS");

    HELPERS.subscribePropertyChange(this, this.windLoadFactorPsi0, "SystemPreferences.windLoadFactorPsi0", onValuechanged, null, "windLoadFactorPsi0");
    HELPERS.subscribePropertyChange(this, this.windLoadFactorPsi1, "SystemPreferences.windLoadFactorPsi1", onValuechanged, null, "windLoadFactorPsi1");
    HELPERS.subscribePropertyChange(this, this.windLoadFactorPsi2, "SystemPreferences.windLoadFactorPsi2", onValuechanged, null, "windLoadFactorPsi2");

    HELPERS.subscribePropertyChange(this, this.liveLoadFactorPsi0, "SystemPreferences.liveLoadFactorPsi0", onValuechanged, null, "liveLoadFactorPsi0");
    HELPERS.subscribePropertyChange(this, this.liveLoadFactorPsi1, "SystemPreferences.liveLoadFactorPsi1", onValuechanged, null, "liveLoadFactorPsi1");
    HELPERS.subscribePropertyChange(this, this.liveLoadFactorPsi2, "SystemPreferences.liveLoadFactorPsi1", onValuechanged, null, "liveLoadFactorPsi2");
    
    HELPERS.subscribePropertyChange(this, this.ecGammaM0, "SystemPreferences.ecGammaM0", onValuechanged, null, "ecGammaM0");
    HELPERS.subscribePropertyChange(this, this.ecGammaM1, "SystemPreferences.ecGammaM1", onValuechanged, null, "ecGammaM1");
    HELPERS.subscribePropertyChange(this, this.maxDefChannelREL, "SystemPreferences.maxDefChannelREL", onValuechanged, null, "maxDefChannelREL");
    HELPERS.subscribePropertyChange(this, this.maxDefCantileverREL, "SystemPreferences.maxDefCantileverREL", onValuechanged, null, "maxDefCantileverREL");
    HELPERS.subscribePropertyChange(this, this.maxDefChannelABS, "SystemPreferences.maxDefChannelABS", onValuechanged, null, "maxDefChannelABS");
    HELPERS.subscribePropertyChange(this, this.maxDefCantileverABS, "SystemPreferences.maxDefCantileverABS", onValuechanged, null, "maxDefCantileverABS");

    //this.watchModel = function(callback, unwatch) {
    //    ko.watch(this.deadLoad, false, callback, unwatch);
    //    ko.watch(this.liveLoad, false, callback, unwatch);
    //    ko.watch(this.maxDefChannel, false, callback, unwatch);
    //    ko.watch(this.maxDefCantilever, false, callback, unwatch);
    //}
    this.save = function() {
        return {
            deadLoadFactorULS: this.deadLoadFactorULS(),
            deadLoadInfFactorULS: this.deadLoadInfFactorULS(),
            liveLoadFactorULS: this.liveLoadFactorULS(),
            seismicLoadFactorULS: this.seismicLoadFactorULS(),
            deadLoadFactorSLS: this.deadLoadFactorSLS(),
            deadLoadInfFactorSLS: this.deadLoadInfFactorSLS(),
            liveLoadFactorSLS: this.liveLoadFactorSLS(),
            seismicLoadFactorSLS: this.seismicLoadFactorSLS(),
            liveLoadFactorPsi0: this.liveLoadFactorPsi0(),
            liveLoadFactorPsi1: this.liveLoadFactorPsi1(),
            liveLoadFactorPsi2: this.liveLoadFactorPsi2(),

            windLoadFactorPsi0: this.windLoadFactorPsi0(),
            windLoadFactorPsi1: this.windLoadFactorPsi1(),
            windLoadFactorPsi2: this.windLoadFactorPsi2(),
            
            maxDefChannelREL: this.maxDefChannelREL(),
            maxDefCantileverREL: this.maxDefCantileverREL(),
            maxDefChannelABS: this.maxDefChannelABS(),
            maxDefCantileverABS: this.maxDefCantileverABS(),

            ecGammaM0:this.ecGammaM0(),
            ecGammaM1:this.ecGammaM1()
        }
    }
    this.load = function(object) {
        this.deadLoadFactorULS(object.deadLoadFactorULS);
        this.deadLoadInfFactorULS(object.deadLoadInfFactorULS);
        this.liveLoadFactorULS(object.liveLoadFactorULS);
        this.seismicLoadFactorULS(object.seismicLoadFactorULS);

        this.deadLoadFactorSLS(object.deadLoadFactorSLS);
        this.deadLoadInfFactorSLS(object.deadLoadInfFactorSLS);
        this.liveLoadFactorSLS(object.liveLoadFactorSLS);
        this.seismicLoadFactorSLS(object.seismicLoadFactorSLS);
        
        this.liveLoadFactorPsi0(object.liveLoadFactorPsi0);
        this.liveLoadFactorPsi1(object.liveLoadFactorPsi1);
        this.liveLoadFactorPsi2(object.liveLoadFactorPsi2);

        this.windLoadFactorPsi0(object.windLoadFactorPsi0);
        this.windLoadFactorPsi1(object.windLoadFactorPsi1);
        this.windLoadFactorPsi2(object.windLoadFactorPsi2);
        
        this.maxDefChannelREL(object.maxDefChannelREL);
        this.maxDefCantileverREL(object.maxDefCantileverREL);
        this.maxDefChannelABS(object.maxDefChannelABS);
        this.maxDefCantileverABS(object.maxDefCantileverABS);

        this.ecGammaM0(object.ecGammaM0);
        this.ecGammaM1(object.ecGammaM1);
    }
}