﻿var MODEL = MODEL || {};
var nodeForceCount = 0;
var nodeMomentCount = 0;
var barForceCount = 0;
var barUniformCount = 0;
var barTrapezoidalCount = 0;

MODEL.load = {
    node: {
        nodeForceCount: 0,
        NodeForce: function(forcesVector, momentsVector, rotationVector) {
            this.parentType = MODEL.OBJECT_TYPE.Load;
            this.type = MODEL.OBJECT_TYPE.NodeForce;
            this.loadType = MODEL.OBJECT_TYPE.NodeForce; // for compatibility with calculations
            this.id = 0;
            this.name = ko.observable("Node Force " + (nodeForceCount + 1));
            this.loadCase = ko.observable("LOADCASE_LIVE");
            forcesVector = (forcesVector instanceof MODEL.types.Vector) ? forcesVector : new MODEL.types.Vector(0, 0, 0);
            //momentsVector = (momentsVector instanceof MODEL.types.Vector) ? momentsVector : new MODEL.types.Vector(0, 0, 0);
            rotationVector = (rotationVector instanceof MODEL.types.Vector) ? rotationVector : new MODEL.types.Vector(0, 0, 0);
            this.forces = ko.observable(forcesVector);
            //this.moments = ko.observable(momentsVector);
            this.rotation = ko.observable(rotationVector);
            this.selected = ko.observable(false);
            this.assignedTo = ko.observableArray();
            this.watchModel = function(callback, unwatch) {
                ko.watch(this.name, false, callback, unwatch);
                ko.watch(this.forces, false, callback, unwatch);
                ko.watch(this.rotation, false, callback, unwatch);
                ko.watch(this.assignedTo, false, callback, unwatch);
                ko.watch(this.loadCase, false, callback, unwatch);
            }
            this.subs = [];
            this.assignTo = function(nodeModelObject) {
                if (isEmpty(nodeModelObject) || nodeModelObject.type !== MODEL.OBJECT_TYPE.Node) {
                    console.error("MODEL.load.node.NodeForce.assignTo: passed nodeModelObject is not a Node");
                    return;
                }
                var index = this.assignedTo.indexOf(nodeModelObject);
                if (index !== -1) {
                    console.error("MODEL.load.node.NodeForce.assignTo: passed nodeModelObject already exists in load.assignedTo array");
                    return;
                }
                index = nodeModelObject.loads.indexOf(this);
                if (index !== -1) {
                    console.error("MODEL.load.node.NodeForce.assignTo: current load object already exists in nodeModelObject.loads array");
                    return;
                }
                this.assignedTo.push(nodeModelObject);
                nodeModelObject.loads.push(this);
            }
            this.removeAssignment = function(nodeModelObject) {
                    if (isEmpty(nodeModelObject) || nodeModelObject.type !== MODEL.OBJECT_TYPE.Node) {
                        console.error("MODEL.load.node.NodeForce.removeAssignment: passed nodeModelObject is not a Node");
                        return;
                    }
                    var indexInLoad = this.assignedTo.indexOf(nodeModelObject);
                    if (indexInLoad === -1) {
                        throw new Error("MODEL.load.node.NodeForce.removeAssignment: passed nodeModelObject does not exist in load.assignedTo array");
                    }
                    var indexInNode = nodeModelObject.loads.indexOf(this);
                    if (indexInNode === -1) {
                        throw new Error("MODEL.load.node.NodeForce.removeAssignment: current loadModelObject does not exist in nodeModelObject.loads array");
                    }
                    this.assignedTo.splice(indexInLoad, 1);
                    nodeModelObject.loads.splice(indexInNode, 1);
                },
                this.removeAllAssignments = function() {
                    while (this.assignedTo().length > 0) {
                        this.removeAssignment(this.assignedTo()[0]);
                    }
                },
                this.incrementCounter = function() {
                    MODEL.load.node.nodeForceCount++;
                }
        },
        nodeMomentCount: 0,
        NodeMoment: function(forcesVector, momentsVector /*, rotationVector*/) {
            this.parentType = MODEL.OBJECT_TYPE.Load;
            this.type = MODEL.OBJECT_TYPE.NodeMoment;
            this.loadType = MODEL.OBJECT_TYPE.NodeMoment; // for compatibility with calculations
            this.id = 0;
            this.name = ko.observable("Node Moment " + (nodeMomentCount + 1));
            this.loadCase = ko.observable("LOADCASE_LIVE");
            //forcesVector = (forcesVector instanceof MODEL.types.Vector) ? forcesVector : new MODEL.types.Vector(0, 0, 0);
            momentsVector = (momentsVector instanceof MODEL.types.Vector) ? momentsVector : new MODEL.types.Vector(0, 0, 0);
            //rotationVector = (rotationVector instanceof MODEL.types.Vector) ? rotationVector : new MODEL.types.Vector(0, 0, 0);
            //this.forces = ko.observable(forcesVector);
            this.moments = ko.observable(momentsVector);
            //this.rotation = ko.observable(rotationVector);
            this.selected = ko.observable(false);
            this.assignedTo = ko.observableArray();
            this.watchModel = function(callback, unwatch) {
                ko.watch(this.name, false, callback, unwatch);
                ko.watch(this.moments, false, callback, unwatch);
                ko.watch(this.assignedTo, false, callback, unwatch);
                ko.watch(this.loadCase, false, callback, unwatch);
            }
            this.subs = [];
            this.assignTo = function(nodeModelObject) {
                if (isEmpty(nodeModelObject) || nodeModelObject.type !== MODEL.OBJECT_TYPE.Node) {
                    console.error("MODEL.load.node.NodeMoment.assignTo: passed nodeModelObject is not a Node");
                    return;
                }
                var index = this.assignedTo.indexOf(nodeModelObject);
                if (index !== -1) {
                    console.error("MODEL.load.node.NodeMoment.assignTo: passed nodeModelObject already exists in load.assignedTo array");
                    return;
                }
                index = nodeModelObject.loads.indexOf(this);
                if (index !== -1) {
                    console.error("MODEL.load.node.NodeMoment.assignTo: current load object already exists in nodeModelObject.loads array");
                    return;
                }
                this.assignedTo.push(nodeModelObject);
                nodeModelObject.loads.push(this);
            }
            this.removeAssignment = function(nodeModelObject) {
                    if (isEmpty(nodeModelObject) || nodeModelObject.type !== MODEL.OBJECT_TYPE.Node) {
                        console.error("MODEL.load.node.NodeMoment.removeAssignment: passed nodeModelObject is not a Node");
                        return;
                    }
                    var indexInLoad = this.assignedTo.indexOf(nodeModelObject);
                    if (indexInLoad === -1) {
                        throw new Error("MODEL.load.node.NodeMoment.removeAssignment: passed nodeModelObject does not exist in load.assignedTo array");
                    }
                    var indexInNode = nodeModelObject.loads.indexOf(this);
                    if (indexInNode === -1) {
                        throw new Error("MODEL.load.node.NodeMoment.removeAssignment: current loadModelObject does not exist in nodeModelObject.loads array");
                    }
                    this.assignedTo.splice(indexInLoad, 1);
                    nodeModelObject.loads.splice(indexInNode, 1);
                },
                this.removeAllAssignments = function() {
                    while (this.assignedTo().length > 0) {
                        this.removeAssignment(this.assignedTo()[0]);
                    }
                },
                this.incrementCounter = function() {
                    MODEL.load.node.nodeMomentCount++;
                }
        }
    },
    bar: {
        barForceCount: 0,
        BarForce: function(dist, forcesVector, momentsVector, rotationVector) {
            var self = this;
            this.type = MODEL.OBJECT_TYPE.BarForce;
            this.id = 0;
            this.name = ko.observable(translation.BAR_FORCE);
            this.editableName = ko.observable(this.name());
            this.isNameEdited = ko.observable(false);
            this.coordinatesAbsolute = ko.observable(true);
            this.barAttachments = ko.observableArray([new MODEL.types.BarAttachment(null, 0)]);
            this.xRelative = ko.observable(0);
            if (forcesVector && !(forcesVector instanceof MODEL.types.Vector)) {
                console.error("BarForce: expected Vector!");
            }
            if (momentsVector && !(momentsVector instanceof MODEL.types.Vector)) {
                console.error("BarForce: expected Vector!");
            }
            if (rotationVector && !(rotationVector instanceof MODEL.types.Vector)) {
                console.error("BarForce: expected Vector!");
            }
            forcesVector = forcesVector || new MODEL.types.Vector(0, 0, 0);
            momentsVector = momentsVector || new MODEL.types.Vector(0, 0, 0);
            rotationVector = rotationVector || new MODEL.types.Vector(0, 0, 0);
            this.forces = ko.observable(forcesVector);
            this.moments = ko.observable(momentsVector);
            this.rotation = ko.observable(rotationVector);
            this.selected = ko.observable(false);
            this.loadCase = ko.observable("LOADCASE_LIVE");
            this.allLoadTypes = ko.observableArray();
            for (i = 0; i < CORE.model.loadCases().length; i++) {
                this.allLoadTypes.push(CORE.model.loadCases()[i].loadCase);
            };
            this.showLoadTypesList = ko.observable(false);
            this.onLoadTypeCurrentItemClick = function() {
                if (this.showLoadTypesList()) {
                    this.showLoadTypesList(false);
                } else {
                    this.showLoadTypesList(true);
                }
            };
            this.onLoadTypeListItemClick = function(code) {
                this.loadCase(code);
                this.showLoadTypesList(false);
            };
            this.modifyable = ko.observable(true);
            this.name.subscribe(function(newValue) {
                self.editableName(newValue)
            });
            this.isNameEdited.subscribe(function(newValue) {
                var newName = self.editableName();
                if(newName === "" || newName === null) {
                    self.editableName(self.name());
                } else {
                    self.name(self.editableName());
                }
            });

            this.watchModel = function(callback, unwatch) {
                ko.watch(this.name, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.barAttachments, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.forces, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.moments, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.rotation, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.loadCase, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
            }

            this.subs = [];
            this.getMaxAbsValue = function () {
                return Math.max(this.forces().getMaxAbsValue(), this.moments().getMaxAbsValue());
            }
            // ======= X ABSOLUTE <-> X RELATIVE SYNC ========
            this.barAttachmentSubs = [];
            var self = this;
            // subscribe x on every barAttachment
            var onBarAttachmentAdd = function(newBarAttachment, index) {
                if (!isEmpty(newBarAttachment.bar)) {
                    // should only be 1 bar attachment per bar force
                    var newSubs = MODEL.BarAttachmentsController.SyncX(newBarAttachment.x, self.xRelative, newBarAttachment.bar, self.coordinatesAbsolute());
                    self.barAttachmentSubs[index] = [];
                    self.barAttachmentSubs[index].push(newSubs);
                }
            }
            var onBarAttachmentRemoved = function(removedBarAttachment, index) {
                if (!isEmpty(self.barAttachmentSubs[index])) {
                    if (self.barAttachmentSubs[index][0]) self.barAttachmentSubs[index][0][0].dispose();
                    if (self.barAttachmentSubs[index][0]) self.barAttachmentSubs[index][0][1].dispose();
                    if (self.barAttachmentSubs[index][1]) self.barAttachmentSubs[index][1][0].dispose();
                    if (self.barAttachmentSubs[index][1]) self.barAttachmentSubs[index][1][1].dispose();
                    self.barAttachmentSubs.splice(index, 1);
                }
            }
            HELPERS.subscribeArrayChange(this, this.barAttachments, "barAttachments", onBarAttachmentAdd, onBarAttachmentRemoved);

            for (var i = 0, ii = this.barAttachments().length; i < ii; i++) {
                onBarAttachmentAdd(this.barAttachments()[i], i);
            }

            // ======= / X ABSOLUTE <-> X RELATIVE SYNC ========
            this.save = function() {
                var barAttachmentsArray = [];
                for (var i = 0; i < this.barAttachments().length; i++) {
                    barAttachmentsArray.push(new MODEL.types.BarAttachment(this.barAttachments()[i].bar, this.barAttachments()[i].x()).save());
                }

                var details = {
                    isGlobal: true, // Default value
                    isProjected: false, // Default value
                    coordinatesAbsolute: true, // Default value
                    modifyable: this.modifyable(),
                    rotation: this.rotation().save(),
                    barAttachments: barAttachmentsArray,
                    points: [{
                        forces: this.forces().save(),
                        moments: this.moments().save(),
                    }]
                }

                return {
                    id: this.id,
                    name: this.name(),
                    loadType: this.type,
                    loadCase: this.loadCase(), // Default value
                    details: details,
                    //loadVariant: this.loadVariant()
                }
            }
            this.load = function(object, construction) {
                this.id = object.id;
                this.name(object.name);
                // remove initial barAttachment
                this.barAttachments.removeAll();

                for (var i = 0; i < object.details.barAttachments.length; i++) {
                    var bar = construction.getBarById(object.details.barAttachments[i].barId);

                    if (bar !== null && !isEmpty(object.details.barAttachments[i].x))
                        this.barAttachments.push(new MODEL.types.BarAttachment(construction.getBarById(object.details.barAttachments[i].barId), object.details.barAttachments[i].x));
                };

                this.modifyable(object.details.modifyable);
                this.loadCase(object.loadCase);//object.loadType
                this.forces(new MODEL.types.Vector(object.details.points[0].forces.x, object.details.points[0].forces.y, object.details.points[0].forces.z));
                this.moments(new MODEL.types.Vector(object.details.points[0].moments.x, object.details.points[0].moments.y, object.details.points[0].moments.z));
                this.rotation(new MODEL.types.Vector(object.details.rotation.x, object.details.rotation.y, object.details.rotation.z));
            }
            // position is always absolute
            this.assignTo = function(barModelObject, position) {
                if (isEmpty(barModelObject) || barModelObject.type !== MODEL.OBJECT_TYPE.Bar) {
                    console.error("MODEL.load.bar.BarForce.assignTo: passed barModelObject is not a Bar");
                    return;
                }
                if (!$.isNumeric(position)) {
                    console.error("MODEL.load.bar.BarForce.assignTo: passed position is not a number");
                    return;
                }
                var assignedTo = this.barAttachments();
                for (var i = 0; i < assignedTo.length; i++) {
                    if (assignedTo[i].bar === barModelObject && assignedTo[i].x() === position) {
                        console.info("MODEL.load.bar.BarForce.assignTo: passed combination {barModelObject, position} already exists for this load, assign call ignored");
                        return;
                    }
                }
                // x is always absolute
                this.barAttachments.push(new MODEL.types.BarAttachment(barModelObject, position));
            }
            this.removeAssignment = function(barModelObject, position) {
                if (isEmpty(barModelObject) || barModelObject.type !== MODEL.OBJECT_TYPE.Bar) {
                    console.error("MODEL.load.bar.BarForce.removeAssignment: passed barModelObject is not a Bar");
                }
                if (!$.isNumeric(position)) {
                    console.error("MODEL.load.bar.BarForce.removeAssignment: passed position is not a number");
                }
                var indexInLoad = -1;
                var assignedTo = this.barAttachments();
                for (var i = 0; i < assignedTo.length; i++) {
                    if (assignedTo[i].bar === barModelObject && assignedTo[i].x() === position) {
                        indexInLoad = i;
                    }
                }
                if (indexInLoad === -1) {
                    console.error("MODEL.load.bar.BarForce.removeAssignment: passed combination {barModelObject, position} does not exist in this load");
                    return null;
                }
                this.barAttachments.splice(indexInLoad, 1);
                return true;
            }
            this.removeAllAssignments = function() {
                for (var i = this.barAttachments().length - 1; i >= 0; i--) {
                    this.removeAssignment(this.barAttachments()[i].bar, this.barAttachments()[i].x());
                }
            }
            this.incrementCounter = function() {
                MODEL.load.bar.barForceCount++;
            }
        },
        barUniformCount: 0,
        BarUniform: function(forcesVector, rotationVector) {
            this.type = MODEL.OBJECT_TYPE.BarUniform;
            this.id = 0;
            this.name = ko.observable(translation.BAR_UNIFORM);
            this.barAttachments = ko.observableArray();
            if (forcesVector && !(forcesVector instanceof MODEL.types.Vector)) {
                console.error("BarUniform: expected Vector!");
            }
            if (rotationVector && !(rotationVector instanceof MODEL.types.Vector)) {
                console.error("BarUniform: expected Vector!");
            }
            forcesVector = forcesVector || new MODEL.types.Vector(0, 0, 0);
            rotationVector = rotationVector || new MODEL.types.Vector(0, 0, 0);
            forcesVector = (forcesVector instanceof MODEL.types.Vector) ? forcesVector : new MODEL.types.Vector(0, 0, 0);
            rotationVector = (rotationVector instanceof MODEL.types.Vector) ? rotationVector : new MODEL.types.Vector(0, 0, 0);
            this.forces = ko.observable(forcesVector);
            this.rotation = ko.observable(rotationVector);
            this.selected = ko.observable(false);
            this.loadCase = ko.observable("LOADCASE_LIVE");
            this.watchModel = function(callback, unwatch) {
                ko.watch(this.name, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.forces, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.rotation, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.barAttachments, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.loadCase, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
            }
            this.subs = [];
            this.getMaxAbsValue = function () {
                return this.forces().getMaxAbsValue();
            }
            this.save = function() {
                var barAttachmentsArray = [];
                for (var i = 0; i < this.barAttachments().length; i++) {
                    barAttachmentsArray.push(new MODEL.types.BarAttachment(this.barAttachments()[i].bar, 0).save());
                }
                return {
                    id: this.id,
                    name: this.name(),
                    loadType: this.type,
                    loadCase: this.loadCase(), // Default value
                    barAttachments: barAttachmentsArray,
                    isGlobal: true, // Default value
                    isProjected: false, // Default value
                    coordinatesAbsolute: true, // Default value
                    forces: this.forces().save(),
                    rotation: this.rotation().save()
                }
            }
            this.load = function(object, construction) {
                this.id = object.id;
                this.name(object.name);
                for (var i = 0; i < object.barAttachments.length; i++) {
                    var element = construction.getBarById(object.barAttachments[i].barId);
                    this.barAttachments.push(new MODEL.types.BarAttachment(element, 0));
                };
                this.forces(new MODEL.types.Vector(object.forces.x, object.forces.y, object.forces.z));
                this.rotation(new MODEL.types.Vector(object.rotation.x, object.rotation.y, object.rotation.z));
            }
            this.assignTo = function(barModelObject) {
                if (isEmpty(barModelObject) || barModelObject.type !== MODEL.OBJECT_TYPE.Bar) {
                    console.error("MODEL.load.bar.BarUniform.assignTo: passed barModelObject is not a Bar");
                    return;
                }
                var index = this.barAttachments.indexOf(barModelObject);
                if (index !== -1) {
                    console.error("MODEL.load.bar.BarUniform.assignTo: passed barModelObject already exists in load.barAttachments array");
                    return;
                }
                this.barAttachments.push(new MODEL.types.BarAttachment(barModelObject, 0));
            }
            this.removeAssignment = function(barModelObject) {
                var indexInLoad = -1;
                var assignedTo = this.barAttachments();
                for (var i = 0; i < assignedTo.length; i++) {
                    if (assignedTo[i].bar === barModelObject) {
                        indexInLoad = i;
                    }
                }
                if (indexInLoad === -1) {
                    console.error("MODEL.load.bar.BarUniform.removeAssignment: passed bar does not exist in this load's barAttachments");
                    return null;
                }
                this.barAttachments.splice(indexInLoad, 1);
            }
            this.removeAllAssignments = function() {
                for (var i = this.barAttachments().length - 1; i >= 0; i--) {
                    this.removeAssignment(this.barAttachments()[i].bar, this.barAttachments()[i].x());
                }
            }
            this.incrementCounter = function() {
                MODEL.load.bar.barUniformCount++;
            }
        },
        barTrapezoidalCount: 0,
        BarTrapezoidal: function(p1ExtendedVector, p2ExtendedVector, rotationVector) {
            var self = this;
            this.type = MODEL.OBJECT_TYPE.BarTrapezoidal;
            this.id = 0;
            this.name = ko.observable(translation.BAR_TRAPEZOIDAL);
            this.editableName = ko.observable(this.name());
            this.isNameEdited = ko.observable(false)
            this.coordinatesAbsolute = ko.observable(true);
            this.barAttachments = ko.observableArray([new MODEL.types.BarAttachment(null, 0)]);
            this.x1Absolute = ko.observable(0);
            this.x1Relative = ko.observable(0);
            this.x2Absolute = ko.observable(0);
            this.x2Relative = ko.observable(0);
            
            if (p1ExtendedVector && !(p1ExtendedVector instanceof MODEL.types.ExtendedVector)) {
                console.error("BarTrapezodial: expected ExtendedVector!");
            }
            if (p2ExtendedVector && !(p2ExtendedVector instanceof MODEL.types.ExtendedVector)) {
                console.error("BarTrapezodial: expected ExtendedVector!");
            }
            if (rotationVector && !(rotationVector instanceof MODEL.types.Vector)) {
                console.error("BarTrapezodial: expected Vector!");
            }
            p1ExtendedVector = p1ExtendedVector || new MODEL.types.ExtendedVector(0, 0, 0, 0);
            p2ExtendedVector =  p2ExtendedVector || new MODEL.types.ExtendedVector(0, 0, 0, 0);
            rotationVector = rotationVector || new MODEL.types.Vector(0, 0, 0);

            this.points = ko.observableArray([ko.observable(p1ExtendedVector), ko.observable(p2ExtendedVector)]);
            this.rotation = ko.observable(rotationVector);
            this.selected = ko.observable(false);
            this.loadCase = ko.observable("LOADCASE_LIVE");
            this.allLoadTypes = ko.observableArray();
            for (i = 0; i < CORE.model.loadCases().length; i++) {
                this.allLoadTypes.push(CORE.model.loadCases()[i].loadCase);
            };
            this.showLoadTypesList = ko.observable(false);
            this.onLoadTypeCurrentItemClick = function() {
                if (this.showLoadTypesList()) {
                    this.showLoadTypesList(false);
                } else {
                    this.showLoadTypesList(true);
                }
            };
            this.onLoadTypeListItemClick = function(code) {
                this.loadCase(code);
                this.showLoadTypesList(false);
            };
            this.modifyable = ko.observable(true);
            this.name.subscribe(function(newValue) {
                self.editableName(newValue)
            });
            this.isNameEdited.subscribe(function(newValue) {
                var newName = self.editableName();
                if(newName === "" || newName === null) {
                    self.editableName(self.name());
                } else {
                    self.name(self.editableName());
                }
            });
            this.points()[0].subscribe(function(newValue) {
                var newForceValue = self.points()[0]().vector;
                var oldDistance = self.points()[1]().distance;
                self.points()[1](new MODEL.types.ExtendedVector(newForceValue.x, newForceValue.y, newForceValue.z, oldDistance));
            });

            this.watchModel = function(callback, unwatch) {
                ko.watch(this.name, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.barAttachments, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.rotation, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.points, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.x1Absolute, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.x1Relative, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.x2Absolute, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.x2Relative, false, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
                ko.watch(this.loadCase, true, callback, unwatch, { mode: SAVE_MODE.NoConstraints });
            }
            this.subs = [];
            this.getMaxAbsValue = function () {
                return Math.max(this.points()[0]().vector.getMaxAbsValue(), this.points()[1]().vector.getMaxAbsValue());
            }
            this.save = function() {
                var barAttachmentsArray = [];
                var i;
                for (i = 0; i < this.barAttachments().length; i++) {
                    barAttachmentsArray.push(new MODEL.types.BarAttachment(this.barAttachments()[i].bar, this.barAttachments()[i].x()).save());
                }
                var points = [];
                for (i = 0; i < this.points().length; i++) {
                    points[i] = this.points()[i]().save();
                }

                var details = {
                    isGlobal: true, // Default value
                    isProjected: false, // Default value
                    coordinatesAbsolute: true, // Default value
                    modifyable: this.modifyable(),
                    rotation: this.rotation().save(),
                    barAttachments: barAttachmentsArray,
                    points: [{
                        distance: this.points()[0]().save().distance,
                        forces: this.points()[0]().save().vector
                    },
                    {
                        distance: this.points()[1]().save().distance,
                        forces: this.points()[1]().save().vector
                    }]
                }

                return {
                    id: this.id,
                    name: this.name(),
                    loadType: this.type,
                    loadCase: this.loadCase(), // Default value
                    details: details,
                    //loadVariant: this.loadVariant()
                }
            }
            this.load = function(object, construction) {
                this.id = object.id;
                this.name(object.name);
                // delete "bar: null" initial barAttachment
                this.barAttachments.removeAll();

                for (var i = 0; i < object.details.barAttachments.length; i++) {
                    var bar = construction.getBarById(object.details.barAttachments[i].barId);

                    if (bar !== null && !isEmpty(object.details.barAttachments[i].x))
                        this.barAttachments.push(new MODEL.types.BarAttachment(construction.getBarById(object.details.barAttachments[i].barId), object.details.barAttachments[i].x));
                };

                this.modifyable(object.details.modifyable);
                this.loadCase(object.loadCase);//object.loadType
                
                this.points()[0](new MODEL.types.ExtendedVector(object.details.points[0].forces.x, object.details.points[0].forces.y, object.details.points[0].forces.z, 0));
                this.points()[1](new MODEL.types.ExtendedVector(object.details.points[1].forces.x, object.details.points[1].forces.y, object.details.points[1].forces.z, 0));
                this.x1Absolute(object.details.points[0].distance);
                this.x2Absolute(object.details.points[1].distance);
                this.rotation(new MODEL.types.Vector(object.details.rotation.x, object.details.rotation.y, object.details.rotation.z));
            }
            this.assignTo = function(barModelObject) {
                if (isEmpty(barModelObject) || barModelObject.type !== MODEL.OBJECT_TYPE.Bar) {
                    console.error("MODEL.load.bar.BarTrapezoidal.assignTo: passed barModelObject is not a Bar");
                    return;
                }
                var index = this.barAttachments.indexOf(barModelObject);
                if (index !== -1) {
                    console.error("MODEL.load.bar.BarTrapezoidal.assignTo: passed barModelObject already exists in load.barAttachments array");
                    return;
                }
                this.barAttachments.push(new MODEL.types.BarAttachment(barModelObject, 0));
            }
            this.removeAssignment = function(barModelObject) {
                var indexInLoad = -1;
                var assignedTo = this.barAttachments();
                for (var i = 0; i < assignedTo.length; i++) {
                    if (assignedTo[i].bar === barModelObject) {
                        indexInLoad = i;
                    }
                }
                if (indexInLoad === -1) {
                    console.error("MODEL.load.bar.BarTrapezoidal.removeAssignment: passed bar does not exist in this load's barAttachments");
                    return null;
                }
                if (this.barAttachments().length === 0) debugger;
                this.barAttachments.splice(indexInLoad, 1);
            }
            this.removeAllAssignments = function() {
                for (var i = this.barAttachments().length - 1; i >= 0; i--) {
                    this.removeAssignment(this.barAttachments()[i].bar, this.barAttachments()[i].x());
                }
            }
            this.incrementCounter = function() {
                MODEL.load.bar.barTrapezoidalCount++;
            }
            // ======= X ABSOLUTE <-> X RELATIVE SYNC ========
            this.barAttachmentSubs = [];
            var self = this;
            // subscribe x on every barAttachment
            var onBarAttachmentAdd = function(newBarAttachment, index) {
                if (!isEmpty(newBarAttachment.bar)) {
                    // should only be 1 bar attachment per load
                    var newSubs1 = MODEL.BarAttachmentsController.SyncX(self.x1Absolute, self.x1Relative, newBarAttachment.bar, self.coordinatesAbsolute());
                    var newSubs2 = MODEL.BarAttachmentsController.SyncX(self.x2Absolute, self.x2Relative, newBarAttachment.bar, self.coordinatesAbsolute());
                    self.barAttachmentSubs[index] = [];
                    self.barAttachmentSubs[index].push(newSubs1, newSubs2);
                }
            }
            var onBarAttachmentRemoved = function(removedBarAttachment, index) {
                if (!isEmpty(self.barAttachmentSubs[index])) {
                    if (self.barAttachmentSubs[index][0]) self.barAttachmentSubs[index][0][0].dispose();
                    if (self.barAttachmentSubs[index][0]) self.barAttachmentSubs[index][0][1].dispose();
                    if (self.barAttachmentSubs[index][1]) self.barAttachmentSubs[index][1][0].dispose();
                    if (self.barAttachmentSubs[index][1]) self.barAttachmentSubs[index][1][1].dispose();
                    self.barAttachmentSubs.splice(index, 1);
                }
            }
            HELPERS.subscribeArrayChange(this, this.barAttachments, "barAttachments", onBarAttachmentAdd, onBarAttachmentRemoved);

            for (var i = 0, ii = this.barAttachments().length; i < ii; i++) {
                onBarAttachmentAdd(this.barAttachments()[i], i);
            }
            // ======= / X ABSOLUTE <-> X RELATIVE SYNC ========
            this.setPointDistance = function(name) {
                var existingVector;
                var newPoint;
                switch (name) {
                case 'point1':

                    // existingVector = this.points()[1]().vector;
                    // newPoint = new MODEL.types.ExtendedVector(existingVector.x, existingVector.y, existingVector.z, this.x2Absolute());
                    // this.points()[1](newPoint);

                    existingVector = this.points()[0]().vector;
                    newPoint = new MODEL.types.ExtendedVector(existingVector.x, existingVector.y, existingVector.z, this.x1Absolute());
                    this.points()[0](newPoint);
                    break;
                case 'point2':
                    existingVector = this.points()[1]().vector;
                    newPoint = new MODEL.types.ExtendedVector(existingVector.x, existingVector.y, existingVector.z, this.x2Absolute());
                    this.points()[1](newPoint);
                    break;
                }
            }
            HELPERS.subscribePropertyChange(this, this.x1Absolute, "x1Absolute", function() {
                this.setPointDistance('point1');
            });
            HELPERS.subscribePropertyChange(this, this.x2Absolute, "x2Absolute", function() {
                this.setPointDistance('point2');
            });
        }
    }
}