﻿var MODEL = MODEL || {};
MODEL.utils = MODEL.utils || {};
var isUndoRedo = false;

MODEL.utils.ConstructionData = function (protoModel, id) {
    this.protoModel = protoModel;
    this.id = id;
}

MODEL.utils.UndoRedo = function(construction) {
    this.constructionCache = [];
    this.version = ko.observable(0);
    this.addToHistory = function() {
        if (!isUndoRedo) {
            var i;
            if (this.version() < this.constructionCache.length) {
                for (i = this.constructionCache.length; i > this.version(); i--) {
                    this.constructionCache.pop();
                }
            }
            var data = new MODEL.utils.ConstructionData(construction.save(), this.version());
            this.constructionCache.push(data);
            if (this.constructionCache.length > 10) {
                this.constructionCache.shift();
                for (i = 0; i < this.constructionCache.length; i++) {
                    this.constructionCache[i].id--;
                }
            } else {
                this.version(this.version()+1);
            }
        } else {
            isUndoRedo = false;
        }
    }
    this.undo = function() {
        if (this.version() <= 1) {
            console.error("MODEL.UndoRedo: Cannot undo");
        } else {
            isUndoRedo = true;
            CORE.model.constraints.clearConstraints();
            CORE.model.loadModel(this.constructionCache[this.version() - 2].protoModel);
            this.version(this.version() - 1);

        }
    }
    this.redo = function() {
        if (this.version() === this.constructionCache.length) {
            console.error("MODEL.UndoRedo: Nothing to redo");
        } else {
            isUndoRedo = true;
            CORE.model.constraints.clearConstraints();
            CORE.model.loadModel(this.constructionCache[this.version()].protoModel);
            this.version(this.version()+1);
        }
    }

    this.undoAvailable = function () {
        return this.version() > 1;
    }

    this.redoAvailable = function () {
        return this.version() !== this.constructionCache.length;
    }
}