﻿var MODEL = MODEL || {};
MODEL.utils = MODEL.utils || {};

MODEL.utils.Proto = {
    protoModelCache: {},

    getProtoModelFromBase64: function (ProtoBuider, protoBuilderName, base64string, modelId) {

        if (this.protoModelCache[modelId])
            return this.protoModelCache[modelId];

		try {
			//var b64length = ProtoBuf.util.base64.length(base64string);		// not reliable with btoa
			//var outputBuffer = new Uint8Array(b64length);
			//ProtoBuf.util.base64.decode(base64string, outputBuffer, 0);

			var outputBufferArr = atob(base64string).split(',');
			var outputBuffer = new Uint8Array(outputBufferArr);
			protoModel = ProtoBuider.decode(outputBuffer);

			this.protoModelCache[modelId] = protoModel;

			return protoModel;
		} catch (error) {
			console.error("MODEL.utils.Proto: proto message parsing for " + protoBuilderName + " (modelId: " + modelId +") failed, reason: " + error);
			
			if (CORE.viewerFullyLoaded)
				VIEWUI.statusBar.setError("Load error (incompatible 3d model)");
			else
				VIEWERLOADER.setError("Load error (incompatible 3d model proto)", error);

			throw error;
		}

	},
	// discretizeNormal: function(value) {
	// 	var states = 5;
	// 	return Math.floor((value * 100)/states)*states/100;
	// },

	getBufferGeometryFromProtoModel: function (geometryProtoModel, modelId) {

		var geometry = new THREE.BufferGeometry();
		geometry.addAttribute('position', new THREE.BufferAttribute(new Float32Array(geometryProtoModel.position), 3));
		geometry.setIndex(new THREE.BufferAttribute(new Uint32Array(geometryProtoModel.index), 1));

		if (geometryProtoModel.normal !== null && geometryProtoModel.normal.length)
		    geometry.addAttribute('normal', new THREE.BufferAttribute(new Float32Array(geometryProtoModel.normal), 3));
		else {
			geometry.computeVertexNormals();
			// var normals = geometry.attributes.normal.array;
			// for (let j = 0; j < normals.length; j++) {
			// 	//normals[j] = this.discretizeNormal(normals[j]);
			// }
			// for (let j = 0; j < normals.length; j+=3) {
			// 	//var normal = new THREE.Vector3(normals[j], normals[j+1], normals[j+2]);
			// 	//normals[j] =Math.abs(normals[j]);
			// }
		}
		
		if (geometryProtoModel.uv !== null && geometryProtoModel.uv.length)
		    geometry.addAttribute('uv', new THREE.BufferAttribute(new Float32Array(geometryProtoModel.uv), 2));

		return geometry;
	},

	getBufferGeometryFromBase64: function (base64string, modelId) {
        //var objLoader = new THREE.OBJLoader();
        //var myObj = objLoader.parse(base64string);
		//return myObj.children[0].geometry;
		var object3dProtoModel = MODEL.utils.Proto.getProtoModelFromBase64(CORE.model.protoBuilder.Model3d, "Model3d", base64string, modelId);

		var geometry = this.getBufferGeometryFromProtoModel(object3dProtoModel.children[0].geometry);

		return geometry;
	},

	getObject3dFromBase64: function (base64string, modelId) {

		var object3dProtoModel = MODEL.utils.Proto.getProtoModelFromBase64(CORE.model.protoBuilder.Model3d, "Model3d", base64string, modelId);

		var object3d = new THREE.Group();

		for (var i = 0; i < object3dProtoModel.children.length; i++) {

			var mesh = new THREE.Mesh();

			var geometry = this.getBufferGeometryFromProtoModel(object3dProtoModel.children[i].geometry, modelId);

			mesh.geometry = geometry;
			mesh.name = object3dProtoModel.children[i].name;

			object3d.add(mesh);
		}

		return object3d;
	}
}