'use strict';
var VIEW3D = VIEW3D || {}

define( ['js/view3d/materials/VIEW3D.materials.ScreenSpace'], function () {

    var trianglesCount = 64;
    var radius = 0.2;
    var geometry = new THREE.BufferGeometry();
    var arcArray = new Float32Array(trianglesCount*3*2);
    for (var i = 0; i < trianglesCount; i++) {
        arcArray[6*i+0] = 0;
        arcArray[6*i+1] = 0;
        arcArray[6*i+2] = radius;
        arcArray[6*i+3] = i/trianglesCount;
        arcArray[6*i+4] = radius;
        arcArray[6*i+5] = i/trianglesCount + 1/trianglesCount;
    }
    geometry.addAttribute('position', new THREE.BufferAttribute( arcArray, 2));

    var material = new VIEW3D.materials.Angle(new THREE.Vector4(0.0,0.4,0.6,0.3), 0);

    VIEW3D.Angle = function () {
        THREE.Mesh.call(this, geometry, material);
        this.frustumCulled = false;
        this.setAngle = function (a) {
            material.uniforms.angle.value = a;
        }
        this.setAngle(0);
    }

    VIEW3D.Angle.prototype = Object.create(THREE.Mesh.prototype);
});

