﻿'use strict';
var VIEW3D = VIEW3D || {}

VIEW3D.Arrow3D = function (loadModel, orentation, startPos) {
    //var arrowMesh = null;
    // Trapezoid
    this.trapezoidalArrowDataPoint1 = [];
    this.trapezoidalArrowDataPoint2 = [];
    this.trapezoidalLineData = [];
    // Force
    this.arrowData = [];
    this.resetArrowMesh = function () {
        /*
        if (!isEmpty(arrowMesh)) {
            this.remove(arrowMesh);
            arrowMesh = null;
        }
        */
        this.arrowContainer = new VIEW3D.Arrows(camera, 1, CORE.constructionView3D.loadsObject3D.arrows.maxArrow);
        this.dispose = function(){
            this.arrowContainer.dispose();
        }

        if (loadModel.type === MODEL.OBJECT_TYPE.BarTrapezoidal) {
            // Trapezoidal
            var p1 = loadModel.points()[0]().vector;
            var p2 = loadModel.points()[1]().vector;

            if (p1.x !== 0) {
                this.trapezoidalArrowDataPoint1.push(
                {
                    dir: new THREE.Vector3(p1.x, 0, 0),
                    pos: startPos.clone(),
                    color: new THREE.Vector3(1, 0, 0),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (p1.y !== 0) {
                this.trapezoidalArrowDataPoint1.push(
                {
                    dir: new THREE.Vector3(0, p1.y, 0),
                    pos: startPos.clone(),
                    color: new THREE.Vector3(0, 1, 0),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (p1.z !== 0) {
                this.trapezoidalArrowDataPoint1.push(
                {
                    dir: new THREE.Vector3(0, 0, p1.z),
                    pos: startPos.clone(),
                    color: new THREE.Vector3(0, 0, 1),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (p2.x !== 0) {
                this.trapezoidalArrowDataPoint2.push(
                {
                    dir: new THREE.Vector3(p2.x, 0, 0),
                    pos: startPos.clone(),
                    color: new THREE.Vector3(1, 0, 0),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (p2.y !== 0) {
                this.trapezoidalArrowDataPoint2.push(
                {
                    dir: new THREE.Vector3(0, p2.y, 0),
                    pos: startPos.clone(),
                    color: new THREE.Vector3(0, 1, 0),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (p2.z !== 0) {
                this.trapezoidalArrowDataPoint2.push(
                {
                    dir: new THREE.Vector3(0, 0, p2.z),
                    pos: startPos.clone(),
                    color: new THREE.Vector3(0, 0, 1),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (p1.x !== 0 || p2.x) {
                this.trapezoidalLineData.push({
                    dir1: new THREE.Vector3(p1.x, 0, 0),
                    dir2: new THREE.Vector3(p2.x, 0, 0),
                    pos1: startPos.clone(),
                    pos2: startPos.clone().addScalar(0.00001),
                    color: new THREE.Vector3(1, 0, 0),
                    type: VIEW3D.Arrows.Line
                });
            }
            if (p1.y !== 0 || p2.y) {
                this.trapezoidalLineData.push({
                    dir1: new THREE.Vector3(0, p1.y, 0),
                    dir2: new THREE.Vector3(0, p2.y, 0),
                    pos1: startPos.clone(),
                    pos2: startPos.clone().addScalar(0.00001),
                    color: new THREE.Vector3(0, 1, 0),
                    type: VIEW3D.Arrows.Line
                });
            }
            if (p1.z !== 0 || p2.z) {
                this.trapezoidalLineData.push({
                    dir1: new THREE.Vector3(0, 0, p1.z),
                    dir2: new THREE.Vector3(0, 0, p2.z),
                    pos1: startPos.clone(),
                    pos2: startPos.clone().addScalar(0.00001),
                    color: new THREE.Vector3(0, 0, 1),
                    type: VIEW3D.Arrows.Line
                });
            }
            this.arrowContainer.addArrows(this.trapezoidalArrowDataPoint1, undefined);
            this.arrowContainer.addArrows(this.trapezoidalArrowDataPoint2, undefined);
            this.arrowContainer.addArrows(this.trapezoidalLineData, undefined);
        } else {
            // Force
            if (loadModel.forces().x !== 0) {
                this.arrowData.push(
                {
                    dir: new THREE.Vector3(loadModel.forces().x, 0, 0),
                    pos: new THREE.Vector3(0, 0, 0),
                    color: new THREE.Vector3(1, 0, 0),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (loadModel.forces().y !== 0) {
                this.arrowData.push(
                {
                    dir: new THREE.Vector3(0, loadModel.forces().y, 0),
                    pos: new THREE.Vector3(0, 0, 0),
                    color: new THREE.Vector3(0, 1, 0),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (loadModel.forces().z !== 0) {
                this.arrowData.push(
                {
                    dir: new THREE.Vector3(0, 0, loadModel.forces().z),
                    pos: new THREE.Vector3(0, 0, 0),
                    color: new THREE.Vector3(0, 0, 1),
                    type: VIEW3D.Arrows.Arrow
                });
            }
            if (loadModel.moments().x !== 0) {
                this.arrowData.push(
                {
                    dir: new THREE.Vector3(loadModel.moments().x, 0, 0),
                    pos: new THREE.Vector3(0, 0, 0),
                    color: new THREE.Vector3(1, 0, 0),
                    type: VIEW3D.Arrows.Moment
                });
            }
            if (loadModel.moments().y !== 0) {
                this.arrowData.push(
                {
                    dir: new THREE.Vector3(0, loadModel.moments().y, 0),
                    pos: new THREE.Vector3(0, 0, 0),
                    color: new THREE.Vector3(0, 1, 0),
                    type: VIEW3D.Arrows.Moment
                });
            }
            if (loadModel.moments().z !== 0) {
                this.arrowData.push(
                {
                    dir: new THREE.Vector3(0, 0, loadModel.moments().z),
                    pos: new THREE.Vector3(0, 0, 0),
                    color: new THREE.Vector3(0, 0, 1),
                    type: VIEW3D.Arrows.Moment
                });
            }
            this.arrowContainer.addArrows(this.arrowData, undefined);
        }
        this.add(this.arrowContainer);
    }
    this.updatePos = function (pos) {
        var i;

        if (this.trapezoidalArrowDataPoint1.length !== 0) {
            for (i = 0; i < this.trapezoidalArrowDataPoint1.length; i++) {
                this.trapezoidalArrowDataPoint1[i].pos.x = pos.x;
                this.trapezoidalArrowDataPoint1[i].pos.y = pos.y;
                this.trapezoidalArrowDataPoint1[i].pos.z = pos.z;
            }
        }
        if (this.trapezoidalArrowDataPoint2.length !== 0) {
            for (i = 0; i < this.trapezoidalArrowDataPoint2.length; i++) {
                this.trapezoidalArrowDataPoint2[i].pos.x = pos.x;
                this.trapezoidalArrowDataPoint2[i].pos.y = pos.y;
                this.trapezoidalArrowDataPoint2[i].pos.z = pos.z;
            }
        }
        if (this.arrowData.length !== 0) {
            for (i = 0; i < this.arrowData.length; i++) {
                this.arrowData[i].pos.x = pos.x;
                this.arrowData[i].pos.y = pos.y;
                this.arrowData[i].pos.z = pos.z;
            }
        }
        if (this.trapezoidalLineData.length !== 0) {
            for (i = 0; i < this.trapezoidalLineData.length; i++) {
                this.trapezoidalLineData[i].pos1.x = pos.x;
                this.trapezoidalLineData[i].pos1.y = pos.y;
                this.trapezoidalLineData[i].pos1.z = pos.z;

                this.trapezoidalLineData[i].pos2.x = pos.x + 0.00001;
                this.trapezoidalLineData[i].pos2.y = pos.y + 0.00001;
                this.trapezoidalLineData[i].pos2.z = pos.z + 0.00001;
            }
        }
        this.arrowContainer.updateAllArrows();
        
    }
    this.updatePosP2 = function (pos) {
        var i;
        for (i = 0; i < this.trapezoidalArrowDataPoint2.length; i++) {
            this.trapezoidalArrowDataPoint2[i].pos.x = pos.x;
            this.trapezoidalArrowDataPoint2[i].pos.y = pos.y;
            this.trapezoidalArrowDataPoint2[i].pos.z = pos.z;
        }
        for (i = 0; i < this.trapezoidalLineData.length; i++) {
            this.trapezoidalLineData[i].pos2.x = pos.x + 0.00001;
            this.trapezoidalLineData[i].pos2.y = pos.y + 0.00001;
            this.trapezoidalLineData[i].pos2.z = pos.z + 0.00001;
        }
        this.arrowContainer.updateAllArrows();
    }
    THREE.Object3D.call(this);
    this.resetArrowMesh();
};
VIEW3D.Arrow3D.prototype = Object.create(THREE.Object3D.prototype);