'use strict';
var VIEW3D = VIEW3D || {}

define(['js/view3d/VIEW3D.MultiMesh'], function (color, coneProps) {

    color = color || VIEW3D.measurementColor;
    coneProps = coneProps || {radius : 0.01, height: 0.02, radialSegments: 8}

    VIEW3D.Arrowheads = function() {
        var attributes = {
            position: {
                type: Float32Array,
                size: 3
            },
            normal: {
                type: Float32Array,
                size: 3
            }
        };

        var material = new THREE.MeshBasicMaterial({color:color})
        VIEW3D.MultiMesh.call(this, attributes, material)

        var coneGeometry = new THREE.ConeBufferGeometry( coneProps.radius, coneProps.height, coneProps.radialSegments );
        var template = new VIEW3D.MeshTemplate();
        template.setGeometry(coneGeometry);

        //PUBLIC:
        this.add = function(transform) {
            return this.addMeshFromTemplate(template, transform)
        }

        this.remove = function(arrowHead) {
            this.removeMesh(arrowHead);
        }
    }

    VIEW3D.Arrowheads.prototype = Object.create(VIEW3D.MultiMesh.prototype);
});
