﻿'use strict';
var VIEW3D = VIEW3D || {};

define([], function () {

VIEW3D.BitmapFont = function (data, texture) {
    if (isEmpty(data)) {
        data = VIEW3D.BitmapFont.data;
    }
    if (isEmpty(texture)) {
        texture = CORE.res.texture["font"];
    }
    this.font = parseBMFontAscii(data);
    this.texture = texture;
    this.createText = function (text) {
        return THREE.bmfonts.createText();
    };
};
VIEW3D.BitmapFont.data =
'info face=font size=40 bold=0 italic=0 charset= unicode= stretchH=100 smooth=1 aa=1 padding=2,2,2,2 spacing=0,0 outline=0\n\
common lineHeight=45 base=32 scaleW=256 scaleH=256 pages=1 packed=0\n\
page id=0 file="font.png"\n\
chars count=90\n\
char id=97 x=2 y=2 width=19 height=22 xoffset=1 yoffset=10 xadvance=22 page=0 chnl=15\n\
char id=98 x=2 y=26 width=18 height=29 xoffset=3 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=99 x=2 y=57 width=18 height=22 xoffset=2 yoffset=10 xadvance=20 page=0 chnl=15\n\
char id=100 x=2 y=81 width=18 height=29 xoffset=1 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=101 x=2 y=112 width=19 height=22 xoffset=1 yoffset=10 xadvance=22 page=0 chnl=15\n\
char id=102 x=22 y=26 width=12 height=29 xoffset=0 yoffset=2 xadvance=11 page=0 chnl=15\n\
char id=103 x=22 y=57 width=19 height=30 xoffset=1 yoffset=10 xadvance=22 page=0 chnl=15\n\
char id=104 x=36 y=2 width=17 height=29 xoffset=3 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=105 x=2 y=136 width=4 height=29 xoffset=3 yoffset=3 xadvance=9 page=0 chnl=15\n\
char id=106 x=2 y=167 width=8 height=37 xoffset=-2 yoffset=3 xadvance=9 page=0 chnl=15\n\
char id=107 x=8 y=136 width=17 height=29 xoffset=3 yoffset=3 xadvance=20 page=0 chnl=15\n\
char id=108 x=23 y=89 width=4 height=29 xoffset=3 yoffset=3 xadvance=9 page=0 chnl=15\n\
char id=109 x=36 y=33 width=28 height=22 xoffset=3 yoffset=10 xadvance=33 page=0 chnl=15\n\
char id=110 x=55 y=2 width=17 height=22 xoffset=3 yoffset=10 xadvance=22 page=0 chnl=15\n\
char id=111 x=2 y=206 width=20 height=22 xoffset=1 yoffset=10 xadvance=22 page=0 chnl=15\n\
char id=112 x=12 y=167 width=18 height=30 xoffset=3 yoffset=10 xadvance=22 page=0 chnl=15\n\
char id=113 x=27 y=120 width=18 height=30 xoffset=1 yoffset=10 xadvance=22 page=0 chnl=15\n\
char id=114 x=2 y=230 width=12 height=22 xoffset=3 yoffset=10 xadvance=13 page=0 chnl=15\n\
char id=115 x=16 y=230 width=18 height=22 xoffset=1 yoffset=10 xadvance=20 page=0 chnl=15\n\
char id=116 x=29 y=89 width=10 height=29 xoffset=1 yoffset=3 xadvance=11 page=0 chnl=15\n\
char id=117 x=41 y=89 width=17 height=22 xoffset=3 yoffset=11 xadvance=22 page=0 chnl=15\n\
char id=118 x=24 y=199 width=19 height=21 xoffset=1 yoffset=11 xadvance=20 page=0 chnl=15\n\
char id=119 x=43 y=57 width=29 height=21 xoffset=0 yoffset=11 xadvance=29 page=0 chnl=15\n\
char id=120 x=66 y=26 width=20 height=21 xoffset=0 yoffset=11 xadvance=20 page=0 chnl=15\n\
char id=121 x=36 y=222 width=19 height=30 xoffset=1 yoffset=11 xadvance=20 page=0 chnl=15\n\
char id=122 x=74 y=2 width=19 height=21 xoffset=1 yoffset=11 xadvance=20 page=0 chnl=15\n\
char id=65 x=32 y=152 width=27 height=29 xoffset=0 yoffset=3 xadvance=27 page=0 chnl=15\n\
char id=66 x=47 y=113 width=22 height=29 xoffset=3 yoffset=3 xadvance=27 page=0 chnl=15\n\
char id=67 x=60 y=80 width=26 height=30 xoffset=2 yoffset=2 xadvance=29 page=0 chnl=15\n\
char id=68 x=74 y=49 width=24 height=29 xoffset=3 yoffset=3 xadvance=29 page=0 chnl=15\n\
char id=69 x=45 y=183 width=22 height=29 xoffset=3 yoffset=3 xadvance=27 page=0 chnl=15\n\
char id=70 x=61 y=144 width=20 height=29 xoffset=3 yoffset=3 xadvance=24 page=0 chnl=15\n\
char id=71 x=71 y=112 width=27 height=30 xoffset=2 yoffset=2 xadvance=31 page=0 chnl=15\n\
char id=72 x=88 y=80 width=23 height=29 xoffset=3 yoffset=3 xadvance=29 page=0 chnl=15\n\
char id=73 x=57 y=214 width=4 height=29 xoffset=4 yoffset=3 xadvance=11 page=0 chnl=15\n\
char id=74 x=63 y=214 width=16 height=29 xoffset=1 yoffset=3 xadvance=20 page=0 chnl=15\n\
char id=75 x=69 y=175 width=24 height=29 xoffset=3 yoffset=3 xadvance=27 page=0 chnl=15\n\
char id=76 x=83 y=144 width=18 height=29 xoffset=3 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=77 x=100 y=111 width=28 height=29 xoffset=3 yoffset=3 xadvance=33 page=0 chnl=15\n\
char id=78 x=95 y=2 width=23 height=29 xoffset=3 yoffset=3 xadvance=29 page=0 chnl=15\n\
char id=79 x=100 y=33 width=28 height=30 xoffset=2 yoffset=2 xadvance=31 page=0 chnl=15\n\
char id=80 x=120 y=2 width=22 height=29 xoffset=3 yoffset=3 xadvance=27 page=0 chnl=15\n\
char id=81 x=113 y=65 width=28 height=32 xoffset=2 yoffset=2 xadvance=31 page=0 chnl=15\n\
char id=82 x=130 y=33 width=25 height=29 xoffset=3 yoffset=3 xadvance=29 page=0 chnl=15\n\
char id=83 x=81 y=206 width=23 height=30 xoffset=2 yoffset=2 xadvance=27 page=0 chnl=15\n\
char id=84 x=144 y=2 width=23 height=29 xoffset=1 yoffset=3 xadvance=24 page=0 chnl=15\n\
char id=85 x=95 y=175 width=23 height=29 xoffset=3 yoffset=3 xadvance=29 page=0 chnl=15\n\
char id=86 x=103 y=142 width=27 height=29 xoffset=0 yoffset=3 xadvance=27 page=0 chnl=15\n\
char id=87 x=130 y=99 width=37 height=29 xoffset=0 yoffset=3 xadvance=38 page=0 chnl=15\n\
char id=88 x=143 y=64 width=26 height=29 xoffset=0 yoffset=3 xadvance=27 page=0 chnl=15\n\
char id=89 x=157 y=33 width=27 height=29 xoffset=0 yoffset=3 xadvance=27 page=0 chnl=15\n\
char id=90 x=169 y=2 width=23 height=29 xoffset=1 yoffset=3 xadvance=24 page=0 chnl=15\n\
char id=33 x=106 y=206 width=5 height=29 xoffset=3 yoffset=3 xadvance=11 page=0 chnl=15\n\
char id=8470 x=113 y=206 width=38 height=29 xoffset=3 yoffset=3 xadvance=43 page=0 chnl=15\n\
char id=59 x=120 y=173 width=5 height=27 xoffset=3 yoffset=11 xadvance=11 page=0 chnl=15\n\
char id=37 x=127 y=173 width=31 height=31 xoffset=2 yoffset=2 xadvance=36 page=0 chnl=15\n\
char id=58 x=88 y=25 width=4 height=21 xoffset=4 yoffset=11 xadvance=11 page=0 chnl=15\n\
char id=63 x=132 y=130 width=19 height=29 xoffset=2 yoffset=2 xadvance=22 page=0 chnl=15\n\
char id=42 x=81 y=238 width=13 height=13 xoffset=1 yoffset=2 xadvance=16 page=0 chnl=15\n\
char id=40 x=153 y=130 width=10 height=38 xoffset=2 yoffset=2 xadvance=13 page=0 chnl=15\n\
char id=41 x=153 y=206 width=10 height=38 xoffset=2 yoffset=2 xadvance=13 page=0 chnl=15\n\
char id=95 x=96 y=246 width=24 height=3 xoffset=-1 yoffset=37 xadvance=22 page=0 chnl=15\n\
char id=43 x=160 y=170 width=19 height=19 xoffset=2 yoffset=8 xadvance=23 page=0 chnl=15\n\
char id=45 x=100 y=65 width=11 height=4 xoffset=1 yoffset=19 xadvance=13 page=0 chnl=15\n\
char id=61 x=160 y=191 width=19 height=12 xoffset=2 yoffset=11 xadvance=23 page=0 chnl=15\n\
char id=46 x=41 y=113 width=4 height=4 xoffset=4 yoffset=27 xadvance=11 page=0 chnl=15\n\
char id=44 x=113 y=99 width=5 height=10 xoffset=3 yoffset=27 xadvance=11 page=0 chnl=15\n\
char id=47 x=165 y=130 width=11 height=30 xoffset=0 yoffset=2 xadvance=11 page=0 chnl=15\n\
char id=124 x=165 y=205 width=3 height=38 xoffset=4 yoffset=2 xadvance=10 page=0 chnl=15\n\
char id=34 x=32 y=183 width=11 height=10 xoffset=2 yoffset=3 xadvance=14 page=0 chnl=15\n\
char id=39 x=94 y=33 width=4 height=10 xoffset=2 yoffset=3 xadvance=8 page=0 chnl=15\n\
char id=64 x=170 y=205 width=37 height=38 xoffset=2 yoffset=2 xadvance=41 page=0 chnl=15\n\
char id=35 x=169 y=95 width=22 height=30 xoffset=0 yoffset=2 xadvance=22 page=0 chnl=15\n\
char id=36 x=178 y=127 width=19 height=36 xoffset=1 yoffset=0 xadvance=22 page=0 chnl=15\n\
char id=94 x=122 y=237 width=17 height=16 xoffset=1 yoffset=2 xadvance=19 page=0 chnl=15\n\
char id=38 x=181 y=165 width=24 height=30 xoffset=2 yoffset=2 xadvance=27 page=0 chnl=15\n\
char id=123 x=186 y=33 width=12 height=38 xoffset=1 yoffset=2 xadvance=13 page=0 chnl=15\n\
char id=125 x=193 y=73 width=12 height=38 xoffset=1 yoffset=2 xadvance=13 page=0 chnl=15\n\
char id=91 x=199 y=113 width=8 height=37 xoffset=3 yoffset=3 xadvance=11 page=0 chnl=15\n\
char id=93 x=207 y=152 width=8 height=37 xoffset=1 yoffset=3 xadvance=11 page=0 chnl=15\n\
char id=49 x=171 y=64 width=11 height=29 xoffset=4 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=50 x=194 y=2 width=19 height=29 xoffset=1 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=51 x=200 y=33 width=19 height=30 xoffset=2 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=52 x=215 y=2 width=20 height=29 xoffset=1 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=53 x=221 y=33 width=19 height=29 xoffset=2 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=54 x=221 y=64 width=19 height=30 xoffset=2 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=55 x=217 y=96 width=19 height=29 xoffset=2 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=56 x=217 y=127 width=19 height=30 xoffset=2 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=57 x=217 y=159 width=19 height=30 xoffset=2 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=48 x=209 y=191 width=19 height=30 xoffset=2 yoffset=3 xadvance=22 page=0 chnl=15\n\
char id=32 x=214 y=243 width=32 height=6 xoffset=2 yoffset=3 xadvance=11 page=0 chnl=15\n\
kernings count=97\n\
kerning first=32 second=65 amount=-2\n\
kerning first=32 second=84 amount=-1\n\
kerning first=32 second=89 amount=-1\n\
kerning first=49 second=49 amount=-3\n\
kerning first=65 second=32 amount=-2\n\
kerning first=65 second=84 amount=-3\n\
kerning first=65 second=86 amount=-3\n\
kerning first=65 second=87 amount=-1\n\
kerning first=65 second=89 amount=-3\n\
kerning first=65 second=118 amount=-1\n\
kerning first=65 second=119 amount=-1\n\
kerning first=65 second=121 amount=-1\n\
kerning first=70 second=44 amount=-4\n\
kerning first=70 second=46 amount=-4\n\
kerning first=70 second=65 amount=-2\n\
kerning first=76 second=32 amount=-1\n\
kerning first=76 second=84 amount=-3\n\
kerning first=76 second=86 amount=-3\n\
kerning first=76 second=87 amount=-3\n\
kerning first=76 second=89 amount=-3\n\
kerning first=76 second=121 amount=-1\n\
kerning first=80 second=32 amount=-1\n\
kerning first=80 second=44 amount=-5\n\
kerning first=80 second=46 amount=-5\n\
kerning first=80 second=65 amount=-3\n\
kerning first=82 second=84 amount=-1\n\
kerning first=82 second=86 amount=-1\n\
kerning first=82 second=87 amount=-1\n\
kerning first=82 second=89 amount=-1\n\
kerning first=84 second=32 amount=-1\n\
kerning first=84 second=44 amount=-4\n\
kerning first=84 second=45 amount=-2\n\
kerning first=84 second=46 amount=-4\n\
kerning first=84 second=58 amount=-4\n\
kerning first=84 second=59 amount=-4\n\
kerning first=84 second=65 amount=-3\n\
kerning first=84 second=79 amount=-1\n\
kerning first=84 second=97 amount=-4\n\
kerning first=84 second=99 amount=-4\n\
kerning first=84 second=101 amount=-4\n\
kerning first=84 second=105 amount=-1\n\
kerning first=84 second=111 amount=-4\n\
kerning first=84 second=114 amount=-1\n\
kerning first=84 second=115 amount=-4\n\
kerning first=84 second=117 amount=-1\n\
kerning first=84 second=119 amount=-2\n\
kerning first=84 second=121 amount=-2\n\
kerning first=86 second=44 amount=-4\n\
kerning first=86 second=45 amount=-2\n\
kerning first=86 second=46 amount=-4\n\
kerning first=86 second=58 amount=-1\n\
kerning first=86 second=59 amount=-1\n\
kerning first=86 second=65 amount=-3\n\
kerning first=86 second=97 amount=-3\n\
kerning first=86 second=101 amount=-2\n\
kerning first=86 second=105 amount=-1\n\
kerning first=86 second=111 amount=-2\n\
kerning first=86 second=114 amount=-1\n\
kerning first=86 second=117 amount=-1\n\
kerning first=86 second=121 amount=-1\n\
kerning first=87 second=44 amount=-2\n\
kerning first=87 second=45 amount=-1\n\
kerning first=87 second=46 amount=-2\n\
kerning first=87 second=58 amount=-1\n\
kerning first=87 second=59 amount=-1\n\
kerning first=87 second=65 amount=-1\n\
kerning first=87 second=97 amount=-1\n\
kerning first=87 second=101 amount=-1\n\
kerning first=87 second=105 amount=0\n\
kerning first=87 second=111 amount=-1\n\
kerning first=87 second=114 amount=-1\n\
kerning first=87 second=117 amount=-1\n\
kerning first=87 second=121 amount=0\n\
kerning first=89 second=32 amount=-1\n\
kerning first=89 second=44 amount=-5\n\
kerning first=89 second=45 amount=-4\n\
kerning first=89 second=46 amount=-5\n\
kerning first=89 second=58 amount=-2\n\
kerning first=89 second=59 amount=-3\n\
kerning first=89 second=65 amount=-3\n\
kerning first=89 second=97 amount=-3\n\
kerning first=89 second=101 amount=-4\n\
kerning first=89 second=105 amount=-1\n\
kerning first=89 second=111 amount=-4\n\
kerning first=89 second=112 amount=-3\n\
kerning first=89 second=113 amount=-4\n\
kerning first=89 second=117 amount=-2\n\
kerning first=89 second=118 amount=-2\n\
kerning first=102 second=102 amount=-1\n\
kerning first=114 second=44 amount=-2\n\
kerning first=114 second=46 amount=-2\n\
kerning first=118 second=44 amount=-3\n\
kerning first=118 second=46 amount=-3\n\
kerning first=119 second=44 amount=-2\n\
kerning first=119 second=46 amount=-2\n\
kerning first=121 second=44 amount=-3\n\
kerning first=121 second=46 amount=-3';

VIEW3D.BitmapFont.extremumData = 
'info face=font size=22 bold=0 italic=0 charset= unicode= stretchH=100 smooth=1 aa=1 padding=2,2,2,2 spacing=0,0 outline=0\n\
common lineHeight=25 base=17 scaleW=64 scaleH=128 pages=1 packed=0\n\
page id=0 file="font.png"\n\
chars count=22\n\
char id=48 x=2 y=2 width=11 height=16 xoffset=1 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=49 x=15 y=2 width=6 height=16 xoffset=2 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=50 x=23 y=2 width=11 height=16 xoffset=1 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=51 x=36 y=2 width=11 height=16 xoffset=1 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=52 x=49 y=2 width=11 height=16 xoffset=0 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=53 x=2 y=20 width=11 height=16 xoffset=1 yoffset=2 xadvance=12 page=0 chnl=15\n\
char id=54 x=15 y=20 width=11 height=16 xoffset=1 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=55 x=28 y=20 width=11 height=16 xoffset=1 yoffset=2 xadvance=12 page=0 chnl=15\n\
char id=56 x=41 y=20 width=11 height=16 xoffset=1 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=57 x=2 y=38 width=11 height=16 xoffset=1 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=101 x=15 y=38 width=11 height=12 xoffset=1 yoffset=6 xadvance=12 page=0 chnl=15\n\
char id=44 x=54 y=20 width=3 height=6 xoffset=2 yoffset=15 xadvance=6 page=0 chnl=15\n\
char id=46 x=59 y=20 width=3 height=3 xoffset=2 yoffset=15 xadvance=6 page=0 chnl=15\n\
char id=37 x=28 y=38 width=17 height=17 xoffset=1 yoffset=1 xadvance=20 page=0 chnl=15\n\
char id=36 x=15 y=52 width=11 height=20 xoffset=1 yoffset=0 xadvance=12 page=0 chnl=15\n\
char id=45 x=54 y=28 width=6 height=2 xoffset=1 yoffset=11 xadvance=7 page=0 chnl=15\n\
char id=43 x=2 y=56 width=11 height=11 xoffset=1 yoffset=4 xadvance=13 page=0 chnl=15\n\
char id=47 x=54 y=32 width=6 height=17 xoffset=0 yoffset=1 xadvance=6 page=0 chnl=15\n\
char id=42 x=2 y=69 width=7 height=7 xoffset=1 yoffset=1 xadvance=9 page=0 chnl=15\n\
char id=8364 x=47 y=51 width=13 height=17 xoffset=0 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=163 x=28 y=57 width=12 height=17 xoffset=0 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=165 x=11 y=74 width=13 height=16 xoffset=0 yoffset=1 xadvance=12 page=0 chnl=15\n\
char id=32 x=45 y=78 width=15 height=2 xoffset=0 yoffset=1 xadvance=6 page=0 chnl=15\n\
kernings count=1\n\
kerning first=49 second=49 amount=-2';
});