"use strict";
var VIEW3D = VIEW3D || {};
define(["js/view3d/VIEW3D.MultiMesh"],
    function() {
        VIEW3D.DmtConnector = function(geometry) {
            var attributes = {
                position: { type: Float32Array, size: 3 },
                color: { type: Float32Array, size: 3 },
                normal: { type: Float32Array, size: 3 }
            };
            //color : 0x5CCCEE | wireframe : true
            //var material = new THREE.MeshLambertMaterial({ ambient: 0x33ffff, color : 0x33ffff });
            //var material = new THREE.MeshPhongMaterial( { ambient: 0xe167f3, color: 0x33ffff, specular: 0xe167f3, shininess: 100 } );
            var material = new VIEW3D.materials.Metal({ diffuseColor: new THREE.Vector3(0.7, 0.7, 0.7) });
            material.side = THREE.DoubleSide;
            VIEW3D.MultiMesh.call(this, attributes, material);
            this.mesh = null;
            this.tempGeometry = MODEL.utils.Proto.getBufferGeometryFromProtoModel(geometry);

            var verticesCount = this.tempGeometry.attributes.position.array.length / 3;
            this.tempGeometry.addAttribute("color", new THREE.BufferAttribute(new Float32Array(verticesCount * 3), 3));
            this.tempGeometry.computeBoundingBox();
            this.template = new VIEW3D.ColorableMeshTemplate();
            this.template.setGeometry(this.tempGeometry);
            this.template.boundingBox = this.tempGeometry.boundingBox;

            this.setTransform = function(transform) {
                if(this.mesh !== null) {
                    this.removeMesh(this.mesh);
                    this.mesh = null;
                }
                this.mesh = this.addMeshFromTemplate(this.template, {
                    transform: transform,
                    color: VIEW3D.getConnectorColor()
                });
            };
        };
        VIEW3D.DmtConnector.prototype = Object.create(VIEW3D.MultiMesh.prototype);
    });