﻿'use strict';
var VIEW3D = VIEW3D || {}

VIEW3D.EditedElements = function() {
    this.data = null;
    this.lines = null;
    this.init = function(data) {
        this.data = data;
        this.createObjects();
    };
    this.createObjects = function() {
        this.dispose();
        this.lines = new THREE.LineSegments(
            new THREE.BufferGeometry(),
            VIEW3D.EditedElements.LinesMaterial,
            THREE.LinePieces);
        this.add(this.lines);
        this.lines.geometry.addAttribute('position', new THREE.BufferAttribute(new Float32Array(this.data.lines.length * 2 * 3), 3));
    }
    this.updateLines = function() {
        var positions = this.lines.geometry.attributes.position.array;
        for (var i = 0; i < this.data.lines.length; i++) {
            var line = this.data.lines[i];
            positions[i * 6 + 0] = line.start.x;
            positions[i * 6 + 1] = line.start.y;
            positions[i * 6 + 2] = line.start.z;
            positions[i * 6 + 3] = line.end.x;
            positions[i * 6 + 4] = line.end.y;
            positions[i * 6 + 5] = line.end.z;
        }
        this.lines.geometry.attributes.position.needsUpdate = true;
        render();
    }
    this.dispose = function() {
        this.remove(this.lines);
        this.lines = null;
    }
    THREE.Object3D.call(this);
}
VIEW3D.EditedElements.prototype = Object.create(THREE.Object3D.prototype);
VIEW3D.EditedElements.LinesMaterial = new THREE.LineDashedMaterial({
    color: 0x80C080
});