"use strict";
var VIEW3D = VIEW3D || {};
VIEW3D.ExternalModels = function() {
    THREE.Object3D.call(this);
    var collider = new VIEW3D.collision.CollidersContainer();
    this.getCollider = function() {
        return collider;
    };
    this.dispose = function() {
    };

    this.removeModel = function(model) {
        CORE.model.removeExternalModel(model);
        var meshes = cache[model.ElementId];
        if(meshes !== undefined) {
            for (var j = 0; j < meshes.length; j++) {
                var mesh = meshes[j];
                mesh.visible = false;
                this.remove(mesh);
            }
        }
        var colliders = collidersCache[model.ElementId];
        if(colliders !== undefined) {
            for (var j = 0; j < colliders.length; j++) {
                var coll = colliders[j];
                collider.removeColliderIfExists(coll);
            }
        }
    };
    var cache = [];
    var collidersCache = [];
    this.addModel = function(model, meshes, isSelectable) {
        cache[model.ElementId] = meshes;
        CORE.model.addExternalModel(model);
        var colliders = [];
        for (var j = 0; j < meshes.length; j++) {
            var mesh = meshes[j];
            this.add(mesh);
            if(mesh.boundingBox != undefined && isSelectable) {
                var boxCollider = new VIEW3D.collision.BoxCollider(mesh.boundingBox, new THREE.Matrix4());
                boxCollider.view3D = this;
                boxCollider.model = model;
                collider.addCollider(boxCollider);
                colliders.push(boxCollider);
            }
        }
        collidersCache[model.ElementId] = colliders;
    };
    //this.add(_caps);
};
VIEW3D.ExternalModels.prototype = Object.create(THREE.Object3D.prototype);