﻿'use strict';
var VIEW3D = VIEW3D || {}

VIEW3D.Fills = function (fills) {
    THREE.Object3D.call(this);
    this.innerFills = [];
    this.onFillAdded = function (fill, index) {
        var fill3D = new VIEW3D.Fill(fill);
        this.innerFills[index] = fill3D;
        this.add(fill3D);
        render();
    }
    this.onFillRemoved = function (fill, index) {
        this.remove(this.innerFills[index]);
        this.innerFills.splice(index, 1);
        render();
    }
    this.dispose = function () {
        for (var i = 0; i < this.innerFills.length; i++) {
            this.innerFills[i].dispose();
        }
        this.fillsListSub.dispose();
    }
    for (var i = 0; i < fills().length; i++) {
        this.onFillAdded.call(this, fills()[i], i);
    }
    this.fillsListSub = HELPERS.subscribeArrayChange(this, fills, "MODEL.fills", this.onFillAdded, this.onFillRemoved);
}
VIEW3D.Fills.prototype = Object.create(THREE.Object3D.prototype);