var VIEW3D = VIEW3D || {};
if (!VIEW3D.elementDirDictionary) VIEW3D.elementDirDictionary = {};
if (!VIEW3D.elementPosDictionary) VIEW3D.elementPosDictionary = {};
if (!VIEW3D.elementMatrixCacheDictionary) VIEW3D.elementMatrixCacheDictionary = {};
VIEW3D.loadBaseFontSize = 15;
define([],
    function() {   
        VIEW3D.Inputs = function (mode, dist, disableEditOnMouse) {
            VIEW3D.elementCounter = VIEW3D.elementCounter + 1;
            var html = $("<input class='View3dInput' onkeypress='return event.charCode >= 48 && event.charCode <= 57 || event.charCode == 46 || event.keyCode == 8 || event.keyCode == 37 || event.keyCode == 39 || event.keyCode == 46'/>");
            
            if (CORE.options.demoMode)
            {
                html.addClass("VIEWUI_pointerDisabled");
            }
            html = html.prop('outerHTML');

            var container = $("#VIEWUI_canvasesContainer");
            var elements = {};
            var lastId = 0;
            var defaultDist = dist || -8;
            var buildMatrix = function(dir, pos, dist, w, isEdit) {
                if(isEdit) dist = -38;
                var l = Math.sqrt(dir.x * dir.x + dir.y * dir.y);
                var vX = { x: dir.x / l, y: dir.y / l };
                var vY = { x: -vX.y, y: vX.x };
                var oX = { x: vX.x * -w / 2, y: vX.y * - w / 2 };
                var o = { x: pos.x + vY.x * dist + oX.x, y: pos.y + vY.y * dist + oX.y };
                if(isEdit) vX.x = 1.0;
                if(isEdit) vX.y = 0.0;
                if(isEdit) vY.x = 0.0;
                if(isEdit) vY.y = 1.0;
                if(isEdit && disableEditOnMouse !== true) {
                    o.x = CORE.view3D.mouse3d.mouseX - 40;
                    o.y = CORE.view3D.mouse3d.mouseY;
                }

                return 'matrix(' +
                    vX.x.toFixed(5) + ',' + // vX.x.toFixed(5)
                    vX.y.toFixed(5) + ',' + // vX.y.toFixed(5)
                    vY.x.toFixed(5) + ',' + // vY.x.toFixed(5)
                    vY.y.toFixed(5) + ',' + // vY.y.toFixed(5)
                    o.x.toFixed(5) + ',' +
                    o.y.toFixed(5) + ')';
            }
            this.display = "inline";
            this.visible = true;
            this.add = function(dir, pos, val, onValChange, dist, isReadonly) {
                lastId++;
                container.append(html);
                var parent = container.children().last();
                var element = parent[0];

                if(CORE.isResultsScreen === true) // if calculation tab, make inputs read-only
                {
                    $(element).addClass('VIEWUI_pointerDisabled');
                    // readOnly = true;?
                }
                
                if(typeof element === 'undefined') return;
                if (isReadonly !== true) {
                    parent.keydown(function(event) {
                        switch (event.keyCode) {
                        case 9:
                        case 38:
                        case 40:
                            event.preventDefault();
                            return false;
                        default:
                            return true;
                        }
                    });
                    parent.keyup(function(event) {
                        switch (event.keyCode) {
                        case 27:
                            this.value = this.lastValue;
                            $(this).blur();
                            break;
                        case 13:
                            this.value = onValChange(this.value);
                            $(this).blur();
                            break;
                        default:
                            break;
                        }
                    });
                    parent.focusout(function() {
                            this.value = this.lastValue;
                            this.className = 'View3dInput';
                            var w = jQuery.css(this, "width", "content");
                            this.style.transform = VIEW3D.elementMatrixCacheDictionary[this.style.transform];// buildMatrix(VIEW3D.elementDirDictionary[this.style.transform], VIEW3D.elementPosDictionary[this.style.transform], 0, w, false);
                        })
                        .focusin(function() {
                            this.className = 'View3dInputWithFocus';
                            var w = jQuery.css(this, "width", "content");
                            var oldMatrix = this.style.transform;
                            var inputObj = this;
                            inputObj.style.transform = buildMatrix(VIEW3D.elementDirDictionary[inputObj.style.transform], VIEW3D.elementPosDictionary[inputObj.style.transform], 0, w, true);
                            VIEW3D.elementMatrixCacheDictionary[inputObj.style.transform] = oldMatrix;
                            // setTimeout(function(){ 
                            //     inputObj.style.transform = buildMatrix(VIEW3D.elementDirDictionary[inputObj.style.transform], VIEW3D.elementPosDictionary[inputObj.style.transform], 0, w, true);
                            //     VIEW3D.elementMatrixCacheDictionary[inputObj.style.transform] = oldMatrix;
                            // }, 100);
                            
                        });
                    parent.mouseenter(function() {
                            if (this.className === "View3dInput") {
                                this.className = 'View3dInputMouseOver';
                            }
                        })
                        .mouseleave(function() {
                            if (this.className === "View3dInputMouseOver") {
                                this.className = 'View3dInput';
                            }
                        });
                    
                }
                else{
                    element.readOnly = true;
                    element.style.fontSize = "small";
                    // element.style.setProperty("width", "60px", "important");
                    element.style.setProperty("padding", "0px", "important");
                }
                elements[lastId] = element;
                if (!element) {
                    console.error("VIEW3D.Inputs: element is empty")
                    return;
                }
                var w = jQuery.css(element, "width", "content");
                
                element.style.transform = buildMatrix(dir, pos, dist || defaultDist, w, element.className === 'View3dInputWithFocus');
                VIEW3D.elementDirDictionary[element.style.transform] = dir;
                VIEW3D.elementPosDictionary[element.style.transform] = pos;
                element.value = val();
                element.lastValue = val();
                element.style.display = this.display;
                return lastId;
            }

            this.update = function(elementId, dir, pos, dist) {
                var element = elements[elementId];
                if (!element) {
                    //console.error("VIEW3D.Inputs: element is empty")
                    return;
                }
                var w = jQuery.css(element, "width", "content");
                element.style.transform = buildMatrix(dir, pos, dist || defaultDist, w, element.className === 'View3dInputWithFocus');
                VIEW3D.elementDirDictionary[element.style.transform] = dir;
                VIEW3D.elementPosDictionary[element.style.transform] = pos;
            }
            this.setValue = function(elementId, val) {
                var element = elements[elementId];
                element.value = val;
                element.lastValue = val;
            }
            this.remove = function(elementId) {
                var element = elements[elementId];
                if (!element) {
                    console.error("VIEW3D.Inputs: element is empty")
                    return;
                }
               element.parentElement.removeChild(element);
                delete elements[elementId];
            }
            var subMode = null;
            this.dispose = function() {
                for (var elId in elements) {
                    var element = elements[elId];
                    if (!element) {
                        console.error("VIEW3D.Inputs: element is empty")
                        return;
                    }
                    element.parentElement.removeChild(element);
                }
                if (!isEmpty(subMode)) {
                    subMode.dispose();
                    subMode = null;
                }
                elements = {};
            }
            this.onModeChange = function(newMode) {
                var pointerEvents = "auto";
                switch (newMode) {
                case MODE.DRAW_BAR:
                case MODE.DRAW_NODE:
                case MODE.EDIT:
                    pointerEvents = 'none';
                    break;
                default:
                    break;
                }
                for (var id in elements) {
                    var element = elements[id];
                    element.style.pointerEvents = pointerEvents;
                }
            };
            if (mode) {
                subMode = HELPERS.subscribePropertyChange(this, mode, "mode", this.onModeChange);
            }
            this.show = function(visible) {
                this.display = visible ? "inline" : "none";
                for (var id in elements) {
                    var element = elements[id];
                    element.style.display = this.display;
                }
                this.visible = visible;
            }
            this.setFocusOnFirstInput = function() {
                for (var id in elements) {
                    var element = elements[id];
                    element.focus();
                    element.select();
                    break;
                }
            }
            this.setFontSize = function(fontsize) {
                for (var id in elements) {
                    var element = elements[id];
                    element.style.setProperty("font-size", fontsize, "important");
                    element.style.color = "#000";
                }
            }
        }
        VIEW3D.MeasurementInputs = function(camera, containerSize, mode, anchor, offset) {
            var inputs = new VIEW3D.Inputs(mode, offset, true);
            var mesurements = {};
            this.setFocusOnFirstInput = function() {
                inputs.setFocusOnFirstInput();
            }
            var toScreen = function(v, matrix, w, h) {
                var onScreen = new THREE.Vector3(v.x, v.y, v.z);
                onScreen.applyMatrix4(matrix);
                onScreen.x = w / 2 + onScreen.x * w / 2;
                onScreen.y = h / 2 - onScreen.y * h / 2;
                onScreen.z = 0;
                return onScreen;
            }
            var getPos2DAndDir = function(measurement, vpMatrix, camDir) {
                var size = containerSize();
                var p1 = measurement.start();
                var p2 = measurement.getEnd();
                var dir1 = new THREE.Vector3(0, 0, -1);
                var dir2 = new THREE.Vector3(0, -1, 0);
                var dx = Math.abs(p2.x - p1.x);
                var dy = Math.abs(p2.y - p1.y) * 0.999;
                var dz = Math.abs(p2.z - p1.z) * 0.999;
                if (dy > dx && dy > dz) {
                    dir1.set(0, 0, -1);
                    dir2.set(-1, 0, 0);
                } else if (dz > dx && dz > dy) {
                    dir1.set(0, -1, 0);
                    dir2.set(-1, 0, 0);
                }
                var dot1 = dir1.dot(camDir);
                var dot2 = dir2.dot(camDir);
                var dir;
                //console.log('dot1 Label logging: ' + measurement.length() + ', dot1 value: ' + dot1);
                //console.log('dot2 Label logging: ' + measurement.length() + ', dot2 value: ' + dot2);
                if ((Math.abs(dot1) < Math.abs(dot2)) && (Math.abs(Math.abs(dot1) - Math.abs(dot2))> 0.00000000001)) {
                    dir = dir1;
                } else {
                    dir = dir2;
                }
                dir.multiplyScalar(anchor);
                var start = HELPERS.toVector3(measurement.start());
                var end = HELPERS.toVector3(measurement.getEnd());
                start.add(dir);
                end.add(dir);
                var s = toScreen(start, vpMatrix, size.width, size.height);
                var e = toScreen(end, vpMatrix, size.width, size.height);
                if (s.x > e.x && Math.abs(s.x - e.x) > 0.01) {
                    var t = s;
                    s = e;
                    e = t;
                }
                var v = e.sub(s);
                var m = s.add(v.multiplyScalar(0.5));
                //console.log('Direction Label logging: ' + measurement.length() + ', dir value: ' + v.x + ',' + v.y + ',' + v.z);
                //console.log('Postion Label logging: ' + measurement.length() + ', pos value: ' + m.x + ',' + m.y + ',' + m.z);
                return { pos: m, dir: v };
            }
            this.add = function(measurement) {
                var matrix = new THREE.Matrix4();
                matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                var camViewElemets = camera.matrixWorldInverse.elements;
                var camDir = new THREE.Vector3(camViewElemets[2], camViewElemets[6], camViewElemets[10]);
                var pd = getPos2DAndDir(measurement, matrix, camDir);
                var value = convertUnits(measurement.length, "Distance");
                var id = inputs.add(pd.dir,
                    pd.pos,
                    value,
                    function(newLength) {
                        var num = Number(newLength);
                        if (!isEmpty(measurement.validate)) {
                            value(measurement.validate(num));
                        } else if (num > 0) {
                            value(num);
                        }
                        return convertUnits(measurement.length(), "Distance");
                    });
                mesurements[id] = measurement;
            }
            this.updateAll = function() {
                if (!inputs.visible) {
                    return;
                }
                var matrix = new THREE.Matrix4();
                matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                var camViewElemets = camera.matrixWorldInverse.elements;
                var camDir = new THREE.Vector3(camViewElemets[2], camViewElemets[6], camViewElemets[10]);
                for (var id in mesurements) {
                    var measurement = mesurements[id];
                    var pd = getPos2DAndDir(measurement, matrix, camDir);
                    inputs.update(id, pd.dir, pd.pos);
                }
            }
            this.updateDisplayedValues = function() {
                for (var id in mesurements) {
                    var measurement = mesurements[id];
                    inputs.setValue(id, convertUnits(measurement.length(), 'Distance'));
                }
            }
            camera.changeEvent.subscribe(this.updateAll.bind(this));
            this.clearAll = function (){
                mesurements = [];
                inputs.dispose();
            }
            this.dispose = function() {
                this.clearAll();
                this.unitsObserver.dispose();
            }
            this.show = function(visible) {
                inputs.show(visible);
                if (visible) {
                    this.updateAll();
                }
            }
            this.unitsObserver = new UnitsObserver("Distance", this.updateDisplayedValues.bind(this));
        }
        VIEW3D.LineMeasurementInputs = function(camera, containerSize, mode, anchor, offset) {
            var inputs = new VIEW3D.Inputs(mode, offset);
            var mesurements = {};
            this.setFocusOnFirstInput = function() {
                inputs.setFocusOnFirstInput();
            }
            var toScreen = function(v, matrix, w, h) {
                var onScreen = new THREE.Vector3(v.x, v.y, v.z);
                onScreen.applyMatrix4(matrix);
                onScreen.x = w / 2 + onScreen.x * w / 2;
                onScreen.y = h / 2 - onScreen.y * h / 2;
                onScreen.z = 0;
                return onScreen;
            }
            var dirToScreen = function(v, matrix, w, h) {
                var onScreen = new THREE.Vector3(v.x, v.y, v.z);
                VIEW3D.utils.transformDir(onScreen, matrix);
                onScreen.x = onScreen.x * w / 2;
                onScreen.y = -onScreen.y * h / 2;
                onScreen.z = 0;
                return onScreen;
            }

            var calcZoomParam = function() {
                var zoom = CORE.view3D.cameraControl.camera.zoom;
                var zoomProc = (zoom + 65)/100.0;
                var zoomParam = Math.pow(zoomProc,2.25);
                return zoomParam;
            };

            var getPos2DAndDir = function(measurement, vpMatrix, measDir) {
                var size = containerSize();
                var start = HELPERS.toVector3(measurement.start());
                var end = HELPERS.toVector3(measurement.getEnd());
                var s = toScreen(start, vpMatrix, size.width, size.height);
                var e = toScreen(end, vpMatrix, size.width, size.height);
                if (s.x > e.x + 0.1) {
                    var t = s;
                    s = e;
                    e = t;
                }
                var v = e.sub(s);
                var d = dirToScreen(measDir, vpMatrix, size.width, size.height);
                var cross2D = v.x * d.y - v.y * d.x;
                var sw = cross2D > 0.0001 && d.x*d.x + d.y*d.y > 0.001;
                var m = s.add(v.multiplyScalar(0.5));
                var scaledOffset = offset*calcZoomParam();
                return { pos: m, dir: v, offset: sw ? -8 - scaledOffset : -8 + scaledOffset };
            }
            this.measDir = new THREE.Vector3(0, 0, -1);
            this.add = function(measurement) {
                var matrix = new THREE.Matrix4();
                matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                var pd = getPos2DAndDir(measurement, matrix, this.measDir);
                var value = convertUnits(measurement.length, "Distance");
                var id = inputs.add(pd.dir,
                    pd.pos,
                    value,
                    function(newLength) {
                        var num = Number(newLength);
                        if (!isEmpty(measurement.validate)) {
                            value(measurement.validate(num));
                        } else if (num > 0) {
                            value(num);
                        }
                        return convertUnits(measurement.length(), "Distance");
                    },
                    pd.offset);
                mesurements[id] = measurement;
            }
            this.updateAll = function() {
                if (!inputs.visible) {
                    return;
                }
                var matrix = new THREE.Matrix4();
                matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                for (var id in mesurements) {
                    var measurement = mesurements[id];
                    var pd = getPos2DAndDir(measurement, matrix, this.measDir);
                    inputs.update(id, pd.dir, pd.pos, pd.offset);
                }
            }

            this.updateDisplayedValues = function() {
                for (var id in mesurements) {
                    var measurement = mesurements[id];
                    inputs.setValue(id, convertUnits(measurement.length(), 'Distance'));
                }
            }

            camera.changeEvent.subscribe(this.updateAll.bind(this));
            this.clearAll = function (){
                mesurements = [];
                inputs.dispose();
            }
            this.dispose = function() {
                this.clearAll();
                this.unitsObserver.dispose();
            }
            this.show = function(visible) {
                inputs.show(visible);
                if (visible) this.updateAll();
            }
            this.unitsObserver = new UnitsObserver("Distance", this.updateDisplayedValues.bind(this));
        }

        VIEW3D.ForceMeasurementInputs = function(camera, containerSize, mode, offset, customUnitType) {

            var inputs = new VIEW3D.Inputs(mode, offset);
            var unitType = customUnitType || "Force";   // default 'Force'
            var items = {};
            this.setFocusOnFirstInput = function() {
                inputs.setFocusOnFirstInput();
            }
            var toScreen = function(v, matrix, w, h) {
                var onScreen = new THREE.Vector3(v.x, v.y, v.z);
                onScreen.applyMatrix4(matrix);
                onScreen.x = w / 2 + onScreen.x * w / 2;
                onScreen.y = h / 2 - onScreen.y * h / 2;
                onScreen.z = 0;
                return onScreen;
            }
            var dirToScreen = function(v, matrix, w, h) {
                var onScreen = new THREE.Vector3(v.x, v.y, v.z);
                VIEW3D.utils.transformDir(onScreen, matrix);
                onScreen.x = onScreen.x * w / 2;
                onScreen.y = -onScreen.y * h / 2;
                onScreen.z = 0;
                return onScreen;
            }

            var calcZoomParam = function() {
                return 1;
                if(!CORE.view3D) return 1;
                var zoom = CORE.view3D.cameraControl.camera.zoom;
                var zoomProc = zoom/30.0;
                return zoomProc;
            };

            var calcZoomPositionParam = function() {
                if(!CORE.view3D) return 1;
                var zoom = CORE.view3D.cameraControl.camera.zoom;
                var zoomProc = 30.0/zoom;
                return zoomProc;
            }
            var self = this;
            var scalePos = function(positionToScale) {
                return positionToScale*CORE.loadModelScale();
            }
            var calcBasePosition = function() {
                var baseValue = 0.15;
                if(self.maxValue === null) return scalePos(baseValue);
                if(self.forceAbsVal > self.maxValue) return scalePos(baseValue);
                var proportions = self.forceAbsVal / self.maxValue;
                var minProportions = VIEW3D.Arrows.minSize / VIEW3D.Arrows.maxSize;
                if(proportions < minProportions) {
                    proportions = minProportions;
                }

                return scalePos(proportions*baseValue);
            }

            var getPos2DAndDir = function(position, vpMatrix, measDir) {
                var size = containerSize();
                var start = position;
                var q = calcZoomPositionParam()*calcBasePosition();
                var end = new THREE.Vector3(position.x + measDir.x*q, position.y + measDir.y*q, position.z + measDir.z*q);
                var s = toScreen(start, vpMatrix, size.width, size.height);
                var e = toScreen(end, vpMatrix, size.width, size.height);
                if (s.x > e.x + 0.1) {
                    var t = s;
                    s = e;
                    e = t;
                }
                var v = e.sub(s);
                var d = dirToScreen(measDir, vpMatrix, size.width, size.height);
                var cross2D = v.x * d.y - v.y * d.x;
                var sw = cross2D > 0.0001 && d.x*d.x + d.y*d.y > 0.001;
                var m = s.add(v.multiplyScalar(0.5));
                var scaledOffset = calcZoomParam()*offset;
                return { pos: m, dir: v, offset: sw ? -8 - scaledOffset : -8 + scaledOffset };
            }

            
            this.maxValue = null;
            this.measDir = new THREE.Vector3(0, 0, -1);
            this.add = function(position, value, dir) {
                var l = Math.sqrt(dir.x * dir.x + dir.y * dir.y + dir.z * dir.z);
                var tmpDir = new THREE.Vector3(dir.x / l, dir.y / l, dir.z / l);
                this.measDir = tmpDir;
                var matrix = new THREE.Matrix4();
                matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                var pd = getPos2DAndDir(position, matrix, this.measDir);
                var value = convertUnits(value, unitType);
                var id = inputs.add(pd.dir,
                    pd.pos,
                    value,
                    function(newLength) {
                        var num = Number(newLength);

                        if (!isEmpty(measurement.validate)) {
                            value(measurement.validate(num));
                        } else if (num > 0) {
                            value(num);
                        }
                        return convertUnits(measurement.length(), unitType);
                    },
                    pd.offset, true);
                items[id] = position;
                inputs.setFontSize(CORE.loadFontScale()*VIEW3D.loadBaseFontSize);
            }
            this.updateAll = function() {
                if (!inputs.visible || this.isDisposed) {
                    return;
                }
                var matrix = new THREE.Matrix4();
                matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                for (var id in items) {
                    var item = items[id];
                    var pd = getPos2DAndDir(item, matrix, this.measDir);
                    inputs.update(id, pd.dir, pd.pos, pd.offset);
                }
            }

            this.updateDisplayedValues = function() {
                return;
                for (var id in mesurements) {
                    var measurement = mesurements[id];
                    inputs.setValue(id, convertUnits(measurement.length(), unitType));
                }
            }
            this.isDisposed = false;
            camera.changeEvent.subscribe(this.updateAll.bind(this));

            CORE.loadFontScale.subscribe(newValue => {
                inputs.setFontSize(newValue*VIEW3D.loadBaseFontSize);
            });

            this.clearAll = function (){
                inputs.dispose();
            }
            this.dispose = function() {
                this.isDisposed = true;
                this.clearAll();
                //this.unitsObserver.dispose();
            }
            this.show = function(visible) {
                inputs.show(visible);
                if (visible) this.updateAll();
            }
            this.unitsObserver = new UnitsObserver(unitType, this.updateDisplayedValues.bind(this));
        }

        VIEW3D.RotationInputs = function(camera, containerSize) {
            var inputs = new VIEW3D.Inputs(null, -25);
            var rotations = {};
            var toScreen = function(pos, offset, rot, camera, w, h) {
                var matrix = new THREE.Matrix4();
                matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                var s = camera.projectionMatrix.elements[5];
                var pos2D = new THREE.Vector3(pos.x, pos.y, pos.z);
                pos2D.applyMatrix4(matrix);
                var o2D = new THREE.Vector3(offset, 0, 0);
                VIEW3D.utils.transformDir(o2D, rot);
                VIEW3D.utils.transformDir(o2D, camera.matrixWorldInverse);
                o2D.applyMatrix4(camera.projectionMatrix);
                o2D.x /= s;
                o2D.y /= s;
                pos2D.x += o2D.x;
                pos2D.y += o2D.y;
                pos2D.x = w / 2 + pos2D.x * w / 2;
                pos2D.y = h / 2 - pos2D.y * h / 2;
                return pos2D;
            }
            var getPos2DAndDir = function(rotation, camera) {
                var size = containerSize();
                var localRot = new THREE.Matrix4().makeRotationZ(rotation.angle() + rotation.angleOffset);
                var matrix = new THREE.Matrix4().multiplyMatrices(rotation.rotSpace, localRot);
                var s = toScreen(rotation.pos, 0.2, matrix, camera, size.width, size.height);
                return { pos: s, dir: { x: 1, y: 0 } };
            }
            this.add = function(rotation, onChange) {
                var type = "Angle";
                var pd = getPos2DAndDir(rotation, camera);
                var value = convertUnits(rotation.angle, type);
                var id = inputs.add(pd.dir,
                    pd.pos,
                    value,
                    function(newVal) {
                        //var convertedVal = convertUnits(newVal, type);
                        value(newVal); //will change rotation.angle
                        onChange(rotation.angle());
                        return convertUnits(rotation.angle(), type);
                    });
                var inputAngleSub = rotation.angle.subscribe(function(newVal) {
                    var matrix = new THREE.Matrix4();
                    matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                    var rotation = rotations[id].rotation;
                    var pd = getPos2DAndDir(rotation, camera);
                    inputs.update(id, pd.dir, pd.pos);
                    inputs.setValue(id, convertUnits(newVal, type));
                });
                rotations[id] = { rotation: rotation, inputAngleSub: inputAngleSub };
            }
            this.updateAll = function() {
                for (var id in rotations) {
                    var rotation = rotations[id];
                    var pd = getPos2DAndDir(rotation.rotation, camera);
                    inputs.update(id, pd.dir, pd.pos);
                }
            }
            this.updateDisplayedValues = function() {
                for (var id in rotations) {
                    var rotation = rotations[id];
                    inputs.setValue(id, convertUnits(rotation.rotation.angle(), "Angle"));
                }
            }
            var subCamera = camera.changeEvent.subscribe(this.updateAll.bind(this));
            this.clearInputs = function() {
                for (var id in rotations) {
                    rotations[id].inputAngleSub.dispose();
                }
                rotations = [];
                inputs.dispose();
            }
            this.dispose = function() {
                this.clearInputs();
                subCamera.dispose();
                this.unitsObserver.dispose();
            }
            this.show = function(visible) {
                inputs.show(visible);
                if (visible) this.updateAll();
            }
            this.unitsObserver = new UnitsObserver("Angle", this.updateDisplayedValues.bind(this));

        }
        VIEW3D.MoveInputs = function(camera, containerSize) {
            var inputs = new VIEW3D.Inputs(null, -10);
            var moves = {};
            var toScreen = function(pos, camera, w, h, offset) {
                var matrix = new THREE.Matrix4();
                matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                var s = camera.projectionMatrix.elements[5];
                var pos2D = new THREE.Vector3(pos.x, pos.y, pos.z);
                pos2D.applyMatrix4(matrix);
                var o2D = offset.clone();
                VIEW3D.utils.transformDir(o2D, camera.matrixWorldInverse);
                o2D.applyMatrix4(camera.projectionMatrix);
                o2D.x /= s;
                o2D.y /= s;
                pos2D.x += o2D.x;
                pos2D.y += o2D.y;
                pos2D.x = w / 2 + pos2D.x * w / 2;
                pos2D.y = h / 2 - pos2D.y * h / 2;
                return pos2D;
            }
            var getPos2DAndDir = function(move, camera) {
                var size = containerSize();
                var pos = new THREE.Vector3(move.length() - move.startLength, 0, 0);
                pos.applyMatrix4(move.moveSpace);
                var e = move.moveSpace.elements;
                var offset = new THREE.Vector3(e[0], e[1], e[2]).multiplyScalar(0.25);
                pos = pos.add(move.pos);
                var s = toScreen(pos, camera, size.width, size.height, offset);
                return { pos: s, dir: { x: 1, y: 0 } };
            }
            this.add = function(move, onChange) {
                var type = "Distance";
                var pd = getPos2DAndDir(move, camera);
                var value = convertUnits(move.length, type);
                var id = inputs.add(pd.dir,
                    pd.pos,
                    value,
                    function(newVal) {
                        value(newVal); //will change rotation.angle
                        onChange(move.length());
                        return convertUnits(move.length(), type);
                    });
                var inputMoveSub = move.length.subscribe(function(newVal) {
                    var matrix = new THREE.Matrix4();
                    matrix.multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse);
                    var move = moves[id].move;
                    var pd = getPos2DAndDir(move, camera);
                    inputs.update(id, pd.dir, pd.pos);
                    inputs.setValue(id, convertUnits(newVal, type));
                });
                moves[id] = { move: move, inputMoveSub: inputMoveSub };
            }
            this.updateAll = function() {
                for (var id in moves) {
                    var move = moves[id];
                    var pd = getPos2DAndDir(move.move, camera);
                    inputs.update(id, pd.dir, pd.pos);
                }
            }
            this.updateDisplayedValues = function() {
                for (var id in moves) {
                    var move = moves[id];
                    inputs.setValue(id, convertUnits(move.move.length(), 'Distance'));
                }
            }
            var subCamera = camera.changeEvent.subscribe(this.updateAll.bind(this));
            this.clearInputs = function() {
                for (var id in moves) {
                    moves[id].inputMoveSub.dispose();
                }
                moves = [];
                inputs.dispose();
            }
            this.dispose = function() {
                this.clearInputs();
                subCamera.dispose();
                this.unitsObserver.dispose();
            }
            this.show = function(visible) {
                inputs.show(visible);
            }
            this.unitsObserver = new UnitsObserver("Distance", this.updateDisplayedValues.bind(this));
        }

        var UnitsObserver = function(type, onUnitsChange) {
            switch(type){
                case "Distance":
                    this.prcisionSub = HELPERS.subscribePropertyChange(this, VIEWUI.viewOptions.unitDistancePrecision, "VIEWUI.viewOptions.unitDistancePrecision", onUnitsChange);
                    this.unitSub = HELPERS.subscribePropertyChange(this, VIEWUI.viewOptions.unitDistance, "VIEWUI.viewOptions.unitDistance", onUnitsChange);
                    break;
                case "Angle":
                    this.prcisionSub = HELPERS.subscribePropertyChange(this, VIEWUI.viewOptions.unitAnglePrecision, "VIEWUI.viewOptions.unitAnglePrecision", onUnitsChange);
                    this.unitSub = HELPERS.subscribePropertyChange(this, VIEWUI.viewOptions.unitAngle, "VIEWUI.viewOptions.unitAngle", onUnitsChange);
                    break;
            }

            this.dispose = function(){
                this.prcisionSub.dispose();
                this.unitSub.dispose();
            }
        }

    });
