﻿'use strict';
var VIEW3D = VIEW3D || {}

define(['js/view3d/materials/VIEW3D.materials.LoadFill', 'js/view3d/utils/VIEW3D.utils'], function () {
    // class LoadFills extends THREE.Mesh
    VIEW3D.LoadFills = function (camera, maxLength, customMaxFill) {
        var maxLength = maxLength || 1;
        THREE.Object3D.call(this);
        var fillsData = {}; //fills by id
        var lastFillsId = 0;
        var mesh = null;
        var self = this;
        this.maxFill = 0;
        this.minFill = 0.08;
        var maxMoment = 0;
        var posArray = null;
        var indexArray = null;
        var elPosArray = null;
        var colorArray = null;
        var addFillToBuffers = function (startIndex, startVertex, fill/*, collider*/) {
            var x, y, z;
            //var length = maxLength * VIEW3D.LoadFills.maxSize * fill.dir.length() / self.maxFill;
            //var base = VIEW3D.utils.getBaseFromDir(fill.dir);
            var i;
            var fillTemplate = this;
            for (i = 0; i < fillTemplate.indexArray.length; i++) {
                indexArray[startIndex + i] = fillTemplate.indexArray[i] + startVertex / 3;
            }
            for (i = 0; i < fillTemplate.posArray.length; i += 3) {
                x = fillTemplate.posArray[i + 0];
                y = fillTemplate.posArray[i + 1];
                z = fillTemplate.posArray[i + 2];
                //set length
                /*if (Math.abs(x) > 0.001) {
                    x += length - fillTemplate.maxX;
                }*/
                //rotate to dir

                posArray[startVertex + i + 0] = x;//base.baseX.x * x + base.baseY.x * y + base.baseZ.x * z;
                posArray[startVertex + i + 1] = y;//base.baseX.y * x + base.baseY.y * y + base.baseZ.y * z;
                posArray[startVertex + i + 2] = z;//base.baseX.z * x + base.baseY.z * y + base.baseZ.z * z;
                elPosArray[startVertex + i + 0] = fillTemplate.elPosArray[i + 0];//fill.pos.x;
                elPosArray[startVertex + i + 1] = fillTemplate.elPosArray[i + 1];//fill.pos.y;
                elPosArray[startVertex + i + 2] = fillTemplate.elPosArray[i + 2];//fill.pos.z;
                colorArray[startVertex + i + 0] = fill.color.x;
                colorArray[startVertex + i + 1] = fill.color.y;
                colorArray[startVertex + i + 2] = fill.color.z;
            }

            //collider.addCollider(
            //    new VIEW3D.collision.ScreenSegmentCollider(
            //        new THREE.Vector3(fill.pos.x, fill.pos.y, fill.pos.z),
            //        new THREE.Vector3(0, 0, 0),
            //        new THREE.Vector3(fill.pos.x, fill.pos.y, fill.pos.z),
            //        new THREE.Vector3(base.baseX.x * length, base.baseX.y * length, base.baseX.z * length)
            //    ));
        }
        /*var addMomentToBuffers = function (startIndex, startVertex, fill, collider) {
            var x, y, z;
            var length = VIEW3D.LoadFills.maxSize * fill.dir.length() / maxMoment;
            var base = VIEW3D.utils.getBaseFromDir(fill.dir);
            var i;
            for (i = 0; i < momentTemplate.indexArray.length; i++) {
                indexArray[startIndex + i] = momentTemplate.indexArray[i] + startVertex / 3;
            }
            for (i = 0; i < momentTemplate.posArray.length; i += 3) {
                x = momentTemplate.posArray[i + 0];
                y = momentTemplate.posArray[i + 1];
                z = momentTemplate.posArray[i + 2];
                //set length
                if (y < 0 && z > 0) {
                    z += length - momentTemplate.maxY;
                } else {
                    v = new THREE.Vector3(-x, -y, -z);
                    v.normalize();
                    v.multiplyScalar(length - momentTemplate.maxY);
                    y -= v.y;
                    z -= v.z;
                }
                //rotate to dir
                posArray[startVertex + i + 0] = base.baseX.x * x + base.baseY.x * y + base.baseZ.x * z;
                posArray[startVertex + i + 1] = base.baseX.y * x + base.baseY.y * y + base.baseZ.y * z;
                posArray[startVertex + i + 2] = base.baseX.z * x + base.baseY.z * y + base.baseZ.z * z;
                elPosArray[startVertex + i + 0] = fill.pos.x;
                elPosArray[startVertex + i + 1] = fill.pos.y;
                elPosArray[startVertex + i + 2] = fill.pos.z;
                colorArray[startVertex + i + 0] = fill.color.x;
                colorArray[startVertex + i + 1] = fill.color.y;
                colorArray[startVertex + i + 2] = fill.color.z;
            }
            for (i = 0; i < 3 * 2; i++) {
                var a1 = i * 2 * Math.PI / 8;
                var a2 = a1 + 2 * Math.PI / 8;
                var z1 = -Math.sin(a1) * length;
                var y1 = -Math.cos(a1) * length;
                var z2 = -Math.sin(a2) * length;
                var y2 = -Math.cos(a2) * length;
                collider.addCollider(
                    new VIEW3D.collision.ScreenSegmentCollider(
                        new THREE.Vector3(fill.pos.x, fill.pos.y, fill.pos.z),
                        new THREE.Vector3(base.baseY.x * y1 + base.baseZ.x * z1, base.baseY.y * y1 + base.baseZ.y * z1, base.baseY.z * y1 + base.baseZ.z * z1),
                        new THREE.Vector3(fill.pos.x, fill.pos.y, fill.pos.z),
                        new THREE.Vector3(base.baseY.x * y2 + base.baseZ.x * z2, base.baseY.y * y2 + base.baseZ.y * z2, base.baseY.z * y2 + base.baseZ.z * z2)
                    )
                );
            }
        }*/
        /*var addLineToBuffers = function (startIndex, startVertex, fill, collider) {
            var x, y, z;
            var dir1 = fill.dir1.clone().multiplyScalar(maxLength * VIEW3D.LoadFills.maxSize / self.maxFill);
            var dir2 = fill.dir2.clone().multiplyScalar(maxLength * VIEW3D.LoadFills.maxSize / self.maxFill);
            var dir = new THREE.Vector3().subVectors(fill.pos2, fill.pos1);
            var base = VIEW3D.utils.getBaseFromDir(dir);
            var i;
            for (i = 0; i < lineTemplate.indexArray.length; i++) {
                indexArray[startIndex + i] = lineTemplate.indexArray[i] + startVertex / 3;
            }
            for (i = 0; i < lineTemplate.posArray.length; i += 3) {
                x = lineTemplate.posArray[i + 0];
                y = lineTemplate.posArray[i + 1];
                z = lineTemplate.posArray[i + 2];
                //set length
                if (x > 0.0001) {
                    x = 0;
                    elPosArray[startVertex + i + 0] = fill.pos1.x;
                    elPosArray[startVertex + i + 1] = fill.pos1.y;
                    elPosArray[startVertex + i + 2] = fill.pos1.z;
                    posArray[startVertex + i + 0] = base.baseX.x * x + base.baseY.x * y + base.baseZ.x * z + dir1.x;
                    posArray[startVertex + i + 1] = base.baseX.y * x + base.baseY.y * y + base.baseZ.y * z + dir1.y;
                    posArray[startVertex + i + 2] = base.baseX.z * x + base.baseY.z * y + base.baseZ.z * z + dir1.z;
                } else {
                    x = 0;
                    elPosArray[startVertex + i + 0] = fill.pos2.x;
                    elPosArray[startVertex + i + 1] = fill.pos2.y;
                    elPosArray[startVertex + i + 2] = fill.pos2.z;
                    posArray[startVertex + i + 0] = base.baseX.x * x + base.baseY.x * y + base.baseZ.x * z + dir2.x;
                    posArray[startVertex + i + 1] = base.baseX.y * x + base.baseY.y * y + base.baseZ.y * z + dir2.y;
                    posArray[startVertex + i + 2] = base.baseX.z * x + base.baseY.z * y + base.baseZ.z * z + dir2.z;
                }
                colorArray[startVertex + i + 0] = fill.color.x;
                colorArray[startVertex + i + 1] = fill.color.y;
                colorArray[startVertex + i + 2] = fill.color.z;
            }
            collider.addCollider(
                new VIEW3D.collision.ScreenSegmentCollider(
                    new THREE.Vector3(fill.pos1.x, fill.pos1.y, fill.pos1.z),
                    new THREE.Vector3(dir1.x, dir1.y, dir1.z),
                    new THREE.Vector3(fill.pos2.x, fill.pos2.y, fill.pos2.z),
                    new THREE.Vector3(dir2.x, dir2.y, dir2.z)
                )
            );
        }*/
        var increaseBuffer = function (oldBuff, newElementsCount, Type) {
            var oldSize = isEmpty(oldBuff) ? 0 : oldBuff.length;
            var newSize = oldSize + newElementsCount;
            var newBuffer = new Type(newSize);
            if (!isEmpty(oldBuff)) {
                newBuffer.set(oldBuff, 0);
            }
            return newBuffer;
        }
        var reduceBuffer = function (oldBuff, startPos, toRemoveCount, Type) {
            var oldSize = oldBuff.length;
            var newSize = oldSize - toRemoveCount;
            if (newSize === 0) {
                return null;
            }
            var newBuffer = new Type(newSize);
            if (startPos > 0) {
                newBuffer.set(oldBuff.subarray(0, startPos));
            }
            if (startPos + toRemoveCount < oldSize) {
                newBuffer.set(oldBuff.subarray(startPos + toRemoveCount, oldSize), startPos);
            }
            return newBuffer;
        }
        /*var createTemplate = function (obj, addToBuffers) {
            var loader = new THREE.OBJLoader();
            var geometry = loader.parse(obj).children[0].geometry;
            VIEW3D.utils.optimize(geometry);
            var posArray = geometry.attributes.position.array;
            var vertCount = geometry.attributes.position.array.length;
            var indexArray = geometry.getIndex().array;
            var indexCount = indexArray.length;
            var maxX = 0;
            var maxY = 0;
            var maxZ = 0;
            for (var i = 0; i < posArray.length; i += 3) {
                posArray[i + 0] *= VIEW3D.LoadFills.templateScale;
                posArray[i + 1] *= VIEW3D.LoadFills.templateScale;
                posArray[i + 2] *= VIEW3D.LoadFills.templateScale;
                maxX = Math.max(maxX, posArray[i]);
                maxY = Math.max(maxY, posArray[i + 1]);
                maxZ = Math.max(maxY, posArray[i + 1]);
            }
            return {
                vertCount: vertCount,
                posArray: posArray,
                indexArray: indexArray,
                indexCount: indexCount,
                maxX: maxX,
                maxY: maxY,
                maxZ: maxZ,
                addToBuffers: addToBuffers
            }
        }*/

        var createFillTemplate = function (fill, addToBuffers, self) {    // dynamically create geometry from fill object

            var v1 = fill.force1pos;    // positions on bar in world space
            var v2 = fill.force2pos;

            var force1 = HELPERS.toVector3(fill.force1value);  // force values vectors
            var force2 = HELPERS.toVector3(fill.force2value);

            //var scale = VIEW3D.Arrows.maxSize / (self.maxFill || 1);
            var scale = VIEW3D.Arrows.maxSize / (!isEmpty(CORE.constructionView3D) ? (Math.max(CORE.constructionView3D.loadsObject3D.arrows.maxArrow, self.maxFill) || 0) : 1);

            force1 = force1.multiplyScalar(scale);
            force2 = force2.multiplyScalar(scale);

            function validateMin(value) {
                if (value !== 0 && Math.abs(value) < self.minFill){
                    value = value > 0 ? self.minFill : -self.minFill;
                }
                value = value*CORE.loadModelScale(); 
                return value;
            }

            force1.set(validateMin(force1.x), validateMin(force1.y), validateMin(force1.z));
            force2.set(validateMin(force2.x), validateMin(force2.y), validateMin(force2.z));

            var indices = [
                0, 1, 2,
                2, 3, 0
            ];

            var positions = [
                    0, 0, 0,
                    0, 0, 0,
                    force2.x, force2.y, force2.z,   // only one coordinate (x, y or z) should be non-zero
                    force1.x, force1.y, force1.z
            ];

            var elPosArray = [
                    v1.x, v1.y, v1.z,
                    v2.x, v2.y, v2.z,
                    v2.x, v2.y, v2.z,
                    v1.x, v1.y, v1.z,
            ];

            var posArray = positions;
            var vertCount = positions.length;
            var indexArray = indices;
            var indexCount = indices.length;
            var maxX = 0;
            var maxY = 0;
            var maxZ = 0;
            for (var i = 0; i < posArray.length; i += 3) {
                //posArray[i + 0] *= VIEW3D.LoadFills.templateScale;
                //posArray[i + 1] *= VIEW3D.LoadFills.templateScale;
                //posArray[i + 2] *= VIEW3D.LoadFills.templateScale;
                maxX = Math.max(maxX, posArray[i]);
                maxY = Math.max(maxY, posArray[i + 1]);
                maxZ = Math.max(maxZ, posArray[i + 2]);
            }
            return {
                vertCount: vertCount,
                posArray: posArray,
                elPosArray: elPosArray,
                indexArray: indexArray,
                indexCount: indexCount,
                maxX: maxX,
                maxY: maxY,
                maxZ: maxZ,
                addToBuffers: addToBuffers
            }
        }

        //var fillTemplate = createTemplate(VIEW3D.LoadFills.fillObj, addFillToBuffers);
        //var momentTemplate = createTemplate(VIEW3D.LoadFills.momentObj, addMomentToBuffers);
        //var lineTemplate = createTemplate(VIEW3D.LoadFills.lineObj, addLineToBuffers);
        var getTemplate = function (fill) {
            switch (fill.type) {
                case VIEW3D.LoadFills.Fill:
                    return createFillTemplate(fill, addFillToBuffers, self);
                case VIEW3D.LoadFills.Moment:
                    return momentTemplate;
                case VIEW3D.LoadFills.Line:
                    return lineTemplate;
                default:
                    throw "unknown fill type";
            }
        }

        this.getPosMatrix = function () {
            return new THREE.Matrix4().multiplyMatrices(camera.projectionMatrix, camera.matrixWorldInverse).multiply(this.matrixWorld);
        }
        var getDirMatrix = function () {
            var matrixWorldInverse = camera.matrixWorldInverse.clone();
            //remove translation
            matrixWorldInverse.setPosition(new THREE.Vector3(0, 0, 0));
            var projectionMatrix = camera.projectionMatrix.clone();
            //remove zoom
            projectionMatrix.elements[0] /= projectionMatrix.elements[5];
            projectionMatrix.elements[5] = 1.0;
            return new THREE.Matrix4().multiplyMatrices(projectionMatrix, matrixWorldInverse);
        }
        /*this.collisionTest = function (point2D) {
            for (var id in fillsData) {

                var params = {
                    mousePos: point2D,
                    matrix: this.getPosMatrix(),
                    matrixSreenOffset: getDirMatrix(),
                }

                var result = [];
                fillsData[id].collider.intersectMousePos(params, result);
                if (result.length > 0) {
                    return fillsData[id].userData
                }
            }

        }*/
        this.addFills = function (fills, userData) {
            if (fills.length <= 0) {
                return 0;
            }
            //var fillsCollider = new VIEW3D.collision.DisjunctionCollider();

            var fillsId = ++lastFillsId;
            //how many vertices?
            var newVerticesCount = 0;
            var newIndicesCount = 0;
            var i;
            for (i = 0; i < fills.length; i++) {
                newVerticesCount += 4 * 3;//getTemplate(fills[i]).vertCount;
                newIndicesCount += 6;//getTemplate(fills[i]).indexCount;
            }
            //increase buffers size
            posArray = increaseBuffer(posArray, newVerticesCount, Float32Array);
            elPosArray = increaseBuffer(elPosArray, newVerticesCount, Float32Array);
            colorArray = increaseBuffer(colorArray, newVerticesCount, Float32Array);
            indexArray = increaseBuffer(indexArray, newIndicesCount, Uint32Array);
            var startVertex = posArray.length - newVerticesCount;
            var startIndex = indexArray.length - newIndicesCount;
            //add new fills to buffer
            for (i = 0; i < fills.length; i++) {
                var template = getTemplate(fills[i]);
                template.addToBuffers(startIndex, startVertex, fills[i]/*, fillsCollider*/);
                startVertex += template.vertCount;
                startIndex += template.indexCount;
            }
            fillsData[fillsId] = {
                startVertex: posArray.length - newVerticesCount,
                verticesCount: newVerticesCount,
                startIndex: indexArray.length - newIndicesCount,
                indicesCount: newIndicesCount,
                data: fills,
                userData: userData,
                //collider: fillsCollider
            };
            this.updateGeometry();
            return fillsId;
        }

        /*this.getCollider = function (fillsId) {
            return fillsData[fillsId].collider;
        }*/

        this.removeFills = function (fillsId) {
            if (fillsId <= 0) {
                return;
            }
            var fillData = fillsData[fillsId];
            delete fillsData[fillsId];

            posArray = reduceBuffer(posArray, fillData.startVertex, fillData.verticesCount, Float32Array);
            elPosArray = reduceBuffer(elPosArray, fillData.startVertex, fillData.verticesCount, Float32Array);
            colorArray = reduceBuffer(colorArray, fillData.startVertex, fillData.verticesCount, Float32Array);
            indexArray = reduceBuffer(indexArray, fillData.startIndex, fillData.indicesCount, Uint32Array);
            if (!isEmpty(indexArray)) {
                for (var i = fillData.startIndex; i < indexArray.length; i++) {
                    indexArray[i] -= fillData.verticesCount / 3;
                }
            }
            for (var id in fillsData) {
                if (fillsData.hasOwnProperty(id)) {
                    if (id > fillsId) {
                        fillsData[id].startVertex -= fillData.verticesCount;
                        fillsData[id].startIndex -= fillData.indicesCount;
                    }
                }
            }
            this.updateGeometry();
        }
        var willBeUpdated = false;
        this.updateGeometry = function () {
            var self = this;
            if (!willBeUpdated) {
                willBeUpdated = true;
                setTimeout(function () {
                    var newMaxFill = 0;
                    var newMaxMoment = 0;
                    for (var id in fillsData) {
                        if (fillsData.hasOwnProperty(id)) {
                            var fills = fillsData[id];
                            for (var i = 0; i < fills.data.length; i++) {
                                var data = fills.data[i];
                                switch (data.type) {
                                    case VIEW3D.LoadFills.Fill:
                                        newMaxFill = Math.max(newMaxFill, data.force1value.length(), data.force2value.length());
                                        break;
                                    case VIEW3D.LoadFills.Moment:
                                        newMaxMoment = Math.max(newMaxMoment, data.dir.length());
                                        break;
                                }
                            }
                        }
                    }
                    if (Math.abs(self.maxFill - newMaxFill) > 0.0000001 ||
                        Math.abs(maxMoment - newMaxMoment) > 0.0000001) {
                        self.maxFill = Math.max(customMaxFill || 0, newMaxFill);
                        maxMoment = newMaxMoment;
                        self.updateAllFills();
                    }
                    if (mesh != null) {
                        self.remove(mesh);
                    }
                    if (!isEmpty(posArray) && posArray.length > 0) {
                        var geometry = new THREE.BufferGeometry();
                        geometry.addAttribute('position', new THREE.BufferAttribute(posArray, 3));
                        geometry.addAttribute('elementPos', new THREE.BufferAttribute(elPosArray, 3));
                        geometry.addAttribute('color', new THREE.BufferAttribute(colorArray, 3));
                        geometry.setIndex(new THREE.BufferAttribute(indexArray, 1));
                        geometry.computeBoundingSphere();
                        var opacity = 0.1;
                        mesh = new THREE.Mesh(geometry, new VIEW3D.materials.LoadFill(opacity));
                        mesh.frustumCulled = false;
                        self.add(mesh);
                    }
                    render();
                    willBeUpdated = false;
                }, 5);
            }
        }
        this.updateAllFills = function () {
            for (var id in fillsData) {
                if (fillsData.hasOwnProperty(id)) {
                    this.updateFills(id);
                }
            }
        }
        this.updateFills = function (fillsId, newData) {
            if (isEmpty(newData)) {
                newData = fillsData[fillsId].data;
            }
            var startVertex = fillsData[fillsId].startVertex;
            var startIndex = fillsData[fillsId].startIndex;
            //fillsData[fillsId].collider.removeAllColliders();
            for (var i = 0; i < newData.length; i++) {
                var template = getTemplate(newData[i]);
                template.addToBuffers(startIndex, startVertex, newData[i]/*, fillsData[fillsId].collider*/);
                startVertex += template.vertCount;
                startIndex += template.indexCount;
            }
            this.updateGeometry();
        }
        this.getFillsData = function (fillsId) {
            return fillsData[fillsId];
        }
        this.getGeometry = function () {
            return mesh.geometry;
        }

        // CORE.loadModelScale.subscribe(newVal => {
        //     self.updateAllFills();
        // });
    }
    VIEW3D.LoadFills.templateScale = 1;
    VIEW3D.LoadFills.maxSize = 0.2;
    VIEW3D.LoadFills.Fill = 0;
    VIEW3D.LoadFills.Moment = 1;
    VIEW3D.LoadFills.Line = 2;
    VIEW3D.LoadFills.prototype = Object.create(THREE.Object3D.prototype);
    VIEW3D.LoadFills.fillObj = null;
    VIEW3D.LoadFills.lineObj = null;
    VIEW3D.LoadFills.momentObj = null;
});