'use strict';
var VIEW3D = VIEW3D || {}
define(['js/view3d/VIEW3D.Inputs'], function () {

    VIEW3D.LoadInputs = function (camera) {
        var data = [];
        var maxValue = 0;

        this.updateMaxValues = function() {
            var maxValue = 0;
            for (var i = 0; i < data.length; i++) {
                var inputControl = data[i];
                if(inputControl.forceAbsVal > maxValue && inputControl.isDisposed !== true) maxValue = inputControl.forceAbsVal;
            }

            for (var i = 0; i < data.length; i++) {
                var inputControl = data[i];
                inputControl.maxValue = maxValue;
                inputControl.updateAll();
            }
        }

        this.addInputs = function (inputs, arrowsId, customUnitType) {
            if (inputs.length <= 0) {
                return;
            }

            for (i = 0; i < inputs.length; i++) {
                var input = inputs[i];
                var inputControl = new VIEW3D.ForceMeasurementInputs(camera, CORE.screenSize, null, input.offset, customUnitType);
                //inputControl.measDir = input.dir;
                //inputControl.add(input.dir, input.pos, input.val, function(newVal) {}, -8);
                inputControl.forceAbsVal = Math.abs(input.val());
                inputControl.add(input.pos, input.val, input.dir);
                var visible = VIEWUI.viewOptions.loadsVisible();
                inputControl.show(visible);
                inputControl.arrowsId = arrowsId;
                data.push(inputControl);
            }

            this.updateMaxValues();
        }

        this.removeInput = function (arrowsId) {
            if (arrowsId <= 0) {
                return;
            }
            var toDelete = [];
            for (var i = 0; i < data.length; i++) {
                var element = data[i];
                if(element.arrowsId === arrowsId) {
                    element.dispose();
                }
            }
            this.updateMaxValues();
        }

        this.setInputVisibility = function(value) {
            for (var i = 0; i < data.length; i++) {
                var element = data[i];
                element.show(value);
            }
        } 
    }
    VIEW3D.LoadInputs.prototype = Object.create(THREE.Object3D.prototype);
});
