'use strict';
var VIEW3D = VIEW3D || {}

define(['js/view3d/materials/VIEW3D.materials.SnappingLine'], function () {
    VIEW3D.SnapingGuides = function (snap) {
        var geometry = new THREE.BufferGeometry();
        geometry.addAttribute('position', new THREE.BufferAttribute(new Float32Array(20*3), 3));
        geometry.addAttribute('distance', new THREE.BufferAttribute(new Float32Array(20*1), 1));
        geometry.attributes.position.dynamic = true;
        geometry.attributes.distance.dynamic = true;
        this.visible=false;

        var material = new VIEW3D.materials.SnappingLine();

        THREE.LineSegments.call(this, geometry, material);
        this.frustumCulled = false;

        snap.snapingPointsChange.subscribe(function () {
            var posAttr = geometry.attributes.position;
            var distAttr = geometry.attributes.distance;
            var snapPoint = snap.snapedPosition;
            var lineIndex = 0;
            for (var i = 0; i < snap.snapingPoints.length; i++) {
                var snapedPos = snap.snapingPoints[i];
                posAttr.setXYZ(lineIndex*2 + 0, snapedPos.x, snapedPos.y, snapedPos.z);
                posAttr.setXYZ(lineIndex*2 + 1, snapPoint.x, snapPoint.y, snapPoint.z);
                var dist = snapPoint.distanceTo(snapedPos);// Math.abs(snapedPos.x - snapPoint.x);
                distAttr.setX(lineIndex*2+0, 0);
                distAttr.setX(lineIndex*2+1, dist);
                lineIndex++;

                // posAttr.setXYZ(lineIndex*2 + 0, snapPoint.x, snapedPos.y, snapedPos.z);
                // posAttr.setXYZ(lineIndex*2 + 1, snapPoint.x, snapPoint.y, snapedPos.z);
                // distAttr.setX(lineIndex*2+0, dist);
                // dist += Math.abs(snapedPos.y - snapPoint.y);
                // distAttr.setX(lineIndex*2+1, dist);
                // lineIndex++;

                // posAttr.setXYZ(lineIndex*2 + 0, snapPoint.x, snapPoint.y, snapedPos.z);
                // posAttr.setXYZ(lineIndex*2 + 1, snapPoint.x, snapPoint.y, snapPoint.z);
                // distAttr.setX(lineIndex*2+0, dist);
                // distAttr.setX(lineIndex*2+1, dist + Math.abs(snapedPos.z - snapPoint.z));
                // lineIndex++;
            }
            geometry.setDrawRange(0,lineIndex*2)
            posAttr.needsUpdate = true;
            distAttr.needsUpdate = true;

            this.visible = lineIndex > 0;

        }.bind(this));

    }
    VIEW3D.SnapingGuides.prototype = Object.create(THREE.LineSegments.prototype);


});