﻿'use strict';
var VIEW3D = VIEW3D || {}

define(['js/view3d/materials/VIEW3D.materials.ScreenSpace'], function () {
    // class VIEW3D.Support
    VIEW3D.Support = function (position, mat) {
        if (!(position instanceof THREE.Vector3 || position instanceof MODEL.types.Vector)) throw "VIEW3D.Support: position has to be a vector!";

        var geometry = VIEW3D.Support.createGeometry();
        var material = new VIEW3D.materials.ScreenSpace();
        var instance = new THREE.LineSegments(geometry, material);
        instance.position.set(position.x, position.y, position.z);
        var vec;
        for (var i = 0; i < instance.geometry.attributes.position.array.length; i++) {
            vec = new THREE.Vector3(instance.geometry.attributes.position.array[i * 3], instance.geometry.attributes.position.array[i * 3 + 1], instance.geometry.attributes.position.array[i * 3 + 2]).applyMatrix4(mat);
            instance.geometry.attributes.position.array[i * 3] = vec.x;
            instance.geometry.attributes.position.array[i * 3 + 1] = vec.y;
            instance.geometry.attributes.position.array[i * 3 + 2] = vec.z;
        }      
        return instance;
    };

    VIEW3D.Support.createGeometry = function () {
        var geometry = new THREE.BufferGeometry();
        var positions = new Float32Array(78);
        //VIEW3D.Support.geometry.vertices.push(-0.25, -0.25, 0);
        positions[0] = 0;
        positions[1] = -0.025;
        positions[2] = -0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, -0.25, 0);
        positions[3] = 0;
        positions[4] = -0.025;
        positions[5] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, -0.25, 0);
        positions[6] = 0;
        positions[7] = -0.025;
        positions[8] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, 0.25, 0);
        positions[9] = 0;
        positions[10] = 0.025;
        positions[11] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, 0.25, 0);
        positions[12] = 0;
        positions[13] = 0.025;
        positions[14] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(-0.25, 0.25, 0);
        positions[15] = 0;
        positions[16] = 0.025;
        positions[17] = -0.025;
        //VIEW3D.Support.geometry.vertices.push(-0.25, 0.25, 0);
        positions[18] = 0;
        positions[19] = 0.025;
        positions[20] = -0.025;
        //VIEW3D.Support.geometry.vertices.push(-0.25, -0.25, 0);
        positions[21] = 0;
        positions[22] = -0.025;
        positions[23] = -0.025;
        //VIEW3D.Support.geometry.vertices.push(-0.25, -0.25, 0);    
        positions[24] = 0;
        positions[25] = -0.025;
        positions[26] = -0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, 0.25, 0);
        positions[27] = 0;
        positions[28] = 0.025;
        positions[29] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, 0.15, 0);   
        positions[30] = 0;
        positions[31] = 0.015;
        positions[32] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(-0.15, -0.25, 0);
        positions[33] = 0;
        positions[34] = -0.025;
        positions[35] = -0.015;
        //VIEW3D.Support.geometry.vertices.push(0.15, 0.25, 0);  
        positions[36] = 0;
        positions[37] = 0.025;
        positions[38] = 0.015;
        //VIEW3D.Support.geometry.vertices.push(-0.25, -0.15, 0);
        positions[39] = 0;
        positions[40] = -0.015;
        positions[41] = -0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, 0.05, 0);
        positions[42] = 0;
        positions[43] = 0.005;
        positions[44] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(-0.05, -0.25, 0);
        positions[45] = 0;
        positions[46] = -0.025;
        positions[47] = -0.005;
        //VIEW3D.Support.geometry.vertices.push(0.05, 0.25, 0);
        positions[48] = 0;
        positions[49] = 0.025;
        positions[50] = 0.005;
        //VIEW3D.Support.geometry.vertices.push(-0.25, -0.05, 0);
        positions[51] = 0;
        positions[52] = -0.005;
        positions[53] = -0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, -0.05, 0);
        positions[54] = 0;
        positions[55] = -0.005;
        positions[56] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(0.05, -0.25, 0);
        positions[57] = 0;
        positions[58] = -0.025;
        positions[59] = 0.005;
        //VIEW3D.Support.geometry.vertices.push(-0.05, 0.25, 0);
        positions[60] = 0;
        positions[61] = 0.025;
        positions[62] = -0.005;
        //VIEW3D.Support.geometry.vertices.push(-0.25, 0.05, 0);
        positions[63] = 0;
        positions[64] = 0.005;
        positions[65] = -0.025;
        //VIEW3D.Support.geometry.vertices.push(0.25, -0.15, 0);
        positions[66] = 0;
        positions[67] = -0.015;
        positions[68] = 0.025;
        //VIEW3D.Support.geometry.vertices.push(0.15, -0.25, 0);
        positions[69] = 0;
        positions[70] = -0.025;
        positions[71] = 0.015;
        //VIEW3D.Support.geometry.vertices.push(-0.15, 0.25, 0);
        positions[72] = 0;
        positions[73] = 0.025;
        positions[74] = -0.015;
        //VIEW3D.Support.geometry.vertices.push(-0.25, 0.15, 0);
        positions[75] = 0;
        positions[76] = 0.015;
        positions[77] = -0.025;
        var elementPos = new Float32Array(78);
        for (var i = 0; i < 78; i++) {
            elementPos[i] = 0;
        }
        var color = new Float32Array(78);
        for (var i = 0; i < 78; i++) {
            color[i] = 0;
        }
        geometry.addAttribute('position', new THREE.BufferAttribute(positions, 3));
        geometry.addAttribute('elementPos', new THREE.BufferAttribute(elementPos, 3));
        geometry.addAttribute('color', new THREE.BufferAttribute(color, 3));

        return geometry;
    }
});