﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.controls = VIEW3D.controls || {}

VIEW3D.controls.BarUniformEdit = function (parent, selectedObjects, barUniformModel, mouse3D) {
    var enabled = false;
    var arrows = null;
    //var visualization;

    this.enable = function() {
        if (enabled) {
            return;
        }
        arrows = new VIEW3D.Arrows();
        //visualization = new VIEW3D.BarUniform(barUniformModel(), arrows);
        parent.add(arrows);
        enabled = true;
        if (elementsPropertiesCache.barUniformModel !== 0) {
            barUniformModel(elementsPropertiesCache.barUniformModel);
        }
    }
    this.disable = function() {
        if (!enabled) {
            return;
        }
        parent.remove(arrows);
        enabled = false;
    }
    this.onMouseUp = function (event) {
        if (enabled === false) {
            return false;
        }
        //$(document.activeElement).blur();
        var object = mouse3D.object();
        if (!isEmpty(object) && object.type === MODEL.OBJECT_TYPE.Bar) {
            if (this.checkBar(object)) {
                CORE.model.addLoad(barUniformModel());
                barUniformModel().assignTo(object);
                var forces = barUniformModel().forces();
                this.disable();
                barUniformModel(new MODEL.load.bar.BarUniform());
                barUniformModel().forces(forces);
                var oldLoad = new MODEL.load.bar.BarUniform();
                oldLoad.forces(forces);
                elementsPropertiesCache.barUniformModel = oldLoad;
                this.enable();
                return true;
            }
            return false;
        }
        return false;
    }
    this.checkBar = function (newBar) {
        return true;
    }
}