﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.controls = VIEW3D.controls || {}

VIEW3D.controls.MeasurementEdit = function (mouse3D) {
    var enabled = false;
    this.enable = function () {
        if (enabled === true) {
            return;
        }
        enabled = true;
    }
    this.disable = function () {
        if (enabled === false) {
            return;
        }
        enabled = false;
    }
    this.onMouseUp = function (event) {

        if (enabled === false || (isEmpty(CORE.options.mode) && (event.target.parentElement && event.target.parentElement.id !== "webGlContainer"))) {
            return false;
        }
        var object = mouse3D.object();
        if (!isEmpty(object) && object.type === MODEL.OBJECT_TYPE.Measurement) {
            VIEWUI.measurementEdit.edit(
                object,
                canvas.clientWidth / 2 * (1 + mouse3D.position().x),    // mouse3D - this is not the position of the mouse! (but it is set by the VIEW3D.Measurements.getLabel function)
                canvas.clientHeight / 2 * (1 - mouse3D.position().y)
                );
        }
        return false;
    }
}
