﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.controls = VIEW3D.controls || {}

VIEW3D.controls.NodeForceEdit = function(parent, selectedObjects, nodeForceModel) {
    var enabled = false;
    var visualization = null;
    var selSubscription = null;
    this.enable = function() {
        if (enabled) {
            return;
        }
        selSubscription = HELPERS.subscribeArrayChange(this, selectedObjects, "model.nodes", this.onSelectionAdded, this.onSelectionRemoved);
        visualization = new VIEW3D.NodeForce(nodeForceModel(), parent);
        enabled = true;
    }
    this.disable = function() {
        if (!enabled) {
            return;
        }
        visualization.clean();
        selSubscription.dispose();
        enabled = false;
    }
    this.onSelectionAdded = function(sel) {
        if (sel instanceof MODEL.Node) {
            nodeForceModel().assignTo(sel);
        }
    }
    this.onSelectionRemoved = function(sel) {
        if (sel instanceof MODEL.Node) {
            nodeForceModel().removeAssignment(sel);
        }
    }
}