﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.controls = VIEW3D.controls || {}

VIEW3D.controls.Select = function (camera, construction, mouse3D, viewName) {    // viewName - for debugging
    var enabled = false;
    this.forceMultiSelection = false;
    this.viewName = viewName;
    this.enable = function() {
        if (enabled === true) {
            return;
        }
        enabled = true;
    }
    this.disable = function() {
        if (enabled === false) {
            return;
        }
        enabled = false;
    }
    this.onMouseUp = function (event) {

        if (enabled === false || (isEmpty(CORE.options.mode) && (event.target.parentElement && event.target.parentElement.id !== "webGlContainer"))) {
            return false;
        }
        if (event.button === 0) {
            var object = mouse3D.object();

            if(!isEmpty(object) && object.type == MODEL.OBJECT_TYPE.Measurement) {
                //ignore i clicked on Measurement
                return false;
            }

            var multiSel = event.ctrlKey || this.forceMultiSelection;
            if (!multiSel) {
                construction.deselectAll();
            }
            if (!isEmpty(object)) {
                if (object.selected !== undefined) {//can be selected
                    object.selected(true || !HELPERS.inputState.selectMultiple);
                    return true;
                }
            }

            HELPERS.inputState.onInputBlur();
        }
        return false;
    }
}