'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.controls = VIEW3D.controls || {}

VIEW3D.controls.SelectionEditTools = function(selectedObjects, onBarElementEdit) {
    var selectionSub = null;
    this.willChange = false;
    var realViewSub = null;

    this.onSelectionChange = function() {
        var hideOnBarEdit = true;
        realViewSub = HELPERS.safeDispose(realViewSub);
        if (selectedObjects().length === 1) {
            var selectedObject = selectedObjects()[0];
            var barAttachment, object;
            if (selectedObject.type === MODEL.OBJECT_TYPE.BarForce) {
                object = selectedObject;
                barAttachment = object.barAttachments()[0];
                if (isEmpty(barAttachment)) return;

                onBarElementEdit.setBar(barAttachment.bar, barAttachment.x(), function (x) {
                    barAttachment.x(x);
                });

                hideOnBarEdit = false;
            }
            else 
            if (selectedObject.type === MODEL.OBJECT_TYPE.BarTrapezoidal) {
                object = selectedObject;
                barAttachment = object.barAttachments()[0];
                if (isEmpty(barAttachment)) return;
                onBarElementEdit.setBarTrapezoid(barAttachment.bar, object.points()[0]().distance, object.points()[1]().distance,
                    function (x) {
                        object.x1Absolute(x);
                    }, function (x) {
                        object.x2Absolute(x);
                    });
                hideOnBarEdit = false;
            }
        }
        if (hideOnBarEdit) {
            onBarElementEdit.clearMesurements();
        }
    }
    this.enable = function() {
        selectionSub = HELPERS.subscribeArrayChange(this, selectedObjects, "selectedObjects", this.onSelectionChange, this.onSelectionChange);
        this.onSelectionChange();
    }
    this.disable = function() {
        selectionSub = HELPERS.safeDispose(selectionSub);
        realViewSub = HELPERS.safeDispose(realViewSub);
    }
}