﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.controls = VIEW3D.controls || {}

VIEW3D.controls.SupportEdit = function(parent, selectedObjects, supportModel, mouse3D) {
    var enabled = false;
    var visualization = null;
    //var selSubscription = null;
    this.enable = function() {
        if (enabled) {
            return;
        }
        //selSubscription = HELPERS.subscribeArrayChange(this, selectedObjects, "model.nodes", this.onSelectionAdded, this.onSelectionRemoved);
        visualization = new VIEW3D.SupportsNode(supportModel, parent);
        enabled = true;
    }
    this.disable = function() {
        if (!enabled) {
            return;
        }
        visualization.dispose();
        //selSubscription.dispose();
        enabled = false;
    }
    this.onMouseUp = function() {
        if (mouse3D.object().type === MODEL.OBJECT_TYPE.Node) {

            //check if support is available for this node
            var availableSupports = CORE.model.constraints.getNodeConstraints(mouse3D.object().id).supports;
            var filtered = availableSupports.filter(function (item) { return item.ElementId === supportModel().id });
            if (filtered.length === 0) return;

            supportModel().assignTo(mouse3D.object());
        }
    }
}