﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.materials = VIEW3D.materials || {}

VIEW3D.materials.Chart = function(opacity, scale, depthWrite) {
    THREE.ShaderMaterial.call(this, {
        transparent: true,
        side: THREE.DoubleSide,
        depthWrite: !isEmpty(depthWrite) ? depthWrite : false,
        fog: false,
        vertexColors: THREE.VertexColors,
        uniforms: {
            scale: {
                type: "f",
                value: scale
            },
            opacity: {
                type: "f",
                value: opacity
            }
        },
        vertexShader:
            'uniform float scale;\n\
                attribute vec4 dir;\n\
                varying vec3 vColor;\n\
                \n\
                void main() {\n\
                    vec4 pos = modelViewMatrix * vec4( position, 1.0 );\n\
                    vec4 d = modelViewMatrix * (vec4( dir.xyz, 0.0 ) * dir.w * scale);\n\
                    pos = projectionMatrix * (pos + d);\n\
                    gl_Position = pos;\n\
                    vColor=color;\n\
                }',
        fragmentShader:
            'uniform float opacity;\n\
            varying vec3 vColor;\n\
            \n\
             void main() {\n\
                gl_FragColor = vec4( vColor, opacity );\n\
            }'
    });
}
VIEW3D.materials.Chart.prototype = Object.create(THREE.ShaderMaterial.prototype);