﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.materials = VIEW3D.materials || {}

VIEW3D.materials.ChartEdge = function(scale) {
    THREE.ShaderMaterial.call(this, {
        fog: false,
        uniforms: {
            scale: {
                type: "f",
                value: scale || 1.0
            },
            lineColor: {
                type: "c",
                value: new THREE.Color()
            }
        },
        vertexShader:
            'uniform float scale;\n\
                attribute vec4 dir;\n\
                \n\
                void main() {\n\
                    vec4 pos = modelViewMatrix * vec4( position, 1.0 );\n\
                    vec4 d = modelViewMatrix * (vec4( dir.xyz, 0.0 ) * dir.w * scale);\n\
                    pos = projectionMatrix * (pos + d);\n\
                    gl_Position = pos;\n\
                  //vColor=color;\n\
                }',
        fragmentShader:
            'uniform vec3 lineColor;\n\
             void main() {\n\
                gl_FragColor = vec4( lineColor.xyz, 1.0 );\n\
            }'
    });
}
VIEW3D.materials.ChartEdge.prototype = Object.create(THREE.ShaderMaterial.prototype);