﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.materials = VIEW3D.materials || {}

VIEW3D.materials.LoadFill = function (opacity) {
	THREE.ShaderMaterial.call(this, {
		transparent: true,
		side: THREE.DoubleSide,
	    depthWrite: false,
		fog: false,
		vertexColors: THREE.VertexColors,
		uniforms: {
			opacity: {
				type: "f",
				value: opacity
			}
		},
		vertexShader:
            'uniform float scale;\n\
                varying vec3 vColor;\n\
				attribute vec3 elementPos;\n\
                \n\
                void main() {\n\
                    vec4 pos = modelViewMatrix * vec4( elementPos, 1.0 );\n\
                    pos = (projectionMatrix * pos);\n\
                    \n\
                    vec4 offset = modelViewMatrix * vec4( position, 0.0 );\n\
                    offset = (projectionMatrix * offset);\n\
                    offset.xy /= projectionMatrix[1][1];//divide by zoom\n\
                    \n\
                    pos.xyz += offset.xyz;\n\
                    gl_Position = pos;\n\
                    vColor=color;\n\
                }',
		fragmentShader:
            'uniform float opacity;\n\
            varying vec3 vColor;\n\
            \n\
             void main() {\n\
                gl_FragColor = vec4( vColor, opacity );\n\
            }'
	});
}
VIEW3D.materials.LoadFill.prototype = Object.create(THREE.ShaderMaterial.prototype);