'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.materials = VIEW3D.materials || {}

VIEW3D.materials.SnappingLine = function () {
    THREE.ShaderMaterial.call(this, {
        transparent: true,
        vertexShader:
            '   attribute float distance;\n\
                varying float dist;\n\
                \n\
                void main() {\n\
                    vec4 pos = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n\
                    dist =  15.0 * distance * projectionMatrix[1][1];//divide by zoom\n\
                    gl_Position = pos;\n\
            }',
        fragmentShader:
            'varying float dist;\n\
             \n\
             void main() {\n\
                float transparent = floor(dist - floor(dist) + 0.5);\n\
                gl_FragColor = vec4(0,1,0,transparent);\n\
            }'

    });
}
VIEW3D.materials.SnappingLine.prototype = Object.create(THREE.ShaderMaterial.prototype);