﻿'use strict';
var VIEW3D = VIEW3D || {}
VIEW3D.materials = VIEW3D.materials || {}

VIEW3D.materials.ZoomArea = function (opacity, aspectRatio, color) {
    if (isEmpty(color)) {
        color = new THREE.Vector3(1, 1, 1);
    }
    THREE.ShaderMaterial.call(this, {
        transparent: true,
        side: THREE.DoubleSide,
        depthWrite: false,
        depthTest: false,
        fog: false,
        uniforms: {
            aspectRatio: {
                type: "f",
                value: aspectRatio
            },
            opacity: {
                type: "f",
                value: opacity
            },
            color: {
                type: "v3",
                value: color    
            }
},
        vertexShader:
            'uniform float aspectRatio;\n\
                \n\
                void main() {\n\
                    vec4 pos = vec4( position, 1.0 );\n //modelViewMatrix\
                    pos.x /= aspectRatio;\n\
                    gl_Position = pos;\n\
                }',
        fragmentShader:
            'uniform float opacity;\n\
             uniform vec3 color;\n\
             \n\
             void main() {\n\
                gl_FragColor = vec4( color.rgb, opacity );\n\
             }'
    });
}
VIEW3D.materials.ZoomArea.prototype = Object.create(THREE.ShaderMaterial.prototype);