VIEWUI = VIEWUI || {};

VIEWUI.barEdit = {
    viewModel: {
        bar : null,
        barLength: ko.observable(0),
        barYaw1: ko.observable(0),
        barPitch1: ko.observable(0),
        barYaw2: ko.observable(0),
        barPitch2: ko.observable(0),
        moveLeftEnd: ko.observable(false),
        showEditAngles1: ko.observable(false),
        showEditAngles1Click: function(vm) {
            vm.showEditAngles1(!vm.showEditAngles1());
            if(vm.showEditAngles1()) {
                vm.showEditAngles2(false);
            }
        },
        showEditAngles2: ko.observable(false),
        showEditAngles2Click: function(vm) {
            vm.showEditAngles2(!vm.showEditAngles2());
            if(vm.showEditAngles2()) {
                vm.showEditAngles1(false);
            }
        },
        lenghtKeypress: function (vm, e) {
            if (e.keyCode == 13) {
                setTimeout(function () {
                    var startNode =  vm.moveLeftEnd() ? vm.rightNode : vm.leftNode;
                    var endNode =  vm.moveLeftEnd() ? vm.leftNode : vm.rightNode;
                    var startPos = startNode.position();
                    var endPos = endNode.position();
                    var dir =  new THREE.Vector3().subVectors(endPos, startPos).normalize();
                    endPos = startPos.add(dir.multiplyScalar(vm.barLength()));
                    endNode.position(  new MODEL.types.Vector(endPos.x, endPos.y, endPos.z));
                    vm.barEdit.show(vm.bar);//reset control
                },0);
            }
            return true;
        },
        angle1Keypress: function (vm, e) {
            if (e.keyCode == 13) {
                vm.rotateNode(vm.bar.node1().position(), vm.bar.node2(), vm.barYaw1, vm.barPitch1);
            }
            return true;
        },
        angle2Keypress: function (vm, e) {
            if (e.keyCode == 13) {
                vm.rotateNode(vm.bar.node2().position(), vm.bar.node1(), vm.barYaw2, vm.barPitch2);
            }
            return true;
        },
        rotateNode: function(center, node, yaw, pitch) {
            var self = this;
            setTimeout(function () {
                //var rotation = new THREE.Matrix4().makeRotationFromEuler(new THREE.Euler(0, pitch(), yaw()), "")
                var rotY = new THREE.Matrix4().makeRotationY(-pitch());
                var rotZ = new THREE.Matrix4().makeRotationZ(yaw());
                var rotation = new THREE.Matrix4().multiplyMatrices(rotZ, rotY);
                var endpos = new THREE.Vector3(self.barLength(), 0,0);
                endpos.applyMatrix4(rotation);
                endpos.add( HELPERS.toVector3(center) );
                node.position( HELPERS.toVector(endpos) );
                self.barEdit.show(self.bar);//reset control

            },10);
        },
        changeSide:function (vm) {
            vm.moveLeftEnd(!vm.moveLeftEnd());
        },
    },
    init: function() {
        ko.applyBindings(this.viewModel, VIEWUI.divs.editBarContainer.element[0]);
        ko.applyBindings(this.viewModel, VIEWUI.divs.editBarAngles1Container.element[0]);
        ko.applyBindings(this.viewModel, VIEWUI.divs.editBarAngles2Container.element[0]);
    },
    bindEventHandlers: function () {
        /*
        setTimeout(function () {
            $('#VIEWUI_container').not(VIEWUI.divs.editMoveContainer.element).on("click", VIEWUI.moveEdit.onClick);
        }, 0);*/
    },
    unbindEventHandlers: function () {
        /*setTimeout(function () {
            $('#VIEWUI_container').not(VIEWUI.divs.editMoveContainer.element).off("click", VIEWUI.moveEdit.onClick);
        }, 0);*/
    },
    /*
    onClick: function(event) {

        if (!$(event.target).parents('#' + VIEWUI.divs.editMoveContainer.id).length) { // if clicked outside div
            VIEWUI.moveEdit.viewModel.cancel();
        }
    },*/

    show: function (bar) {
        if(this.viewModel.bar !== bar) {
            this.viewModel.showEditAngles1(false);
            this.viewModel.showEditAngles2(false);
        }
        this.viewModel.bar = bar;
        this.viewModel.barEdit = this;
        var node1Pos = VIEW3D.utils.get2dPosition(bar.node1().position());
        var node2Pos = VIEW3D.utils.get2dPosition(bar.node2().position());
        var startPos = node1Pos;
        var endPos = node2Pos;
        if( startPos.x < endPos.x ) {
            this.viewModel.leftNode = bar.node1();
            this.viewModel.rightNode =bar.node2();
        } else {
            this.viewModel.leftNode = bar.node2();
            this.viewModel.rightNode =bar.node1();
            startPos = node2Pos;
            endPos = node1Pos;
        }

        var dir =  new THREE.Vector2().subVectors(endPos, startPos).normalize();
        var middle =  new THREE.Vector2().addVectors(endPos, startPos).divideScalar(2);
        middle.x -= dir.y * 20;
        middle.y += dir.x * 20;
        var matrix = new THREE.Matrix4().makeTranslation(endPos.x, endPos.y, 0);
        matrix.multiply(new THREE.Matrix4().makeRotationZ(1));
        this.viewModel.barLength(bar.getLength());
        VIEWUI.divs.editBarContainer.element.css({
            transform: "matrix("+ dir.x + "," + dir.y + "," + (-dir.y) + ","+ dir.x + "," + middle.x+","+middle.y+")"
        }).show();

        var dir3d = bar.node2().position().sub(bar.node1().position());
        var yaw = Math.atan2(dir3d.y, dir3d.x) ;
        if (yaw < 0) {
            yaw += 2 * Math.PI;
        }
        this.viewModel.barYaw1(yaw);

        var pitch = Math.atan2(dir3d.z, Math.sqrt(dir3d.y*dir3d.y + dir3d.x*dir3d.x));
        this.viewModel.barPitch1(pitch);

        dir3d = bar.node1().position().sub(bar.node2().position());
        yaw = Math.atan2(dir3d.y, dir3d.x) ;
        if (yaw < 0) {
            yaw += 2 * Math.PI;
        }
        this.viewModel.barYaw2(yaw);

        pitch = Math.atan2(dir3d.z, Math.sqrt(dir3d.y*dir3d.y + dir3d.x*dir3d.x));
        this.viewModel.barPitch2(pitch);

        node1Pos.y += 10;
        node1Pos.x -= 10;
        node1Pos.y = canvas.clientHeight - node1Pos.y;
        VIEWUI.divs.editBarAngles1Container.element.css({
            bottom: node1Pos.y +"px",
            left: node1Pos.x +"px",
        }).show();


        node2Pos.y += 10;
        node2Pos.x -= 10;
        node2Pos.y = canvas.clientHeight - node2Pos.y;
        VIEWUI.divs.editBarAngles2Container.element.css({
            bottom: node2Pos.y +"px",
            left: node2Pos.x +"px",
        }).show();

    },

    hide: function () {
        this.viewModel.bar = null;
        VIEWUI.divs.editBarContainer.element.hide();
        VIEWUI.divs.editBarAngles1Container.element.hide();
        VIEWUI.divs.editBarAngles2Container.element.hide();
    }

}