﻿define(['js/viewui/VIEWUI.properties.vmGenerator', 'js/viewui/VIEWUI.properties.Bar', 'js/viewui/VIEWUI.properties.BarForce', 'js/viewui/VIEWUI.properties.Node', 'js/viewui/VIEWUI.toolbar'], function() {
    VIEWUI.properties._selectionArraySubscription = null;
    VIEWUI.properties._workplaneSubscription = null;
    VIEWUI.properties._selectedObjects = null;
    VIEWUI.properties._activeWorkplane = null;
    VIEWUI.properties.latestComboId = 1;
    VIEWUI.properties.comboBoxesInitialized = false;
    VIEWUI.properties.divs = {
        // when require.js is used, divs can be initialized when the module is loaded (and not in the init function)
        propertiesTopBar: { element: null, id: "VIEWUI_propertiesTopBar" },
        propertiesTemplates: { element: null, id: "VIEWUI_propertiesTemplates" },
        properties: { element: null, id: "VIEWUI_properties" },
        propertiesContents: { element: null, id: "VIEWUI_properties_contents" }
    };
    VIEWUI.properties.subscriptions = [];
    VIEWUI.properties.init = function(selectedObjects, activeWorkplane) {
        this._selectedObjects = selectedObjects;
        this._activeWorkplane = activeWorkplane;
        var divs = VIEWUI.properties.divs;
        for (var property in divs) {
            if (divs.hasOwnProperty(property)) {
                divs[property].element = $('#' + divs[property].id);
                if (divs[property].element.length === 0) {
                    console.error("VIEWUI.popups.init: div " + divs[property].id + " not found in DOM");
                }
            }
        }
        if (this.propertiesContainer === null || this.propertiesTemplates === null) {
            throw 'VIEWUI.properties.init: Elements do not exist!';
        }
        HELPERS.subscribePropertyChange(this, VIEWUI.viewModel.popupMode, "VIEWUI.viewModel.popupMode", function(newPopupMode) {
            if (newPopupMode !== POPUP_MODE.PROPERTIES) {
                VIEWUI.properties.resetWebGlContainers();
                VIEWUI.properties.clearSubscriptions();
            }
        });
        HELPERS.subscribePropertyChange(this, CORE.model.barsResults, "CORE.model.barsResults", function(barsResults) {
            if (isEmpty(barsResults))
                VIEWUI.properties.resetWebGlContainers();
            else
                setTimeout(function() {
                    VIEWUI.spinners.init("#VIEWUI_propertiesContainer");
                }, 0);
        });

        VIEWUI.properties.initOversizeProtection();

        CORE.model.modelChange.subscribe(function() {
            VIEWUI.initCheckboxes(VIEWUI.properties.divs.properties.element);
        });


        $(window).scroll(function() {
            if (!VIEWUI.toolbar.TopBarViewModel.isFullscreen()) {
                //VIEWUI.properties.adjustAllComboboxLists();
                VIEWUI.properties.hideAllComboboxLists();
            }
        });

        $(window).resize(function() {
            //VIEWUI.properties.adjustAllComboboxLists();
            VIEWUI.properties.hideAllComboboxLists();
        });

        // Hide comboboxes after lost focus
        //$('body').click(function (event) {                             // uncomment after properties refactoring
        //    if (!$(event.target).closest('.VIEWUI_combobox').length) {
        //        $('.VIEWUI_comboboxOptionsContainer:visible').hide();
        //    }
        //});
    };

    //VIEWUI.properties.adjustAllComboboxLists = function () {

    //    var container = 'body'; //VIEWUI.divs.viewerContainer.element;

    //    $(container).find(".VIEWUI_comboboxOptionsContainer:visible").each(function (index, item) {
    //        VIEWUI.properties.adjustComboboxList(item);
    //    });
    //}

    VIEWUI.properties.hideAllComboboxLists = function() {
        $('.VIEWUI_autoSizeContainer:visible').each(function(index, item) {
            VIEWUI.properties.hideComboboxList(item);
        });
    }

    VIEWUI.properties.hideComboboxList = function(comboboxList) {

        $(comboboxList).hide();

        var comboboxId = $(comboboxList).attr('comboId');
        if (!comboboxId) return;

        var combobox = $('.VIEWUI_combobox[comboId=' + comboboxId + ']');

        $(combobox).append(comboboxList); // put combobox list back in the original container
    }

    VIEWUI.properties.enable = function() {
        //if (this._selectionArraySubscription == null) {       // this may be different (CRM after going to edit calc page and back)
        if (this._selectionArraySubscription != null) {
            this._selectionArraySubscription.dispose();
            this._selectionArraySubscription = null;
        }

        this._selectionArraySubscription = HELPERS.subscribeArrayChange(
            VIEWUI,
            this._selectedObjects,
            "selectedObjects",
            VIEWUI.properties.onSelectedObjectsArrayChanged,
            VIEWUI.properties.onSelectedObjectsArrayChanged);
        //}
        //if (this._workplaneSubscription == null) {
        //    this._workplaneSubscription = HELPERS.subscribePropertyChange(VIEWUI, this._activeWorkplane, "CORE.model.activeWorkplane", VIEWUI.properties.onActiveWorkplaneChanged);
        //}
        //VIEWUI.properties.onSelectedObjectsArrayChanged();
    };
    VIEWUI.properties.disable = function() {
        if (this._selectionArraySubscription != null) {
            this._selectionArraySubscription.dispose();
            this._selectionArraySubscription = null;
        }
        if (this._workplaneSubscription != null) {
            this._workplaneSubscription.dispose();
            this._workplaneSubscription = null;
        }
        VIEWUI.viewModel.popupMode(null);
    };
    //VIEWUI.properties.onActiveWorkplaneChanged = function (workplaneModelObject, oldActiveWorkplane) {
    //    if (oldActiveWorkplane === null) return; //do not show properties on startup
    //    //properties show
    //    var viewModel = VIEWUI.properties.vmGenerator.getViewModel(workplaneModelObject);
    //    //assign additional properties
    //    viewModel.type = 'properties';
    //    VIEWUI.properties.setAndShowPropertiesDiv(viewModel, VIEWUI.properties.divs.propertiesContents.element, true);
    //};

    VIEWUI.properties.showCustomPropertyTab = function(obj) {
        var viewModel = VIEWUI.properties.vmGenerator.getViewModel(obj);
        VIEWUI.properties.setAndShowPropertiesDiv(viewModel, VIEWUI.properties.divs.propertiesContents.element);
    }

    VIEWUI.properties.hideCustomPropertyTab = function() {
        VIEWUI.viewModel.popupMode(null);
        HELPERS.inputState.onInputBlur();
    }

    VIEWUI.properties.onSelectedObjectsArrayChanged = function() {

        if (HELPERS.inputState.isRightClicked) {
            return;
        }
        if (CORE.model.selectedObjects().length === 1) { // determine if show or hide properties
            var selectedModelObject = CORE.model.selectedObjects()[0];
            var viewModel = VIEWUI.properties.vmGenerator.getViewModel(selectedModelObject);
            //assign additional properties
            viewModel.onOkClicked = function() {
                CORE.model.deselectAll();
            }
            viewModel.type = 'properties';
            if (typeof VIEWUI.properties.additionalProperties[selectedModelObject.type] !== 'undefined') {
                ko.mapping.fromJS(new VIEWUI.properties.additionalProperties[selectedModelObject.type](viewModel), {}, viewModel); //assign additional properties
            }
            VIEWUI.properties.setAndShowPropertiesDiv(viewModel, VIEWUI.properties.divs.propertiesContents.element); // set and show properties
        } else // hide properties
        {
            VIEWUI.viewModel.popupMode(null);
            HELPERS.inputState.onInputBlur();
        }
    };
    VIEWUI.properties.progressBar = function(percent) {
        var can = $("canvas[id='circleProgressBar']")[0];
        var size = 80;
        var width = 5;
        can.width = size;
        can.height = size;
        var ctx = can.getContext('2d');
        var deg = percent * 3.6;
        var radius = size / 2;
        var cx = radius;
        var cy = radius;
        var color;

        function toRadians(deg) {
            return deg * Math.PI / 180;
        }

        function drawCircle(startPos, endPos, radius, color) {
            ctx.fillStyle = color;
            ctx.beginPath();
            ctx.moveTo(cx, cy);
            ctx.arc(cx, cy, radius, toRadians(startPos), toRadians(endPos));
            ctx.lineTo(cx, cy);
            ctx.closePath();
            ctx.fill();
        }

        if (percent < 100) {
            color = '#2AA51C';
        } else {
            color = 'FireBrick';
        }
        drawCircle(0, 360, radius, 'rgba(255, 255, 255, 0.2)');
        drawCircle(270, deg + 270, radius, color);
        drawCircle(0, 360, radius - width, '#4C4C4C');
    };
    VIEWUI.properties.additionalProperties = (function() {
        var additionalProperties = {};
        additionalProperties[MODEL.OBJECT_TYPE.Bar] = function(viewModel) {
            return new VIEWUI.properties.Bar(viewModel);
        }; // moved to VIEWUI.properties.Bar.js
        additionalProperties[MODEL.OBJECT_TYPE.Node] = function(viewModel) {
            return new VIEWUI.properties.Node(viewModel);
        }; // moved to VIEWUI.properties.Node.js
        additionalProperties[MODEL.OBJECT_TYPE.BarForce] = function(viewModel) {
            return new VIEWUI.properties.BarForce(viewModel);
        };
        additionalProperties[MODEL.OBJECT_TYPE.BarTrapezoidal] = function(viewModel) {
            return new VIEWUI.properties.BarForce(viewModel);
        };
        return additionalProperties;
    })();
    VIEWUI.properties.setAndShowPropertiesDiv = function(viewModel, _propertiesDiv) {
        var propertiesDiv = _propertiesDiv.clone(); //create a new copy from template
        //properties show
        VIEWUI.properties.divs.properties.element.html(propertiesDiv);

        var applyBindings = function() {
            document.getElementById("VIEWUI_propertiesContainer").style.height = "10000000px";
            ko.applyBindings(viewModel, propertiesDiv[0]);
            //VIEWUI.spinners.init("#VIEWUI_propertiesContainer"); moved to afterRender in vmGenerator
            VIEWUI.initCustomRadio($('.VIEWUI_customRadio'));
            VIEWUI.viewModel.popupMode(POPUP_MODE.PROPERTIES);
            propertiesDiv = null;
            if (!isEmpty(viewModel.afterCopy)) { // custom "event" (common interface)
                viewModel.afterCopy();
            }
            VIEWUI.initCheckboxes(VIEWUI.properties.divs.properties.element);
            VIEWUI.initScrollbar(VIEWUI.properties.divs.properties.element.find(".VIEWUI_allFieldsContainer"));
            VIEWUI.properties.initComboboxListBehaviour(VIEWUI.properties.divs.properties.element);
        }

        if (typeof viewModel.prepareObject === 'function') {
            viewModel.prepareObject(applyBindings);
        } else
            applyBindings();

        CORE.setPropertiesContainerIsEnabled();

        VIEWUI.adjustPropertiesHeight();
        //niceBar.init($(".VIEWUI_allFieldsContainer")[0]);

    };


    VIEWUI.properties.initOversizeProtection = function() {

        // adjust container height to the height of the viewer
        $(window).resize(function() {
            VIEWUI.properties.checkContainerSize();
        });
        HELPERS.subscribePropertyChange(this, CORE.model.nodesResults, "CORE.model.nodesResults", function() {
            VIEWUI.properties.checkContainerSize();
        });

        CORE.model.modelChange.subscribe(function() {
            VIEWUI.properties.initComboboxListBehaviour(VIEWUI.properties.divs.properties.element);
            VIEWUI.properties.checkContainerSize();
        });
    }

    VIEWUI.properties.checkContainerSize = function() {

        CORE.adjustTopBorder();

        // show scrollbar if properties list is too long
        setTimeout(function() {
            if ($("#VIEWUI_templateContainer").eq(0).height() > VIEWUI.divs.viewerContainer.element.height() - CORE.topBorder - 64) {
                // when properties are bigger than window, need to set constant height
                $("#VIEWUI_propertiesContainer").css("height", "10000px"); // 100% height doesn't work with max-height-ed parents
            } else {
                // when properties are smaller than window, width is auto
                $("#VIEWUI_propertiesContainer").css("height", "");

                if (VIEWUI.viewModel.popupMode() !== null) {
                    var isFirefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;

                    if (isFirefox) {
                        $("#VIEWUI_propertiesContainer").hide(); // firefox bug workaround
                        setTimeout(function() {
                            $("#VIEWUI_propertiesContainer").show();
                        }, 0);
                    }
                }
                //alert(document.getElementById("VIEWUI_propertiesContainer").style.top);
                $("#VIEWUI_properties").css("height", ""); // firefox bug workaround
                $("#VIEWUI_properties").css("height", "calc(100% - 50px)");
            }

        }, 0);
    }

    VIEWUI.properties.initComboboxListBehaviour = function(container) {

        // BASIC BEHAVIOUR

        if (!VIEWUI.properties.comboBoxesInitialized) {
            // Hide comboboxes after lost focus         // TODO: move to VIEWUI.properties.js during properties refactoring
            $('body').click(function(event) {
                if (!$(event.target).closest('.VIEWUI_combobox').length && !$(event.target).closest('.VIEWUI_autoSizeContainer').length) {
                    VIEWUI.properties.hideAllComboboxLists();
                }
            });
        }

        if (container) {
            $(container).find('.VIEWUI_allFieldsContainer').scroll(function() {
                VIEWUI.properties.hideAllComboboxLists(); // hide comboboxes when scrolling properties (doesn't work for now, event not fired?)
            });
        }


        var initBehaviour = function(combobox) {

            $(combobox).mousedown(function(event) { // show dropdown and hide other dropdowns when clicked on one

                setTimeout(function() { // combobox items need to finish loading first (refactor?)

                    var clickedCombo = $(event.target).closest('.VIEWUI_combobox');

                    var comboId = clickedCombo.attr('comboId');

                    var comboboxOptions = clickedCombo.find('.VIEWUI_autoSizeContainer').eq(0);

                    if (!comboboxOptions.length)
                        comboboxOptions = $('.VIEWUI_autoSizeContainer[comboId=' + comboId + "]"); // search in body


                    $('.VIEWUI_autoSizeContainer').each(function(index, item) {

                        if (!comboboxOptions.is(":visible") && $(item)[0] === comboboxOptions[0]) {

                            if ($(item).is(":visible"))
                                VIEWUI.properties.hideComboboxList(item);
                            else
                                $(item).show();

                            adjustComboBox(event);
                        } else
                            VIEWUI.properties.hideComboboxList(item);
                    });

                }, 0);
            });

            $(combobox).attr('initialized', 'true');
        }

        $('.VIEWUI_combobox:visible').each(function(index, item) { // TODO: pass container

            if ($(item).attr('initialized') !== 'true') // init if not initialized before
                initBehaviour(item);
        });


        $('.VIEWUI_comboboxOptions').click(function(event) { // hide dropdown when clicked on it TODO: prevent multiple event registers
            if (event.target.tagName !== 'A') // except "details"
                VIEWUI.properties.hideAllComboboxLists();
        });

        // /BASIC BEHAVIOUR

        var adjustComboBox = function(e) {

            var comboBox = $(e.target).closest('.VIEWUI_combobox');

            if (!comboBox.attr('comboId')) {
                comboBox.attr('comboId', VIEWUI.properties.latestComboId);
                VIEWUI.properties.latestComboId++;
            }

            var comboId = comboBox.attr('comboId');

            var comboboxOptions = $(comboBox).find('.VIEWUI_autoSizeContainer').eq(0);
            var isProcessed = comboboxOptions.length === 0;

            if (isProcessed)
                comboboxOptions = $('.VIEWUI_autoSizeContainer[comboId=' + comboId + "]"); // search in body
            else {
                comboboxOptions.attr('comboId', comboId); // not processed yet, assign an id and a type
                $('body').append(comboboxOptions); // move to body
            }


            if (comboboxOptions.length !== 1) { console.info(".VIEWUI_comboboxOptions lost"); return; }

            var comboboxOffset = comboBox.offset();
            var comboboxHeight = comboBox.outerHeight();


            var topOffset = comboboxOffset.top + comboboxHeight;
            if (topOffset + $(window).scrollTop() + 100 > $(window).height() - $(comboboxOptions).height() - comboBox.height()) { // move list above combobox if wouldn't fit below
                topOffset -= $(comboboxOptions).height() + comboBox.height();
            }


            if (comboBox.width() > $(comboboxOptions).width())
                comboboxOptions.css('min-width', comboBox.width());

            comboboxOptions.css('top', topOffset);
            comboboxOptions.css('left', comboBox.offset().left - comboboxOptions.width() + comboBox.width());
            comboboxOptions.css('right', 'auto');


        }

        VIEWUI.properties.comboBoxesInitialized = true;

    }

    VIEWUI.properties.resetWebGlContainers = function() { // when popupMode changes, properties are destroyed, need to rescue webgl containers (e.g. bar results)
        $('#VIEWUI_properties #resultsWebGlContainer').appendTo('#hiddenContainers'); // move container back to VIEWUI.html so it avoids destruction
        CORE.resultsWindowModel.removeObjects(CORE.resultsWindowModel.bars()); // reset results model
        CORE.resultsWindowModel.barsResults(null);
    }
    VIEWUI.properties.clearSubscriptions = function() {
        for (var i = 0, ii = this.subscriptions.length; i < ii; i++) {
            this.subscriptions[i].dispose();
        }
        this.subscriptions = [];
    }
    VIEWUI.properties.resultsTypeSelection = ko.observable("DISPLACEMENT"); // properties declared here will be remembered when popup closes
    VIEWUI.properties.visibleResultsForce = ko.observable("Fx");
    VIEWUI.properties.visibleResultsDisp = ko.observable("Ux");
    VIEWUI.properties.resultsViewOptions = {
        showCalcDisplacement: ko.observable(false),
        showCalcForceFx: ko.observable(false),
        showCalcForceFy: ko.observable(false),
        showCalcForceFz: ko.observable(false),
        showCalcForceMx: ko.observable(false),
        showCalcForceMy: ko.observable(false),
        showCalcForceMz: ko.observable(false),
        showCalcForceUx: ko.observable(false),
        showCalcForceUy: ko.observable(false),
        showCalcForceUz: ko.observable(false),
    };
    VIEWUI.properties.isOnlySelectedObject = function(object) {
        return CORE.model.selectedObjects().length === 1 && CORE.model.selectedObjects.indexOf(object) !== -1;
    };
    VIEWUI.properties.ifNoSelectedObjects = function() {
        return CORE.model.selectedObjects().length === 0;
    };
});