﻿VIEWUI.toolbar = {
    divs: {
        toolbar: { element: null, id: "VIEWUI_toolbar" },
        topBar: { element: null, id: "VIEWUI_topBar" }
    },
    init: function() {
        var divs = VIEWUI.toolbar.divs;
        for (var property in divs) {
            if (divs.hasOwnProperty(property)) {
                divs[property].element = $('#' + divs[property].id);
                if (divs[property].element.length === 0) {
                    console.error("VIEWUI.toolbar.init: div " + divs[property].id + " not found in DOM");
                }
            }
        }
        this.bindButtonsViewModel();
        this.switchMode(MODE.SELECT);
        this.generateReport = function() {
            return generateReport();
        };
        setTimeout(function() {
            $('.VIEWUI_menuSubBtn').click(function() { // hide submenu when item clicked
                $('.VIEWUI_menuSubButtons:not(.VIEWUI_menuSubButtonsFixed)').css('pointer-events', 'none');
                setTimeout(function() {
                    $('.VIEWUI_menuSubButtons').css('pointer-events', 'auto');
                }, 10);
            });
        }, 100);
    },
    btnDrawBarForceClicked: function() {
        var newLoad = new MODEL.load.bar.BarForce(null, new MODEL.types.Vector(0, 0, -500), null, null);
        CORE.model.definingObject(newLoad);
        VIEWUI.toolbar.switchMode(MODE.EDIT_BAR_FORCE);
    },
    btnDrawBarUniformClicked: function() {
        var newLoad = new MODEL.load.bar.BarUniform(null, null);
        CORE.model.definingObject(newLoad);
        VIEWUI.toolbar.switchMode(MODE.EDIT_BAR_UNIFORM);
    },
    btnDrawBarTrapezoidalClicked: function() {
        var newLoad = new MODEL.load.bar.BarTrapezoidal(new MODEL.types.ExtendedVector(0, 0, -500, 0), new MODEL.types.ExtendedVector(0, 0, -500, 0), null);
        CORE.model.definingObject(newLoad);
        VIEWUI.toolbar.switchMode(MODE.EDIT_BAR_TRAPEZOIDAL);
    },
    TopBarViewModel: function() {
        VIEWUI.properties.checkContainerSize();
        this.isFullscreen = ko.observable(false);
        this.viewerContainerInitialWidth = null; // calculated size
        this.viewerContainerInitialHeight = null;
        this.viewerContainerInitialOffset = null;
        this.viewerContainerInitialWidthAttr = null; // e.g. 100%
        this.viewerContainerInitialHeightAttr = null;
        this.btnGoFullscreen = function() {
            this.viewerContainerInitialWidth = viewerContainer.css('width');
            this.viewerContainerInitialHeight = viewerContainer.css('height');
            this.viewerContainerInitialOffset = viewerContainer.offset();
            this.viewerContainerInitialWidthAttr = viewerContainer[0].style.width;
            this.viewerContainerInitialHeightAttr = viewerContainer[0].style.height;
            viewerContainer.css({
                'top': viewerContainer.offset().top - $(window).scrollTop(),
                'left': viewerContainer.offset().left - $(window).scrollLeft(),
                'width': viewerContainer.width(),
                'height': viewerContainer.height()
            });
            viewerContainer.addClass("VIEWUI_viewerContainerMaximized");
            viewerContainer.animate({
                "top": "0px",
                "left": "0px",
                "width": "100%",
                "height": "100%"
            }, {
                duration: "fast",
                step: function() {
                    CORE.refreshAspectRatio();
                    VIEWUI.properties.checkContainerSize();
                },
                complete: function() {
                    CORE.refreshAspectRatio();
                    CORE.view3D.cameraControl.camera.changeEvent.notifySubscribers();
                    VIEWUI.popups.autoCenterPopup();
                    $(window).resize();
                }
            });
            this.isFullscreen(true);

            $('.ProposedAlternatives').addClass('bigZindex');
            $('.proposedAlternativesVisible').addClass('bigZindex2');
            $('.zoomDis').addClass('bigZindex3');
            //$('.eng-real-buttons').addClass('eng-real-buttons2');
            $('.displacement-checkbox').addClass('displacement-checkbox2');

        };
        this.btnExitFullscreen = function() {
            var self = this;
            viewerContainer.animate({
                "top": this.viewerContainerInitialOffset.top - $(window).scrollTop(),
                "left": this.viewerContainerInitialOffset.left - $(window).scrollLeft(),
                "width": this.viewerContainerInitialWidth,
                "height": this.viewerContainerInitialHeight
            }, {
                duration: "fast",
                step: CORE.refreshAspectRatio,
                complete: function() {
                    viewerContainer.removeClass("VIEWUI_viewerContainerMaximized"); //viewerContainer -> CORE.viewerContainer
                    viewerContainer.width(self.viewerContainerInitialWidthAttr);
                    viewerContainer.height(self.viewerContainerInitialHeightAttr);
                    CORE.refreshAspectRatio();
                    CORE.view3D.cameraControl.camera.changeEvent.notifySubscribers();
                    VIEWUI.popups.autoCenterPopup();
                    $(window).resize();
                }
            });
            this.isFullscreen(false);

            $('.ProposedAlternatives').removeClass('bigZindex');
            $('.proposedAlternativesVisible').removeClass('bigZindex2');
            $('.eng-real-buttons').removeClass('eng-real-buttons2');
            $('.zoomDis').removeClass('bigZindex3');
            $('.displacement-checkbox').removeClass('displacement-checkbox2');
            VIEWUI.properties.checkContainerSize();
        };
        this.btnUndo = function() {
            CORE.constructionUndoRedo.undo();
        };
        this.btnRedo = function() {
            CORE.constructionUndoRedo.redo();
        }
        this.undoAvailable = function() {
            return CORE.constructionUndoRedo.undoAvailable();
        }
        this.redoAvailable = function() {
            return CORE.constructionUndoRedo.redoAvailable();
        }
        this.btnSettings = function() {
            VIEWUI.popups.settings.show();
        };
        this.btnVersionList = function() {
            VIEWUI.popups.versionList.show();
        };
        this.saveToDb = function() {
            var proto = CORE.model.save();
            CORE.model.sendProto(proto);
        };
        this.loadFromDb = function() {
            CORE.model.load(CORE.options.appId, CORE.options.projId, CORE.options.jobId);
        };
        this.generateAnalysisInProgress = false;
        this.generateAnalysis = function() {
            if(VIEWUI.toolbar.generateAnalysisInProgress) return;
            var proto = CORE.model.save();
            CORE.webApiManager.downloadZipFiles(proto);
        };
        this.exportToDxfInProgress = false;
        this.exportToDxf = function() {
            if(VIEWUI.toolbar.exportToDxfInProgress) return;
            // var div = document.getElementById('dxfLoader');
            // div.style.display = 'block';
            var i;
            var construction = [];
            var connectors = CORE.constructionView3D.nodesObject3D.export();
            for (i = 0; i < connectors.length; i++) {
                construction.push(connectors[i]);
            }
            var barsDxfView = new VIEW3D.BarDxf(CORE.model.bars, CORE.model.constraints);
            var bars = barsDxfView.export();
            for (i = 0; i < bars.length; i++) {
                construction.push(bars[i]);
            }
            var barCaps = barsDxfView.caps.export();
            for (i = 0; i < barCaps.length; i++) {
                construction.push(barCaps[i]);
            }

            //var pushButtons = CORE.constructionView3D.pushButtons.export();
            //for (i = 0; i < pushButtons.length; i++) {
            //    construction.push(pushButtons[i]);
            //}
            MODEL.repository.exportToDxf(construction);
        }
        this.getAppId = function() {
            return CORE.options.appId;
        };
        this.getJobId = function() {
            return CORE.options.jobId;
        };
    },
    ButtonsViewModel: function() {
        this.mode = CORE.mode;
        this.debugMode = CORE.options.debugMode;
        this.viewOptions = VIEWUI.viewOptions;
        this.selectionMode = ko.computed(function() {
            return CORE.mode() === MODE.SELECT;
        });
        this.btnSelectClicked = function() {
            VIEWUI.toolbar.switchMode(MODE.SELECT);
            if (VIEWUI.viewModel.popupMode() === POPUP_MODE.DEFINITION) {
                VIEWUI.viewModel.popupMode(null);
            }
        };
        this.btnMoveClicked = function() {
            VIEWUI.toolbar.switchMode(MODE.MOVE);
            if (VIEWUI.viewModel.popupMode() === POPUP_MODE.DEFINITION) {
                VIEWUI.viewModel.popupMode(null);
            }
        };
        this.btnEditClicked = function() {
            VIEWUI.toolbar.switchMode(MODE.EDIT);
            if (VIEWUI.viewModel.popupMode() === POPUP_MODE.DEFINITION) {
                VIEWUI.viewModel.popupMode(null);
            }
        };
        this.btnDwgClicked = function() {
            VIEWUI.popups.dxfExport.show();
        };
        this.drawNodeMode = ko.computed(function() {
            return CORE.mode() === MODE.DRAW_NODE;
        });
        this.btnDrawNodeClicked = function() {
            var newNode = new MODEL.Node(new MODEL.types.Vector(0, 0, 0));
            CORE.model.definingObject(newNode);
            VIEWUI.toolbar.switchMode(MODE.DRAW_NODE);
        };

        this.drawBarCommonAction = function() {
            var node1 = new MODEL.Node(new MODEL.types.Vector(0, 0, 0));
            var node2 = new MODEL.Node(new MODEL.types.Vector(0, 0, 0));
            var newBar = new MODEL.Bar(node1, node2);
            CORE.model.definingObject(newBar);
            VIEWUI.toolbar.switchMode(MODE.DRAW_BAR);
        }

        this.btnDrawBarClicked = function() {
            VIEW3D.controls.isMultiDrawActive = false;
            this.drawBarCommonAction();
        };

        this.btnDrawMultiBarClicked = function() {
            VIEW3D.controls.isMultiDrawActive = true;
            this.drawBarCommonAction();
        };

        this.btnDrawWorkplaneClicked = function() {
            VIEWUI.popups.addWorkplane.show();
            VIEWUI.toolbar.switchMode(MODE.DRAW_WORKPLANE);
        };
        this.btnAddNodeForceClicked = function() {
            var newLoad = new MODEL.load.node.NodeForce(null);
            CORE.model.definingObject(newLoad);
            VIEWUI.toolbar.switchMode(MODE.EDIT_NODE_FORCE);
        };
        this.btnAddNodeMomentClicked = function() {
            var newLoad = new MODEL.load.node.NodeMoment(null);
            CORE.model.definingObject(newLoad);
            VIEWUI.toolbar.switchMode(MODE.EDIT_NODE_MOMENT);
        };
        this.btnAddSupportClicked = function(id) {
            var support = CORE.model.getSupportById(id);

            if (support) {
                CORE.model.definingObject(support);
                VIEWUI.toolbar.switchMode(MODE.EDIT_SUPPORT);
            } else {
                throw new Error("Support with index " + id + " not found");
            }
        };
        this.btnDrawBarForceClicked = function() {
            var newLoad = new MODEL.load.bar.BarForce(null, null, null, null);
            CORE.model.definingObject(newLoad);
            VIEWUI.toolbar.switchMode(MODE.EDIT_BAR_FORCE);
        };
        this.btnDrawBarUniformClicked = function() {
            var newLoad = new MODEL.load.bar.BarUniform(null, null);
            CORE.model.definingObject(newLoad);
            VIEWUI.toolbar.switchMode(MODE.EDIT_BAR_UNIFORM);
        };
        this.btnDrawBarTrapezoidalClicked = function() {
            var newLoad = new MODEL.load.bar.BarTrapezoidal(null, null, null);
            CORE.model.definingObject(newLoad);
            VIEWUI.toolbar.switchMode(MODE.EDIT_BAR_TRAPEZOIDAL);
        };
        this.btnAddFill = function() {
            var newFill = new MODEL.Fill();
            CORE.model.definingObject(newFill);
            VIEWUI.toolbar.switchMode(MODE.EDIT_FILL);
        };
        this.btnAddBox = function() {
            var newBox = new MODEL.BoxDefinition();
            CORE.model.definingObject(newBox);
            VIEWUI.toolbar.switchMode(MODE.EDIT_BOX);
        };

        this.btnShowFacadeWizard = function() {
            VIEWUI.popups.facadeWizard.show();
        };
        this.btnShowVerandaWizard = function() {
            VIEWUI.popups.verandaWizard.show();
        };
        this.btnCalculateClicked = function() {
            function startCalculationsProcess() {
                VIEWUI.popups.calculationsProgress.show();
                CORE.calculations.calculate();
            };
            var proto = CORE.model.save();
            CORE.model.sendProto(proto, { mode: SAVE_MODE.FullConstraints }, startCalculationsProcess);
        };
        this.btnCut = function() {
            VIEWUI.toolbar.switchMode(MODE.CUT);
        }
        this.btnSnapClicked = function() {
            VIEWUI.toolbar.switchMode(MODE.SNAP);
        }
        this.btnExportToDxf = function() {

            var i;
            var construction = [];
            var connectors = CORE.constructionView3D.nodesObject3D.export();
            for (i = 0; i < connectors.length; i++) {
                construction.push(connectors[i]);
            }
            var barsDxfView = new VIEW3D.BarDxf(CORE.model.bars, CORE.model.constraints);
            var bars = barsDxfView.export();
            for (i = 0; i < bars.length; i++) {
                construction.push(bars[i]);
            }
            var barCaps = barsDxfView.caps.export();
            for (i = 0; i < barCaps.length; i++) {
                construction.push(barCaps[i]);
            }

            var pushButtons = CORE.constructionView3D.pushButtons.export();
            for (i = 0; i < pushButtons.length; i++) {
                construction.push(pushButtons[i]);
            }
            MODEL.repository.exportToDxf(construction);
        }
        this.btnGenerateReport = function(reportType) {
            VIEWUI.popups.reportSettings.show(reportType, 'PDF');
        };
        this.btnGenerateXls = function() {
            VIEWUI.popups.reportSettings.show(null, 'XLS');
        };
        this.frontView = function() {
            CORE.view3D.cameraControl.resetView(0, 1, 0, true);
            CORE.view3D.moveControl.updateTextBox(null);
        };
        this.leftView = function() {
            CORE.view3D.cameraControl.resetView(1, 0, 0, true);
            CORE.view3D.moveControl.updateTextBox(null);
        };
        this.rightView = function() {
            CORE.view3D.cameraControl.resetView(-1, 0, 0, true);
            CORE.view3D.moveControl.updateTextBox(null);
        };
        this.topView = function() {
            CORE.view3D.cameraControl.resetView(0, 0, -1, true);
            CORE.view3D.moveControl.updateTextBox(null);
        };
        this.zoomIn = function() {
            CORE.view3D.cameraControl.zoomIn();
            CORE.view3D.moveControl.updateTextBox(null);
        };
        this.zoomOut = function() {
            CORE.view3D.cameraControl.zoomOut();
            CORE.view3D.moveControl.updateTextBox(null);
        };
        this.zoomArea = function() {
            CORE.mode(MODE.ZOOM_AREA);
            CORE.view3D.moveControl.updateTextBox(null);
        };
        this.zoomAll = function() {
            CORE.view3D.cameraControl.zoomAll();
            CORE.view3D.moveControl.updateTextBox(null);
        };

        this.showMenuItems = ko.observable(true);

        this.handleCustomSnapAction = function() {
            this.showMenuItems(false);
            VIEW3D.ShowSnapGrid();
            //CORE.view3D.cameraControl.resetView(0, 1, 0, true);
            Extension.moveCameraToActivePlane();
            var snapGrid = VIEW3D.GetSnapGridDefinition();
            snapGrid.showMenuItems = this.showMenuItems;
            VIEWUI.properties.showCustomPropertyTab(snapGrid);
            CORE.view3D.moveControl.updateTextBox(null);
            CORE.setShowCheckboxesPanel(false);
            VIEW3D.AxisHelper.getContainer().hide();
            CORE.view3D.cameraControl.rotationEnabled = false;
        }

        this.changeMode = function() {
            VIEWUI.toolbar.switchMode(MODE.EDIT);
            this.handleCustomSnapAction();
        };
        this.moveConstruction = function() {
            VIEWUI.toolbar.switchMode(MODE.MOVE_CONSTRUCTION);
            CORE.model.selectAll();
            this.handleCustomSnapAction();
        };
        this.selectPipePlane = function() {
            Extension.isPipePlaneToolActive(!Extension.isPipePlaneToolActive());
            // Extension.activatePipePlaneTool();
        }
    },
    bindButtonsViewModel: function() {

        if (typeof this.TopBarViewModel === 'function')
            this.TopBarViewModel = new this.TopBarViewModel();

        ko.applyBindings(new this.ButtonsViewModel(), VIEWUI.toolbar.divs.toolbar.element[0]);
        ko.applyBindings(this.TopBarViewModel, VIEWUI.toolbar.divs.topBar.element[0]);
    },
    switchMode: function(newMode) {
        CORE.mode(newMode);
        VIEWUI.toolbar.updateStyles();
    },
    updateStyles: function() {
        switch (CORE.mode()) {
            case MODE.SELECT:
                canvas.style.cursor = 'default';
                break;
            case MODE.DRAW_NODE:
                canvas.style.cursor = 'crosshair';
                break;
            case MODE.DRAW_BAR:
                canvas.style.cursor = 'default';
                break;
            default:
                canvas.style.cursor = 'default';
                break;
        }
    }
}