﻿var VIEWUI = VIEWUI || {};

VIEWUI.viewTree = {
    divContainerId: "VIEWUI_viewTreeContainer",
    divContainerElement: "not initialized", // divObjectList element
    divTreeId: "VIEWUI_viewTree",
    divTreeElement: "not initialized", // divObjectListTree element
    objectIdPrefix: "object_",
    tree: "not initialized",
    init: function() {
        this.divContainerElement = document.getElementById(this.divContainerId);
        this.divTreeElement = document.getElementById(this.divTreeId);
        if (this.divTreeElement === null) {
            throw 'VIEWUI.viewTree.init: Element ' + this.divTreeId + ' does not exist!';
        }
        VIEWUI.viewTree.initTree();
    },
    onClickSelectCallback: function(item) {
        if(CORE.mode() !== MODE.SELECT) VIEWUI.toolbar.switchMode(MODE.SELECT);
        if (CORE.mode() === MODE.DRAW_NODE || CORE.mode() === MODE.DRAW_BAR) {
            VIEWUI.toolbar.switchMode(MODE.SELECT);
            VIEWUI.viewModel.popupMode(null);
        }
        if (!HELPERS.inputState.selectMultiple) {
            CORE.model.deselectAll();
        }
        if (!item.selected() || !HELPERS.inputState.selectMultiple) {
            item.selected(true);
        } else {
            item.selected(false);
        }
    },
    ViewModel: new (function() {
        var self = this;
        this.browserHideTimeout = null;
        this.browserShowTimeout = null;
        this.browserAnimationDuration = 300;
        this.browserHideAfter = 500;
        this.browserShowAfter = 600;
        this.browserVisible = false;
        var animateShow = function (element, duration) {
            element.fadeIn(duration);
        }
        var animateShowWindow = function(element, duration) {
            var height = $("#VIEWUI_viewTree").height();
            $(element).css('pointer-events', 'auto');
            $(element).css('box-shadow', '');
            //$(element).css('border', '');
            element
                .animate({ opacity: 1, width: '200px', height: height + 24}, duration, 'swing',    // 22 (top bar) + 2 (borders)
                function () {
                    $(this).height('auto');
                }); 
        }
        var animateHideWindow = function(element, duration) {
            $(element).css('pointer-events', 'none');
            $(element).css('box-shadow', 'none');
            //$(element).css('border', 'none');
            $(element).css('width', '198px');
            setTimeout(function () {                // box-shadow and border bug workaround
                element.animate({ opacity: 0, width: '0px', height: '0px' }, duration);
            }, 10);
        }
        var animateHide = function (element, duration) {
            element.fadeOut(duration);
        }
        this.browserHoverButtonClicked = function() {
            if (this.browserShowTimeout !== null) {
                clearTimeout(this.browserShowTimeout);
            }
            animateHide($("#VIEWUI_viewTreeHoverButton:visible"), this.browserAnimationDuration);
            animateShowWindow($("#VIEWUI_viewTreeWindow"), this.browserAnimationDuration);
        }
        this.browserHoverButtonMouseOver = function() {
            if (this.browserHideTimeout !== null) {
                clearTimeout(this.browserHideTimeout);
            }
            this.browserShowTimeout = setTimeout(function() {
                    if (!self.browserVisible) {
                        animateHide($("#VIEWUI_viewTreeHoverButton:visible"), self.browserAnimationDuration);
                        animateShowWindow($("#VIEWUI_viewTreeWindow"), self.browserAnimationDuration);
                        self.browserVisible = true;
                    }
                },
                this.browserShowAfter);
        }
        this.browserWindowMouseOver = function() {
            if (this.browserHideTimeout !== null) {
                clearTimeout(this.browserHideTimeout);
            }
        }
        this.browserMouseOut = function() {
            if (this.browserShowTimeout !== null) {
                clearTimeout(this.browserShowTimeout);
            }
            this.browserHideTimeout = setTimeout(function() {
                    animateShow($("#VIEWUI_viewTreeHoverButton"), self.browserAnimationDuration);
                    animateHideWindow($("#VIEWUI_viewTreeWindow:visible"), self.browserAnimationDuration);
                    self.browserVisible = false;
                },
                this.browserHideAfter);
        }
    })(),
    initTree: function() {
        /*ko.bindingHandlers.tooltip = {    //uncomment for nice tooltip support
            init: function (element, valueAccessor) {
                var local = ko.utils.unwrapObservable(valueAccessor()),
                    options = {};
                ko.utils.extend(options, local);
                $(element).tooltip(options);
                ko.utils.domNodeDisposal.addDisposeCallback(element, function () {
                    $(element).tooltip("destroy");
                });
            }
        };
            var PageModel = function () {
            var self = this;
            self.treeData = ko.observable();
            self.loadData = function (data) {
                self.treeData(data);
            };
        }
        pageModel = new PageModel();
        pageModel.loadData(VIEWUI.viewTree.getViewModel());*/
        ko.cleanNode(VIEWUI.viewTree.divTreeElement);
        ko.applyBindings(CORE.model, VIEWUI.viewTree.divTreeElement);
        ko.applyBindings(this.ViewModel, VIEWUI.viewTree.divContainerElement);
    }
}