﻿(function () {
    'use strict';
    var helpers = {
        createNode(id) {
            return new MODEL.Node(new MODEL.types.Vector(0, 0, 0));
            return n;
        },
        // creates 2 noes and bar between them
        addBar(bars, n1, n2, id) {
            var bar = new MODEL.Bar(n1, n2);
            bar.id = id;
            bars.push(bar);
            return bar;
        }
    }
    describe('MODEL.NodeBarsRelation', function () {
        describe('onAddBar', function () {
            it('will create link in both nodes', function () {
                var bars = ko.observableArray();
                var nodeBarsRelation = new MODEL.NodeBarsRelation(bars);
                var node1 = helpers.createNode(1);
                var node2 = helpers.createNode(2);

                helpers.addBar(bars, node1, node2, 1001);

                expect(node1.createsBars().length).toBe(1);
                expect(node2.createsBars().length).toBe(1);
            });
        });
        describe('onAddBar', function () {
            it('will remove link in both nodes', function () {
                var bars = ko.observableArray();
                var node1 = helpers.createNode(1);
                var node2 = helpers.createNode(2);
                helpers.addBar(bars, node1, node2, 1001);

                var nodeBarsRelation = new MODEL.NodeBarsRelation(bars);
                bars.pop();

                expect(node1.createsBars().length).toBe(0);
                expect(node2.createsBars().length).toBe(0);
            });
        });
        describe('onNodeChange', function () {
            it('will reconnect', function () {
                var bars = ko.observableArray();
                var node1 = helpers.createNode(1);
                var node2 = helpers.createNode(2);
                var node3 = helpers.createNode(2);
                var bar = helpers.addBar(bars, node1, node2, 1001);

                var nodeBarsRelation = new MODEL.NodeBarsRelation(bars);
                bar.node1(node3);

                expect(node1.createsBars().length).toBe(0);
                expect(node3.createsBars().length).toBe(1);
            });
        });
    });
})();
